﻿<%@ Page Language="C#" ValidateRequest="false" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<script runat="server">

    protected Boolean MakeRESTRequest(String RequestURL, String RequestMethod, System.Collections.Generic.Dictionary<String, String> ExtraRequestHeaders, String SendData, int RetryTimes, ref int ErrorNumber, ref String ErrorDescription, ref String LogData, ref System.Collections.Generic.Dictionary<String, String> RequestHeaders, ref int ResponseStatusCode, ref String ResponseStatusDescription, ref System.Collections.Generic.Dictionary<String, String> ResponseHeaders, ref String ResponseStringFormatted)
    {
        SprightlySoftAWS.REST MyREST = new SprightlySoftAWS.REST();
        Boolean RetBool = true;
        LogData = "";

        for (int i = 0; i == RetryTimes; i++)
        {
            RetBool = MyREST.MakeRequest(RequestURL, RequestMethod, ExtraRequestHeaders, SendData);

            //Set the return values.
            ErrorNumber = MyREST.ErrorNumber;
            ErrorDescription = MyREST.ErrorDescription;
            LogData += MyREST.LogData;
            RequestHeaders = MyREST.RequestHeaders;
            ResponseStatusCode = MyREST.ResponseStatusCode;
            ResponseStatusDescription = MyREST.ResponseStatusDescription;
            ResponseHeaders = MyREST.ResponseHeaders;
            ResponseStringFormatted = MyREST.ResponseStringFormatted;

            if (RetBool == true)
            {
                break;
            }
            else
            {
                if (MyREST.ResponseStatusCode == 503)
                {
                    //A Service Unavailable response was returned.  Wait and retry.
                    System.Threading.Thread.Sleep(1000 * i * i);
                }
                else if (MyREST.ResponseStatusCode == 0 && MyREST.ErrorNumber == 1003)
                {
                    //Getting the response failed.  This may be a network disconnection.  Wait and retry.
                    System.Threading.Thread.Sleep(1000 * i * i);
                }
                else
                {
                    //An error occured but retrying would not solve the problem.
                    break;
                }
            }
        }

        return RetBool;
    }

    protected String AddQueryStringParameterToURL(String RequestURL, String ParameterName, String ParameterValue)
    {
        if (RequestURL.Contains("?") == true)
        {
            RequestURL += "&" + ParameterName + "=" + System.Uri.EscapeDataString(ParameterValue);
        }
        else
        {
            RequestURL += "?" + ParameterName + "=" + System.Uri.EscapeDataString(ParameterValue);
        }

        return RequestURL;
    }

    protected void ButtonGETListHostedZones_Click(object sender, EventArgs e)
    {
        int ErrorNumber = 0;
        String ErrorDescription = "";
        String LogData = "";
        System.Collections.Generic.Dictionary<String, String> RequestHeaders = new System.Collections.Generic.Dictionary<String, String>();
        int ResponseStatusCode = 0;
        String ResponseStatusDescription = "";
        System.Collections.Generic.Dictionary<String, String> ResponseHeaders = new System.Collections.Generic.Dictionary<String, String>();
        String ResponseStringFormatted = "";
        SprightlySoftAWS.REST MyREST = new SprightlySoftAWS.REST();

        String RequestURL;
        RequestURL = "https://route53.amazonaws.com/2010-10-01/hostedzone";
        if (TextBoxGETListHostedZonesMarker.Text != "")
        {
            RequestURL = AddQueryStringParameterToURL(RequestURL, "marker", TextBoxGETListHostedZonesMarker.Text);
        }
        if (TextBoxGETListHostedZonesMaxItems.Text != "")
        {
            RequestURL = AddQueryStringParameterToURL(RequestURL, "maxitems", TextBoxGETListHostedZonesMaxItems.Text);
        }

        String RequestMethod;
        RequestMethod = "GET";

        String SendData = "";

        //Create the date that will be used for the x-amz-date hreader and X-Amzn-Authorization signature value.
        String MyDate;
        MyDate = DateTime.UtcNow.ToString("r");

        //Add the date header.
        System.Collections.Generic.Dictionary<String, String> ExtraRequestHeaders = new System.Collections.Generic.Dictionary<String, String>();
        ExtraRequestHeaders.Add("x-amz-date", MyDate);

        String AuthorizationValue;
        AuthorizationValue = MyREST.GetAWS3AuthorizationValue(TextBoxAWSAccessKeyId.Text, TextBoxAWSSecretAccessKey.Text, MyDate);

        //Add the authorization header.
        ExtraRequestHeaders.Add("X-Amzn-Authorization", AuthorizationValue);

        Boolean RetBool;
        RetBool = MakeRESTRequest(RequestURL, RequestMethod, ExtraRequestHeaders, SendData, 0, ref ErrorNumber, ref ErrorDescription, ref LogData, ref RequestHeaders, ref ResponseStatusCode, ref ResponseStatusDescription, ref ResponseHeaders, ref ResponseStringFormatted);

        String ResponseText = "";

        if (RetBool == true)
        {
            ResponseText = "Success." + Environment.NewLine;
        }
        else
        {
            ResponseText = "Failure." + Environment.NewLine;
        }

        ResponseText += Environment.NewLine;

        ResponseText += "Request:" + Environment.NewLine;
        ResponseText += "   " + RequestMethod + " " + RequestURL + Environment.NewLine;
        foreach (System.Collections.Generic.KeyValuePair<String, String> MyHeader in RequestHeaders)
        {
            ResponseText += "   " + (MyHeader.Key + ": " + MyHeader.Value + Environment.NewLine);
        }

        ResponseText += Environment.NewLine;

        ResponseText += "Response:" + Environment.NewLine;
        ResponseText += "   " + "HTTP/1.1 " + ResponseStatusCode.ToString() + " " + ResponseStatusDescription + Environment.NewLine;

        foreach (System.Collections.Generic.KeyValuePair<String, String> MyHeader in ResponseHeaders)
        {
            ResponseText += "   " + (MyHeader.Key + ": " + MyHeader.Value + Environment.NewLine);
        }

        ResponseText += Environment.NewLine;
        ResponseText += ResponseStringFormatted + Environment.NewLine;

        TextBoxGETListHostedZonesResponse.Text = ResponseText;

        TextBoxGETListHostedZonesResponse.Focus();
    }

    protected void ButtonPOSTCreateHostedZone_Click(object sender, EventArgs e)
    {
        int ErrorNumber = 0;
        String ErrorDescription = "";
        String LogData = "";
        System.Collections.Generic.Dictionary<String, String> RequestHeaders = new System.Collections.Generic.Dictionary<String, String>();
        int ResponseStatusCode = 0;
        String ResponseStatusDescription = "";
        System.Collections.Generic.Dictionary<String, String> ResponseHeaders = new System.Collections.Generic.Dictionary<String, String>();
        String ResponseStringFormatted = "";
        SprightlySoftAWS.REST MyREST = new SprightlySoftAWS.REST();

        String RequestURL;
        RequestURL = "https://route53.amazonaws.com/2010-10-01/hostedzone";

        String RequestMethod;
        RequestMethod = "POST";

        String SendData = "";
        SendData += "<?xml version=\"1.0\" encoding=\"UTF-8\"?>" + Environment.NewLine;
        SendData += "<CreateHostedZoneRequest xmlns=\"https://route53.amazonaws.com/doc/2010-10-01/\">" + Environment.NewLine;
        SendData += "   <Name>" + TextBoxPOSTCreateHostedZoneName.Text + "</Name>" + Environment.NewLine;
        SendData += "   <CallerReference>" + TextBoxPOSTCreateHostedZoneCallerReference.Text + "</CallerReference>" + Environment.NewLine;
        SendData += "   <HostedZoneConfig>" + Environment.NewLine;
        SendData += "      <Comment>" + TextBoxPOSTCreateHostedZoneHostedZoneComment.Text + "</Comment>" + Environment.NewLine;
        SendData += "   </HostedZoneConfig>" + Environment.NewLine;
        SendData += "</CreateHostedZoneRequest>" + Environment.NewLine;

        String MyDate;
        MyDate = DateTime.UtcNow.ToString("r");

        System.Collections.Generic.Dictionary<String, String> ExtraRequestHeaders = new System.Collections.Generic.Dictionary<String, String>();
        ExtraRequestHeaders.Add("x-amz-date", MyDate);

        String AuthorizationValue;
        AuthorizationValue = MyREST.GetAWS3AuthorizationValue(TextBoxAWSAccessKeyId.Text, TextBoxAWSSecretAccessKey.Text, MyDate);

        ExtraRequestHeaders.Add("X-Amzn-Authorization", AuthorizationValue);

        Boolean RetBool;
        RetBool = MakeRESTRequest(RequestURL, RequestMethod, ExtraRequestHeaders, SendData, 0, ref ErrorNumber, ref ErrorDescription, ref LogData, ref RequestHeaders, ref ResponseStatusCode, ref ResponseStatusDescription, ref ResponseHeaders, ref ResponseStringFormatted);

        String ResponseText = "";

        if (RetBool == true)
        {
            ResponseText = "Success." + Environment.NewLine;
        }
        else
        {
            ResponseText = "Failure." + Environment.NewLine;
        }

        ResponseText += Environment.NewLine;

        ResponseText += "Request:" + Environment.NewLine;
        ResponseText += "   " + RequestMethod + " " + RequestURL + Environment.NewLine;
        foreach (System.Collections.Generic.KeyValuePair<String, String> MyHeader in RequestHeaders)
        {
            ResponseText += "   " + (MyHeader.Key + ": " + MyHeader.Value + Environment.NewLine);
        }

        ResponseText += Environment.NewLine;

        ResponseText += SendData + Environment.NewLine;
        ResponseText += Environment.NewLine;

        ResponseText += "Response:" + Environment.NewLine;
        ResponseText += "   " + "HTTP/1.1 " + ResponseStatusCode.ToString() + " " + ResponseStatusDescription + Environment.NewLine;

        foreach (System.Collections.Generic.KeyValuePair<String, String> MyHeader in ResponseHeaders)
        {
            ResponseText += "   " + (MyHeader.Key + ": " + MyHeader.Value + Environment.NewLine);
        }

        ResponseText += Environment.NewLine;
        ResponseText += ResponseStringFormatted + Environment.NewLine;

        TextBoxPOSTCreateHostedZoneResponse.Text = ResponseText;

        TextBoxPOSTCreateHostedZoneResponse.Focus();
    }

    protected void ButtonGETGetHostedZone_Click(object sender, EventArgs e)
    {
        int ErrorNumber = 0;
        String ErrorDescription = "";
        String LogData = "";
        System.Collections.Generic.Dictionary<String, String> RequestHeaders = new System.Collections.Generic.Dictionary<String, String>();
        int ResponseStatusCode = 0;
        String ResponseStatusDescription = "";
        System.Collections.Generic.Dictionary<String, String> ResponseHeaders = new System.Collections.Generic.Dictionary<String, String>();
        String ResponseStringFormatted = "";
        SprightlySoftAWS.REST MyREST = new SprightlySoftAWS.REST();

        String RequestURL;
        RequestURL = "https://route53.amazonaws.com/2010-10-01/hostedzone/" + TextBoxGETGetHostedZoneHostedZoneId.Text;

        String RequestMethod;
        RequestMethod = "GET";

        String SendData = "";

        String MyDate;
        MyDate = DateTime.UtcNow.ToString("r");

        System.Collections.Generic.Dictionary<String, String> ExtraRequestHeaders = new System.Collections.Generic.Dictionary<String, String>();
        ExtraRequestHeaders.Add("x-amz-date", MyDate);

        String AuthorizationValue;
        AuthorizationValue = MyREST.GetAWS3AuthorizationValue(TextBoxAWSAccessKeyId.Text, TextBoxAWSSecretAccessKey.Text, MyDate);

        ExtraRequestHeaders.Add("X-Amzn-Authorization", AuthorizationValue);

        Boolean RetBool;
        RetBool = MakeRESTRequest(RequestURL, RequestMethod, ExtraRequestHeaders, SendData, 0, ref ErrorNumber, ref ErrorDescription, ref LogData, ref RequestHeaders, ref ResponseStatusCode, ref ResponseStatusDescription, ref ResponseHeaders, ref ResponseStringFormatted);

        String ResponseText = "";

        if (RetBool == true)
        {
            ResponseText = "Success." + Environment.NewLine;
        }
        else
        {
            ResponseText = "Failure." + Environment.NewLine;
        }

        ResponseText += Environment.NewLine;

        ResponseText += "Request:" + Environment.NewLine;
        ResponseText += "   " + RequestMethod + " " + RequestURL + Environment.NewLine;
        foreach (System.Collections.Generic.KeyValuePair<String, String> MyHeader in RequestHeaders)
        {
            ResponseText += "   " + (MyHeader.Key + ": " + MyHeader.Value + Environment.NewLine);
        }

        ResponseText += Environment.NewLine;

        ResponseText += "Response:" + Environment.NewLine;
        ResponseText += "   " + "HTTP/1.1 " + ResponseStatusCode.ToString() + " " + ResponseStatusDescription + Environment.NewLine;

        foreach (System.Collections.Generic.KeyValuePair<String, String> MyHeader in ResponseHeaders)
        {
            ResponseText += "   " + (MyHeader.Key + ": " + MyHeader.Value + Environment.NewLine);
        }

        ResponseText += Environment.NewLine;
        ResponseText += ResponseStringFormatted + Environment.NewLine;

        TextBoxGETGetHostedZoneResponse.Text = ResponseText;

        TextBoxGETGetHostedZoneResponse.Focus();
    }

    protected void ButtonDELETEDeleteHostedZone_Click(object sender, EventArgs e)
    {
        int ErrorNumber = 0;
        String ErrorDescription = "";
        String LogData = "";
        System.Collections.Generic.Dictionary<String, String> RequestHeaders = new System.Collections.Generic.Dictionary<String, String>();
        int ResponseStatusCode = 0;
        String ResponseStatusDescription = "";
        System.Collections.Generic.Dictionary<String, String> ResponseHeaders = new System.Collections.Generic.Dictionary<String, String>();
        String ResponseStringFormatted = "";
        SprightlySoftAWS.REST MyREST = new SprightlySoftAWS.REST();

        String RequestURL;
        RequestURL = "https://route53.amazonaws.com/2010-10-01/hostedzone/" + TextBoxDELETEDeleteHostedZoneHostedZoneId.Text;

        String RequestMethod;
        RequestMethod = "DELETE";

        String SendData = "";

        String MyDate;
        MyDate = DateTime.UtcNow.ToString("r");

        System.Collections.Generic.Dictionary<String, String> ExtraRequestHeaders = new System.Collections.Generic.Dictionary<String, String>();
        ExtraRequestHeaders.Add("x-amz-date", MyDate);

        String AuthorizationValue;
        AuthorizationValue = MyREST.GetAWS3AuthorizationValue(TextBoxAWSAccessKeyId.Text, TextBoxAWSSecretAccessKey.Text, MyDate);

        ExtraRequestHeaders.Add("X-Amzn-Authorization", AuthorizationValue);

        Boolean RetBool;
        RetBool = MakeRESTRequest(RequestURL, RequestMethod, ExtraRequestHeaders, SendData, 0, ref ErrorNumber, ref ErrorDescription, ref LogData, ref RequestHeaders, ref ResponseStatusCode, ref ResponseStatusDescription, ref ResponseHeaders, ref ResponseStringFormatted);

        String ResponseText = "";

        if (RetBool == true)
        {
            ResponseText = "Success." + Environment.NewLine;
        }
        else
        {
            ResponseText = "Failure." + Environment.NewLine;
        }

        ResponseText += Environment.NewLine;

        ResponseText += "Request:" + Environment.NewLine;
        ResponseText += "   " + RequestMethod + " " + RequestURL + Environment.NewLine;
        foreach (System.Collections.Generic.KeyValuePair<String, String> MyHeader in RequestHeaders)
        {
            ResponseText += "   " + (MyHeader.Key + ": " + MyHeader.Value + Environment.NewLine);
        }

        ResponseText += Environment.NewLine;

        ResponseText += "Response:" + Environment.NewLine;
        ResponseText += "   " + "HTTP/1.1 " + ResponseStatusCode.ToString() + " " + ResponseStatusDescription + Environment.NewLine;

        foreach (System.Collections.Generic.KeyValuePair<String, String> MyHeader in ResponseHeaders)
        {
            ResponseText += "   " + (MyHeader.Key + ": " + MyHeader.Value + Environment.NewLine);
        }

        ResponseText += Environment.NewLine;
        ResponseText += ResponseStringFormatted + Environment.NewLine;

        TextBoxDELETEDeleteHostedZoneResponse.Text = ResponseText;

        TextBoxDELETEDeleteHostedZoneResponse.Focus();
    }

    protected void ButtonGETListResourceRecordSets_Click(object sender, EventArgs e)
    {
        int ErrorNumber = 0;
        String ErrorDescription = "";
        String LogData = "";
        System.Collections.Generic.Dictionary<String, String> RequestHeaders = new System.Collections.Generic.Dictionary<String, String>();
        int ResponseStatusCode = 0;
        String ResponseStatusDescription = "";
        System.Collections.Generic.Dictionary<String, String> ResponseHeaders = new System.Collections.Generic.Dictionary<String, String>();
        String ResponseStringFormatted = "";
        SprightlySoftAWS.REST MyREST = new SprightlySoftAWS.REST();

        String RequestURL;
        RequestURL = "https://route53.amazonaws.com/2010-10-01/hostedzone/" + TextBoxGETListResourceRecordSetsHostedZoneId.Text + "/rrset";
        if (TextBoxGETListResourceRecordSetsType.Text != "")
        {
            RequestURL = AddQueryStringParameterToURL(RequestURL, "type", TextBoxGETListResourceRecordSetsType.Text);
        }
        if (TextBoxGETListResourceRecordSetsName.Text != "")
        {
            RequestURL = AddQueryStringParameterToURL(RequestURL, "name", TextBoxGETListResourceRecordSetsName.Text);
        }
        if (TextBoxGETListResourceRecordSetsMaxitems.Text != "")
        {
            RequestURL = AddQueryStringParameterToURL(RequestURL, "maxitems", TextBoxGETListResourceRecordSetsMaxitems.Text);
        }

        String RequestMethod;
        RequestMethod = "GET";

        String SendData = "";

        String MyDate;
        MyDate = DateTime.UtcNow.ToString("r");

        System.Collections.Generic.Dictionary<String, String> ExtraRequestHeaders = new System.Collections.Generic.Dictionary<String, String>();
        ExtraRequestHeaders.Add("x-amz-date", MyDate);

        String AuthorizationValue;
        AuthorizationValue = MyREST.GetAWS3AuthorizationValue(TextBoxAWSAccessKeyId.Text, TextBoxAWSSecretAccessKey.Text, MyDate);

        ExtraRequestHeaders.Add("X-Amzn-Authorization", AuthorizationValue);

        Boolean RetBool;
        RetBool = MakeRESTRequest(RequestURL, RequestMethod, ExtraRequestHeaders, SendData, 0, ref ErrorNumber, ref ErrorDescription, ref LogData, ref RequestHeaders, ref ResponseStatusCode, ref ResponseStatusDescription, ref ResponseHeaders, ref ResponseStringFormatted);

        String ResponseText = "";

        if (RetBool == true)
        {
            ResponseText = "Success." + Environment.NewLine;
        }
        else
        {
            ResponseText = "Failure." + Environment.NewLine;
        }

        ResponseText += Environment.NewLine;

        ResponseText += "Request:" + Environment.NewLine;
        ResponseText += "   " + RequestMethod + " " + RequestURL + Environment.NewLine;
        foreach (System.Collections.Generic.KeyValuePair<String, String> MyHeader in RequestHeaders)
        {
            ResponseText += "   " + (MyHeader.Key + ": " + MyHeader.Value + Environment.NewLine);
        }

        ResponseText += Environment.NewLine;

        ResponseText += "Response:" + Environment.NewLine;
        ResponseText += "   " + "HTTP/1.1 " + ResponseStatusCode.ToString() + " " + ResponseStatusDescription + Environment.NewLine;

        foreach (System.Collections.Generic.KeyValuePair<String, String> MyHeader in ResponseHeaders)
        {
            ResponseText += "   " + (MyHeader.Key + ": " + MyHeader.Value + Environment.NewLine);
        }

        ResponseText += Environment.NewLine;
        ResponseText += ResponseStringFormatted + Environment.NewLine;

        TextBoxGETListResourceRecordSetsResponse.Text = ResponseText;

        TextBoxGETListResourceRecordSetsResponse.Focus();
    }

    protected void ButtonPOSTChangeResourceRecordSets_Click(object sender, EventArgs e)
    {
        int ErrorNumber = 0;
        String ErrorDescription = "";
        String LogData = "";
        System.Collections.Generic.Dictionary<String, String> RequestHeaders = new System.Collections.Generic.Dictionary<String, String>();
        int ResponseStatusCode = 0;
        String ResponseStatusDescription = "";
        System.Collections.Generic.Dictionary<String, String> ResponseHeaders = new System.Collections.Generic.Dictionary<String, String>();
        String ResponseStringFormatted = "";
        SprightlySoftAWS.REST MyREST = new SprightlySoftAWS.REST();

        String RequestURL;
        RequestURL = "https://route53.amazonaws.com/2010-10-01/hostedzone/" + TextBoxPOSTChangeResourceRecordSetsHostedZoneId.Text + "/rrset";

        String RequestMethod;
        RequestMethod = "POST";

        String SendData = "";
        SendData += "<?xml version=\"1.0\" encoding=\"UTF-8\"?>" + Environment.NewLine;
        SendData += "<ChangeResourceRecordSetsRequest xmlns=\"https://route53.amazonaws.com/doc/2010-10-01/\">" + Environment.NewLine;
        SendData += "   <ChangeBatch>" + Environment.NewLine;
        SendData += "      <Changes>" + Environment.NewLine;
        SendData += "         <Change>" + Environment.NewLine;
        SendData += "            <Action>" + TextBoxPOSTChangeResourceRecordSetsAction.Text + "</Action>" + Environment.NewLine;
        SendData += "            <ResourceRecordSet>" + Environment.NewLine;
        SendData += "               <Name>" + TextBoxPOSTChangeResourceRecordSetsName.Text + "</Name>" + Environment.NewLine;
        SendData += "               <Type>" + TextBoxPOSTChangeResourceRecordSetsType.Text + "</Type>" + Environment.NewLine;
        SendData += "               <TTL>" + TextBoxPOSTChangeResourceRecordSetsTTL.Text + "</TTL>" + Environment.NewLine;
        SendData += "               <ResourceRecords>" + Environment.NewLine;
        SendData += "                  <ResourceRecord>" + Environment.NewLine;
        SendData += "                     <Value>" + TextBoxPOSTChangeResourceRecordSetsResourceRecordValue.Text + "</Value>" + Environment.NewLine;
        SendData += "                  </ResourceRecord>" + Environment.NewLine;
        SendData += "               </ResourceRecords>" + Environment.NewLine;
        SendData += "            </ResourceRecordSet>" + Environment.NewLine;
        SendData += "         </Change>" + Environment.NewLine;
        SendData += "      </Changes>" + Environment.NewLine;
        SendData += "   </ChangeBatch>" + Environment.NewLine;
        SendData += "</ChangeResourceRecordSetsRequest>" + Environment.NewLine;

        String MyDate;
        MyDate = DateTime.UtcNow.ToString("r");

        System.Collections.Generic.Dictionary<String, String> ExtraRequestHeaders = new System.Collections.Generic.Dictionary<String, String>();
        ExtraRequestHeaders.Add("x-amz-date", MyDate);

        String AuthorizationValue;
        AuthorizationValue = MyREST.GetAWS3AuthorizationValue(TextBoxAWSAccessKeyId.Text, TextBoxAWSSecretAccessKey.Text, MyDate);

        ExtraRequestHeaders.Add("X-Amzn-Authorization", AuthorizationValue);

        Boolean RetBool;
        RetBool = MakeRESTRequest(RequestURL, RequestMethod, ExtraRequestHeaders, SendData, 0, ref ErrorNumber, ref ErrorDescription, ref LogData, ref RequestHeaders, ref ResponseStatusCode, ref ResponseStatusDescription, ref ResponseHeaders, ref ResponseStringFormatted);

        String ResponseText = "";

        if (RetBool == true)
        {
            ResponseText = "Success." + Environment.NewLine;
        }
        else
        {
            ResponseText = "Failure." + Environment.NewLine;
        }

        ResponseText += Environment.NewLine;

        ResponseText += "Request:" + Environment.NewLine;
        ResponseText += "   " + RequestMethod + " " + RequestURL + Environment.NewLine;
        foreach (System.Collections.Generic.KeyValuePair<String, String> MyHeader in RequestHeaders)
        {
            ResponseText += "   " + (MyHeader.Key + ": " + MyHeader.Value + Environment.NewLine);
        }

        ResponseText += Environment.NewLine;

        ResponseText += SendData + Environment.NewLine;
        ResponseText += Environment.NewLine;

        ResponseText += "Response:" + Environment.NewLine;
        ResponseText += "   " + "HTTP/1.1 " + ResponseStatusCode.ToString() + " " + ResponseStatusDescription + Environment.NewLine;

        foreach (System.Collections.Generic.KeyValuePair<String, String> MyHeader in ResponseHeaders)
        {
            ResponseText += "   " + (MyHeader.Key + ": " + MyHeader.Value + Environment.NewLine);
        }

        ResponseText += Environment.NewLine;
        ResponseText += ResponseStringFormatted + Environment.NewLine;

        TextBoxPOSTChangeResourceRecordSetsResponse.Text = ResponseText;

        TextBoxPOSTChangeResourceRecordSetsResponse.Focus();
    }

    protected void ButtonGETGetChange_Click(object sender, EventArgs e)
    {
        int ErrorNumber = 0;
        String ErrorDescription = "";
        String LogData = "";
        System.Collections.Generic.Dictionary<String, String> RequestHeaders = new System.Collections.Generic.Dictionary<String, String>();
        int ResponseStatusCode = 0;
        String ResponseStatusDescription = "";
        System.Collections.Generic.Dictionary<String, String> ResponseHeaders = new System.Collections.Generic.Dictionary<String, String>();
        String ResponseStringFormatted = "";
        SprightlySoftAWS.REST MyREST = new SprightlySoftAWS.REST();

        String RequestURL;
        RequestURL = "https://route53.amazonaws.com/2010-10-01/change/" + TextBoxGETGetChangeHostedChangeId.Text;

        String RequestMethod;
        RequestMethod = "GET";

        String SendData = "";

        String MyDate;
        MyDate = DateTime.UtcNow.ToString("r");

        System.Collections.Generic.Dictionary<String, String> ExtraRequestHeaders = new System.Collections.Generic.Dictionary<String, String>();
        ExtraRequestHeaders.Add("x-amz-date", MyDate);

        String AuthorizationValue;
        AuthorizationValue = MyREST.GetAWS3AuthorizationValue(TextBoxAWSAccessKeyId.Text, TextBoxAWSSecretAccessKey.Text, MyDate);

        ExtraRequestHeaders.Add("X-Amzn-Authorization", AuthorizationValue);

        Boolean RetBool;
        RetBool = MakeRESTRequest(RequestURL, RequestMethod, ExtraRequestHeaders, SendData, 0, ref ErrorNumber, ref ErrorDescription, ref LogData, ref RequestHeaders, ref ResponseStatusCode, ref ResponseStatusDescription, ref ResponseHeaders, ref ResponseStringFormatted);

        String ResponseText = "";

        if (RetBool == true)
        {
            ResponseText = "Success." + Environment.NewLine;
        }
        else
        {
            ResponseText = "Failure." + Environment.NewLine;
        }

        ResponseText += Environment.NewLine;

        ResponseText += "Request:" + Environment.NewLine;
        ResponseText += "   " + RequestMethod + " " + RequestURL + Environment.NewLine;
        foreach (System.Collections.Generic.KeyValuePair<String, String> MyHeader in RequestHeaders)
        {
            ResponseText += "   " + (MyHeader.Key + ": " + MyHeader.Value + Environment.NewLine);
        }

        ResponseText += Environment.NewLine;

        ResponseText += "Response:" + Environment.NewLine;
        ResponseText += "   " + "HTTP/1.1 " + ResponseStatusCode.ToString() + " " + ResponseStatusDescription + Environment.NewLine;

        foreach (System.Collections.Generic.KeyValuePair<String, String> MyHeader in ResponseHeaders)
        {
            ResponseText += "   " + (MyHeader.Key + ": " + MyHeader.Value + Environment.NewLine);
        }

        ResponseText += Environment.NewLine;
        ResponseText += ResponseStringFormatted + Environment.NewLine;

        TextBoxGETGetChangeResponse.Text = ResponseText;

        TextBoxGETGetChangeResponse.Focus();
    }
</script>

<html xmlns="http://www.w3.org/1999/xhtml">
<head id="Head1" runat="server">
    <title>Amazon Route 53</title>
    <style type="text/css">
        body, td, th
        {
            font-family: MS Sans Serif, Arial, Helvetica;
            font-size: small;
        }
        h1
        {
            font-size: x-large;
        }
        h2
        {
            font-size: large;
        }
        h3
        {
            font-size: medium;
        }
        .responsetextbox
        {
            width: 700px;
            height: 300px;
        }
        .parameterlabel
        {
            font-weight: bold; 
        }
    </style>
</head>
<body>
    <form id="form1" runat="server">
    <div style="text-align: center;">
        <h1>
            Amazon Route 53 All Actions<br />
        </h1>
    </div>
    <p>
        Amazon Route 53 is a scalable Domain Name System (DNS) web service. It provides
        secure and reliable routing to your infrastructure that uses Amazon Web Services
        (AWS) products, such as Amazon Elastic Compute Cloud (Amazon EC2), Elastic Load
        Balancing, or Amazon Simple Storage Service (Amazon S3). You can also use Amazon
        Route 53 to route users to your infrastructure outside of AWS.</p>
    <p>
        For more information see <a href="http://docs.amazonwebservices.com/Route53/latest/DeveloperGuide/"
            target="_blank">Amazon Route 53 Developer Guide</a>.</p>
    <p>
        The following application allows you to interact with the Amazon Route 53 API.&nbsp;
        The source code for this application is included&nbsp; with the free <a href="http://sprightlysoft.com/AWSComponent/Download.aspx"
            target="_blank">AWS Component for .NET</a>.</p>
    <div>
        <br />
        Enter you Amazon AWS credentials below.<br />
    </div>
    <table cellpadding="0" cellspacing="0">
        <tr>
            <td nowrap="nowrap" class="parameterlabel">
                Amazon AWSAccessKeyId
            </td>
            <td>
                &nbsp;</td>
            <td>
                <asp:TextBox ID="TextBoxAWSAccessKeyId" runat="server" Width="330px"></asp:TextBox>
            </td>
        </tr>
        <tr>
            <td nowrap="nowrap" class="parameterlabel">
                Amazon AWSSecretAccessKey
            </td>
            <td>
                &nbsp;</td>
            <td>
                <asp:TextBox ID="TextBoxAWSSecretAccessKey" runat="server" Width="330px"></asp:TextBox>
            </td>
        </tr>
    </table>
    <br />
    <br />
    <h2>
        Actions on Hosted Zones</h2>
    <blockquote>
        <h3>
            GET ListHostedZones</h3>
        <blockquote>
            This function lists your Amazon Route 53 hosted zones.<br />
            Documentation: <a href="http://docs.amazonwebservices.com/Route53/latest/APIReference/API_ListHostedZones.html"
                target="_blank">http://docs.amazonwebservices.com/Route53/latest/APIReference/API_ListHostedZones.html</a><br />
            <br />
            Parameters:
            <table>
                <tr>
                    <td class="parameterlabel">
                        Marker
                    </td>
                    <td>
                        &nbsp;</td>
                    <td>
                        <asp:TextBox ID="TextBoxGETListHostedZonesMarker" runat="server" Width="170px"></asp:TextBox>
                    </td>
                </tr>
                <tr>
                    <td class="parameterlabel">
                        MaxItems
                    </td>
                    <td>
                        &nbsp;</td>
                    <td>
                        <asp:TextBox ID="TextBoxGETListHostedZonesMaxItems" runat="server" Width="170px"></asp:TextBox>
                    </td>
                </tr>
            </table>
            <br />
            <asp:Button ID="ButtonGETListHostedZones" runat="server" Text="GET ListHostedZones"
                OnClick="ButtonGETListHostedZones_Click" />
            <br />
            <br />
            Responses:<br />
            <asp:TextBox ID="TextBoxGETListHostedZonesResponse" runat="server" class="responsetextbox"
                TextMode="MultiLine" Wrap="False"></asp:TextBox>
        </blockquote>
        <p>
            &nbsp;</p>
        <h3>
            POST CreateHostedZone</h3>
        <blockquote>
            Creates a new hosted zone.<br />
            Documentation: <a href="http://docs.amazonwebservices.com/Route53/latest/APIReference/API_CreateHostedZone.html"
                target="_blank">http://docs.amazonwebservices.com/Route53/latest/APIReference/API_CreateHostedZone.html</a><br />
            <br />
            Parameters:<table>
                <tr>
                    <td class="parameterlabel">
                        Name
                    </td>
                    <td>
                        &nbsp;</td>
                    <td>
                        <asp:TextBox ID="TextBoxPOSTCreateHostedZoneName" runat="server" Width="170px"></asp:TextBox>
                    </td>
                </tr>
                <tr>
                    <td class="parameterlabel">
                        CallerReference
                    </td>
                    <td>
                        &nbsp;</td>
                    <td>
                        <asp:TextBox ID="TextBoxPOSTCreateHostedZoneCallerReference" runat="server" Width="170px"></asp:TextBox>
                    </td>
                </tr>
                <tr>
                    <td class="parameterlabel">
                        Comment
                    </td>
                    <td>
                        &nbsp;</td>
                    <td>
                        <asp:TextBox ID="TextBoxPOSTCreateHostedZoneHostedZoneComment" runat="server" Width="170px"></asp:TextBox>
                    </td>
                </tr>
            </table>
            <br />
            <asp:Button ID="ButtonPOSTCreateHostedZone" runat="server" Text="POST CreateHostedZone"
                OnClick="ButtonPOSTCreateHostedZone_Click" />
            <br />
            <br />
            Responses:<br />
            <asp:TextBox ID="TextBoxPOSTCreateHostedZoneResponse" runat="server" class="responsetextbox"
                TextMode="MultiLine" Wrap="False"></asp:TextBox>
        </blockquote>
        <p>
            &nbsp;</p>
        <h3>
            GET GetHostedZone</h3>
        <blockquote>
            Retrieves information about a hosted zone.<br />
            Documentation: <a href="http://docs.amazonwebservices.com/Route53/latest/APIReference/API_GetHostedZone.html"
                target="_blank">http://docs.amazonwebservices.com/Route53/latest/APIReference/API_GetHostedZone.html</a><br />
            <br />
            Parameters:<table>
                <tr>
                    <td class="parameterlabel">
                        HostedZoneId
                    </td>
                    <td>
                        &nbsp;</td>
                    <td>
                        <asp:TextBox ID="TextBoxGETGetHostedZoneHostedZoneId" runat="server" Width="170px"></asp:TextBox>
                    </td>
                </tr>
            </table>
            <br />
            <asp:Button ID="ButtonGETGetHostedZone" runat="server" Text="GET GetHostedZone" OnClick="ButtonGETGetHostedZone_Click" />
            <br />
            <br />
            Responses:<br />
            <asp:TextBox ID="TextBoxGETGetHostedZoneResponse" runat="server" class="responsetextbox" TextMode="MultiLine"
                Wrap="False"></asp:TextBox>
        </blockquote>
        <p>
            &nbsp;</p>
        <h3>
            DELETE DeleteHostedZone</h3>
        <blockquote>
            Deletes a hosted zone.<br />
            Documentation: <a href="http://docs.amazonwebservices.com/Route53/latest/APIReference/API_DeleteHostedZone.html"
                target="_blank">http://docs.amazonwebservices.com/Route53/latest/APIReference/API_DeleteHostedZone.html</a><br />
            <br />
            Parameters:<table>
                <tr>
                    <td class="parameterlabel">
                        HostedZoneId
                    </td>
                    <td>
                        &nbsp;</td>
                    <td>
                        <asp:TextBox ID="TextBoxDELETEDeleteHostedZoneHostedZoneId" runat="server" Width="170px"></asp:TextBox>
                    </td>
                </tr>
            </table>
            <br />
            <asp:Button ID="Button1" runat="server" Text="DELETE DeleteHostedZone" OnClick="ButtonDELETEDeleteHostedZone_Click" />
            <br />
            <br />
            Responses:<br />
            <asp:TextBox ID="TextBoxDELETEDeleteHostedZoneResponse" runat="server" class="responsetextbox"
                TextMode="MultiLine" Wrap="False"></asp:TextBox>
        </blockquote>
    </blockquote>
    <br />
    <h2>
        Actions on Resource Records Sets</h2>
    <blockquote>
        <h3>
            GET ListResourceRecordSets</h3>
        <blockquote>
            Lists your resource record sets.<br />
            Documentation: <a href="http://docs.amazonwebservices.com/Route53/latest/APIReference/API_ListResourceRecordSets.html"
                target="_blank">http://docs.amazonwebservices.com/Route53/latest/APIReference/API_ListResourceRecordSets.html</a><br />
            <br />
            Parameters:<table>
                <tr>
                    <td class="parameterlabel">
                        HostedZoneId
                    </td>
                    <td>
                        &nbsp;</td>
                    <td>
                        <asp:TextBox ID="TextBoxGETListResourceRecordSetsHostedZoneId" runat="server" Width="170px"></asp:TextBox>
                    </td>
                </tr>
                <tr>
                    <td class="parameterlabel">
                        Type
                    </td>
                    <td>
                        &nbsp;</td>
                    <td>
                        <asp:TextBox ID="TextBoxGETListResourceRecordSetsType" runat="server" Width="170px"></asp:TextBox>
                    </td>
                </tr>
                <tr>
                    <td class="parameterlabel">
                        Name
                    </td>
                    <td>
                        &nbsp;</td>
                    <td>
                        <asp:TextBox ID="TextBoxGETListResourceRecordSetsName" runat="server" Width="170px"></asp:TextBox>
                    </td>
                </tr>
                <tr>
                    <td class="parameterlabel">
                        maxitems
                    </td>
                    <td>
                        &nbsp;</td>
                    <td>
                        <asp:TextBox ID="TextBoxGETListResourceRecordSetsMaxitems" runat="server" Width="170px"></asp:TextBox>
                    </td>
                </tr>
            </table>
            <br />
            <asp:Button ID="ButtonGETListResourceRecordSets" runat="server" Text="GET ListResourceRecordSets"
                OnClick="ButtonGETListResourceRecordSets_Click" />
            <br />
            Responses:<br />
            <asp:TextBox ID="TextBoxGETListResourceRecordSetsResponse" runat="server" class="responsetextbox"
                TextMode="MultiLine" Wrap="False"></asp:TextBox>
        </blockquote>
        <p>
            &nbsp;</p>
        <h3>
            POST ChangeResourceRecordSets</h3>
        <blockquote>
            Create or change authoritative DNS information.<br />
            Documentation: <a href="http://docs.amazonwebservices.com/Route53/latest/APIReference/API_ChangeResourceRecordSets.html"
                target="_blank">http://docs.amazonwebservices.com/Route53/latest/APIReference/API_ChangeResourceRecordSets.html</a><br />
            <br />
            Parameters:<table>
                <tr>
                    <td class="parameterlabel">
                        HostedZoneId
                    </td>
                    <td>
                        &nbsp;</td>
                    <td>
                        <asp:TextBox ID="TextBoxPOSTChangeResourceRecordSetsHostedZoneId" runat="server"
                            Width="170px"></asp:TextBox>
                    </td>
                </tr>
                <tr>
                    <td class="parameterlabel">
                        Action
                    </td>
                    <td>
                        &nbsp;</td>
                    <td>
                        <asp:TextBox ID="TextBoxPOSTChangeResourceRecordSetsAction" runat="server"
                            Width="170px"></asp:TextBox>
                    </td>
                </tr>
                <tr>
                    <td class="parameterlabel">
                        Name
                    </td>
                    <td>
                        &nbsp;</td>
                    <td>
                        <asp:TextBox ID="TextBoxPOSTChangeResourceRecordSetsName" runat="server"
                            Width="170px"></asp:TextBox>
                    </td>
                </tr>
                <tr>
                    <td class="parameterlabel">
                        Type
                    </td>
                    <td>
                        &nbsp;</td>
                    <td>
                        <asp:TextBox ID="TextBoxPOSTChangeResourceRecordSetsType" runat="server"
                            Width="170px"></asp:TextBox>
                    </td>
                </tr>
                <tr>
                    <td class="parameterlabel">
                        TTL
                    </td>
                    <td>
                        &nbsp;</td>
                    <td>
                        <asp:TextBox ID="TextBoxPOSTChangeResourceRecordSetsTTL" runat="server"
                            Width="170px"></asp:TextBox>
                    </td>
                </tr>
                <tr>
                    <td class="parameterlabel">
                        ResourceRecordValue
                    </td>
                    <td>
                        &nbsp;</td>
                    <td>
                        <asp:TextBox ID="TextBoxPOSTChangeResourceRecordSetsResourceRecordValue" runat="server"
                            Width="170px"></asp:TextBox>
                    </td>
                </tr>
            </table>
            <br />
            <asp:Button ID="ButtonPOSTChangeResourceRecordSets" runat="server" Text="POST ChangeResourceRecordSets"
                OnClick="ButtonPOSTChangeResourceRecordSets_Click" />
            <br />
            <br />
            Responses:<br />
            <asp:TextBox ID="TextBoxPOSTChangeResourceRecordSetsResponse" runat="server" class="responsetextbox"
                TextMode="MultiLine" Wrap="False"></asp:TextBox>
        </blockquote>
        <p>
            &nbsp;</p>
        <h3>
            GET GetChange</h3>
        <blockquote>
            Returns the current state of a change request.<br />
            Documentation: <a href="http://docs.amazonwebservices.com/Route53/latest/APIReference/API_GetChange.html"
                target="_blank">http://docs.amazonwebservices.com/Route53/latest/APIReference/API_GetChange.html</a><br />
            <br />
            Parameters:<table>
                <tr>
                    <td class="parameterlabel">
                        ChangeId
                    </td>
                    <td>
                        &nbsp;</td>
                    <td>
                        <asp:TextBox ID="TextBoxGETGetChangeHostedChangeId" runat="server" Width="170px"></asp:TextBox>
                    </td>
                </tr>
            </table>
            <br />
            <asp:Button ID="ButtonGETGetChange" runat="server" Text="GET GetChange" OnClick="ButtonGETGetChange_Click" />
            <br />
            <br />
            Responses:<br />
            <asp:TextBox ID="TextBoxGETGetChangeResponse" runat="server" class="responsetextbox" TextMode="MultiLine"
                Wrap="False"></asp:TextBox>
        </blockquote>
    </blockquote>
    </form>
</body>
</html>
