﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace S3Browser
{
    public partial class FormMain : Form
    {
        public FormMain()
        {
            InitializeComponent();
        }

        private void FormMain_Load(object sender, EventArgs e)
        {
            Properties.Settings MySettings = new Properties.Settings();
            TextBoxAWSAccessKeyId.Text = MySettings.AWSAccessKeyId;
            TextBoxAWSSecretAccessKey.Text = MySettings.AWSSecretAccessKey;
        }

        protected override void OnFormClosing(FormClosingEventArgs e)
        {
            Properties.Settings MySettings = new Properties.Settings();
            MySettings.AWSAccessKeyId = TextBoxAWSAccessKeyId.Text;
            MySettings.AWSSecretAccessKey = TextBoxAWSSecretAccessKey.Text;
            MySettings.Save();
        }

        private void LinkLabelGetAmazonAccount_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            System.Diagnostics.Process.Start("http://aws.amazon.com/");
        }

        private void ButtonBrowseFlat_Click(object sender, EventArgs e)
        {
            Properties.Settings MySettings = new Properties.Settings();
            MySettings.AWSAccessKeyId = TextBoxAWSAccessKeyId.Text;
            MySettings.AWSSecretAccessKey = TextBoxAWSSecretAccessKey.Text;
            MySettings.Save();
            
            FormBrowse MyFormBrowse = new FormBrowse();
            if (MySettings.FormBrowseHeight > 20)
            {
                MyFormBrowse.Height = MySettings.FormBrowseHeight;
            }
            if (MySettings.FormBrowseWidth > 20)
            {
                MyFormBrowse.Width = MySettings.FormBrowseWidth;
            }
            MyFormBrowse.CurrentBucketName = "";
            MyFormBrowse.CurrentPath = "";
            MyFormBrowse.Delimiter = "";
            MyFormBrowse.ShowDialog(this);
        }

        private void ButtonBrowseFolder_Click(object sender, EventArgs e)
        {
            Properties.Settings MySettings = new Properties.Settings();
            MySettings.AWSAccessKeyId = TextBoxAWSAccessKeyId.Text;
            MySettings.AWSSecretAccessKey = TextBoxAWSSecretAccessKey.Text;
            MySettings.Save();

            FormBrowse MyFormBrowse = new FormBrowse();
            if (MySettings.FormBrowseHeight > 20)
            {
                MyFormBrowse.Height = MySettings.FormBrowseHeight;
            }
            if (MySettings.FormBrowseWidth > 20)
            {
                MyFormBrowse.Width = MySettings.FormBrowseWidth;
            }
            MyFormBrowse.CurrentBucketName = "";
            MyFormBrowse.CurrentPath = "";
            MyFormBrowse.Delimiter = "/";
            MyFormBrowse.ShowDialog(this);
        }
    
    }
}
