﻿Public Class FormMain

    Private Sub FormMain_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'when the form loads, set the text box values from the saved settings
        TextBoxAWSAccessKeyId.Text = My.Settings.AWSAccessKeyId
        TextBoxAWSSecretAccessKey.Text = My.Settings.AWSSecretAccessKey
        TabControl1.SelectedIndex = My.Settings.TabControlSelectedIndex
        TextBoxBucketBucketName.Text = My.Settings.BucketBucketName
        TextBoxObjectBucketName.Text = My.Settings.ObjectBucketName
        TextBoxObjectKeyName.Text = My.Settings.ObjectKeyName
        TextBoxUploadFileName.Text = My.Settings.UploadFileName
        TextBoxUploadBucketName.Text = My.Settings.UploadBucketName
        TextBoxUploadKeyName.Text = My.Settings.UploadKeyName
        TextBoxUploadContentType.Text = My.Settings.UploadContentType
        CheckBoxUploadMakePublic.Checked = My.Settings.UploadMakePublic
        CheckBoxUploadUseSSE.Checked = My.Settings.UploadUseSSE
        If My.Settings.UploadStorageClass = "" Then
            ComboBoxUploadStorageClass.Text = ComboBoxUploadStorageClass.Items(0)
        Else
            ComboBoxUploadStorageClass.Text = My.Settings.UploadStorageClass
        End If
        TextBoxDownloadBucketName.Text = My.Settings.DownloadBucketName
        TextBoxDownloadKeyName.Text = My.Settings.DownloadKeyName
        TextBoxDownloadFileName.Text = My.Settings.DownloadFileName
        TextBoxHashFileName.Text = My.Settings.HashFileName
        TextBoxVerBucketName.Text = My.Settings.TextBoxVerBucketName
        TextBoxVerKeyName.Text = My.Settings.TextBoxVerKeyName
        TextBoxVerVersionID.Text = My.Settings.TextBoxVerVersionID

        TextBoxMultiFileName.Text = My.Settings.MultiFileName
        TextBoxMultiBucketName.Text = My.Settings.MultiBucketName
        TextBoxMultiKeyName.Text = My.Settings.MultiKeyName
        TextBoxMultiContentType.Text = My.Settings.MultiContentType
        CheckBoxMultiMakePublic.Checked = My.Settings.MultiMakePublic
        If My.Settings.MultiStorageClass = "" Then
            ComboBoxMultiStorageClass.Text = ComboBoxMultiStorageClass.Items(0)
        Else
            ComboBoxMultiStorageClass.Text = My.Settings.MultiStorageClass
        End If
        TextBoxMultiUploadId.Text = My.Settings.MultiUploadId

    End Sub

    Private Sub FormMain_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        'when the form closes, save the text box values
        My.Settings.AWSAccessKeyId = TextBoxAWSAccessKeyId.Text
        My.Settings.AWSSecretAccessKey = TextBoxAWSSecretAccessKey.Text
        My.Settings.TabControlSelectedIndex = TabControl1.SelectedIndex
        My.Settings.BucketBucketName = TextBoxBucketBucketName.Text
        My.Settings.ObjectBucketName = TextBoxObjectBucketName.Text
        My.Settings.ObjectKeyName = TextBoxObjectKeyName.Text
        My.Settings.UploadFileName = TextBoxUploadFileName.Text
        My.Settings.UploadBucketName = TextBoxUploadBucketName.Text
        My.Settings.UploadKeyName = TextBoxUploadKeyName.Text
        My.Settings.UploadContentType = TextBoxUploadContentType.Text
        My.Settings.UploadMakePublic = CheckBoxUploadMakePublic.Checked
        My.Settings.UploadUseSSE = CheckBoxUploadUseSSE.Checked
        My.Settings.UploadStorageClass = ComboBoxUploadStorageClass.Text
        My.Settings.DownloadBucketName = TextBoxDownloadBucketName.Text
        My.Settings.DownloadKeyName = TextBoxDownloadKeyName.Text
        My.Settings.DownloadFileName = TextBoxDownloadFileName.Text
        My.Settings.HashFileName = TextBoxHashFileName.Text
        My.Settings.TextBoxVerBucketName = TextBoxVerBucketName.Text
        My.Settings.TextBoxVerKeyName = TextBoxVerKeyName.Text
        My.Settings.TextBoxVerVersionID = TextBoxVerVersionID.Text

        My.Settings.MultiFileName = TextBoxMultiFileName.Text
        My.Settings.MultiBucketName = TextBoxMultiBucketName.Text
        My.Settings.MultiKeyName = TextBoxMultiKeyName.Text
        My.Settings.MultiContentType = TextBoxMultiContentType.Text
        My.Settings.MultiMakePublic = CheckBoxMultiMakePublic.Checked
        My.Settings.MultiStorageClass = ComboBoxMultiStorageClass.Text
        My.Settings.MultiUploadId = TextBoxMultiUploadId.Text
    End Sub

    Private Sub LinkLabelGetAmazonAccount_LinkClicked(ByVal sender As System.Object, ByVal e As System.Windows.Forms.LinkLabelLinkClickedEventArgs) Handles LinkLabelGetAmazonAccount.LinkClicked
        System.Diagnostics.Process.Start("http://aws.amazon.com/")
    End Sub

    Private Function FormatLogData(ByVal RequestURL As String, ByVal RequestMethod As String, ByVal RequestHeaders As Dictionary(Of String, String), ByVal ResponseStatusCode As Integer, ByVal ResponseStatusDescription As String, ByVal ResponseHeaders As Dictionary(Of String, String), ByVal ResponseString As String, ByVal ErrorNumber As Integer, ByVal ErrorDescription As String) As String

        Dim ReturnString As String = ""

        If ErrorNumber <> 0 Then
            ReturnString += "SprightlySoft ErrorDescription: " & ErrorDescription & vbCrLf
            ReturnString += "SprightlySoft ErrorNumber: " & ErrorNumber & vbCrLf
            ReturnString += vbCrLf
        End If


        If ResponseStatusCode <> 0 Then
            ReturnString += "Request URL: " & RequestURL & vbCrLf
            ReturnString += "Request Method: " & RequestMethod & vbCrLf

            For Each MyHeader As KeyValuePair(Of String, String) In RequestHeaders
                ReturnString += "Request Header: " & MyHeader.Key & ":" & MyHeader.Value & vbCrLf
            Next

            ReturnString += vbCrLf
            ReturnString += "Response Status Code: " & ResponseStatusCode & vbCrLf
            ReturnString += "Response Status Description: " & ResponseStatusDescription & vbCrLf

            For Each MyHeader As KeyValuePair(Of String, String) In ResponseHeaders
                ReturnString += "Response Header: " & MyHeader.Key & ":" & MyHeader.Value & vbCrLf
            Next

            If ResponseString <> "" Then
                ReturnString += vbCrLf

                Try
                    Dim XmlDoc As New System.Xml.XmlDocument
                    XmlDoc.LoadXml(ResponseString)

                    ReturnString += "Response XML: " & vbCrLf & ResponseString & vbCrLf

                    Dim XmlNode As System.Xml.XmlNode
                    XmlNode = XmlDoc.SelectSingleNode("/Error/Message")

                    If IsNothing(XmlNode) = False Then
                        ReturnString += vbCrLf
                        ReturnString += "Amazon Error Message: " & XmlNode.InnerText & vbCrLf
                    End If

                Catch ex As Exception
                    ReturnString += "Response String: " & vbCrLf & ResponseString & vbCrLf

                End Try

            End If

        End If

        Return ReturnString

    End Function

    Private Sub ButtonListBuckets_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonListBuckets.Click
        sender.Enabled = False

        'GET Service: http://docs.amazonwebservices.com/AmazonS3/latest/API/RESTServiceGET.html

        'create an instance of the REST class
        Dim MyREST As New SprightlySoftAWS.REST

        Dim RequestURL As String
        'Build the URL to call. Do not specify a bucket name or key name when listing all buckets
        RequestURL = MyREST.BuildS3RequestURL(True, "s3.amazonaws.com", "", "", "")

        Dim RequestMethod As String
        RequestMethod = "GET"

        Dim ExtraRequestHeaders As New Dictionary(Of String, String)
        'add a date header
        ExtraRequestHeaders.Add("x-amz-date", DateTime.UtcNow.ToString("r"))

        Dim AuthorizationValue As String
        'generate the authorization header value
        AuthorizationValue = MyREST.GetS3AuthorizationValue(RequestURL, RequestMethod, ExtraRequestHeaders, TextBoxAWSAccessKeyId.Text, TextBoxAWSSecretAccessKey.Text)
        'add the authorization header
        ExtraRequestHeaders.Add("Authorization", AuthorizationValue)

        'call MakeRequest to submit the REST request
        Dim RetBool As Boolean
        RetBool = MyREST.MakeRequest(RequestURL, RequestMethod, ExtraRequestHeaders, "")

        'print the log data to the Output window
        Debug.Print("")
        Debug.Print(MyREST.LogData)
        Debug.Print("")

        Dim XmlDoc As System.Xml.XmlDocument
        Dim MyXmlNamespaceManager As System.Xml.XmlNamespaceManager
        Dim XmlNode As System.Xml.XmlNode
        Dim XmlContentsNodeList As System.Xml.XmlNodeList
        Dim ResponseMessage As String = ""

        'check if the result of the operation was successful
        If RetBool = True Then

            'load the response XML from Amazon into an XmlDocument
            XmlDoc = New System.Xml.XmlDocument
            XmlDoc.LoadXml(MyREST.ResponseString)

            'specify the namespace for XML path expressions
            MyXmlNamespaceManager = New System.Xml.XmlNamespaceManager(XmlDoc.NameTable)
            MyXmlNamespaceManager.AddNamespace("amz", "http://s3.amazonaws.com/doc/2006-03-01/")

            'extract all values from the response XML
            XmlNode = XmlDoc.SelectSingleNode("/amz:ListAllMyBucketsResult/amz:Owner/amz:ID", MyXmlNamespaceManager)
            ResponseMessage = ResponseMessage & "Owner ID = " & XmlNode.InnerText & vbCrLf

            XmlNode = XmlDoc.SelectSingleNode("/amz:ListAllMyBucketsResult/amz:Owner/amz:DisplayName", MyXmlNamespaceManager)
            ResponseMessage = ResponseMessage & "Owner DisplayName = " & XmlNode.InnerText & vbCrLf
            ResponseMessage = ResponseMessage & vbCrLf

            XmlContentsNodeList = XmlDoc.SelectNodes("/amz:ListAllMyBucketsResult/amz:Buckets/amz:Bucket", MyXmlNamespaceManager)

            For Each XmlContentsNode As System.Xml.XmlNode In XmlContentsNodeList
                XmlNode = XmlContentsNode.SelectSingleNode("./amz:Name", MyXmlNamespaceManager)
                ResponseMessage = ResponseMessage & "Bucket Name = " & XmlNode.InnerText

                XmlNode = XmlContentsNode.SelectSingleNode("./amz:CreationDate", MyXmlNamespaceManager)
                ResponseMessage = ResponseMessage & "     CreationDate = " & CDate(XmlNode.InnerText) & vbCrLf
            Next

            'display values from the XML in the DialogOutput form
            DialogOutput.Text = "Success"
            DialogOutput.TextBoxOutput.Text = ResponseMessage
            DialogOutput.ShowDialog(Me)

        Else
            'build an error message
            ResponseMessage = FormatLogData(MyREST.RequestURL, MyREST.RequestMethod, MyREST.RequestHeaders, MyREST.ResponseStatusCode, MyREST.ResponseStatusDescription, MyREST.ResponseHeaders, MyREST.ResponseStringFormatted, MyREST.ErrorNumber, MyREST.ErrorDescription)

            'display the error message
            DialogOutput.Text = "Error"
            DialogOutput.TextBoxOutput.Text = ResponseMessage
            DialogOutput.ShowDialog(Me)
        End If

        sender.Enabled = True
    End Sub

    Private Sub ButtonListBucketAll_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonListBucketAll.Click
        sender.Enabled = False

        'The following sample uses the ListBucket class to retrieve all objects at once.  The class calls get bucket for each page of results.
        'For each object in the result a ListBucket.BucketItemObject is created and added to the BucketItemsArrayList property of the class.  

        Dim MyListBucket As New SprightlySoftAWS.S3.ListBucket

        Dim RetBool As Boolean
        RetBool = MyListBucket.ListBucket(True, "s3.amazonaws.com", TextBoxBucketBucketName.Text, "/", "", TextBoxAWSAccessKeyId.Text, TextBoxAWSSecretAccessKey.Text)

        Debug.Print("")
        Debug.Print(MyListBucket.LogData)
        Debug.Print("")

        Dim ResponseMessage As String = ""

        If RetBool = True Then

            For Each MyBucketItemObject As SprightlySoftAWS.S3.ListBucket.BucketItemObject In MyListBucket.BucketItemsArrayList

                If MyBucketItemObject.IsFolder = True Then
                    ResponseMessage = ResponseMessage & "FolderName = " & MyBucketItemObject.KeyName & vbCrLf
                Else
                    ResponseMessage = ResponseMessage & "KeyName = " & MyBucketItemObject.KeyName & "   LastModified = " & MyBucketItemObject.LastModified & "   ETag = " & MyBucketItemObject.ETag & "   Size = " & MyBucketItemObject.Size & "   OwnerID = " & MyBucketItemObject.OwnerID & "   OwnerName = " & MyBucketItemObject.OwnerName & "   StorageClass = " & MyBucketItemObject.StorageClass & vbCrLf
                End If

            Next

            DialogOutput.Text = "Success"
            DialogOutput.TextBoxOutput.Text = ResponseMessage
            DialogOutput.ShowDialog(Me)

        Else
            ResponseMessage = FormatLogData(MyListBucket.RequestURL, MyListBucket.RequestMethod, MyListBucket.RequestHeaders, MyListBucket.ResponseStatusCode, MyListBucket.ResponseStatusDescription, MyListBucket.ResponseHeaders, MyListBucket.ResponseStringFormatted, MyListBucket.ErrorNumber, MyListBucket.ErrorDescription)

            DialogOutput.Text = "Error"
            DialogOutput.TextBoxOutput.Text = ResponseMessage
            DialogOutput.ShowDialog(Me)
        End If


        sender.Enabled = True
    End Sub

    Private Sub ButtonListBucketPages_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonListBucketPages.Click
        sender.Enabled = False

        'This example lists a bucket one page at a time.  If there are more than 1000 objects in a result the IsTruncated value will be true
        'and the same function will be called again with the Marker value in the query string set to the NextMarker value from the XML.

        'GET Bucket (List Objects): http://docs.amazonwebservices.com/AmazonS3/latest/API/RESTBucketGET.html

        Dim MyREST As New SprightlySoftAWS.REST

        Dim Delimiter As String = "/"  'use a forward slash as the delimiter if your bucket uses folders and you want to list a single folder.
        Dim Prefix As String = ""
        Dim Marker As String = ""
        Dim MaxKeys As Integer = 1000  '1000 is the maximum number of objects that can be returned in a page
        Dim IsTruncated As Boolean = False

        Dim QueryString As String
        Dim RetBool As Boolean
        Dim XmlDoc As System.Xml.XmlDocument
        Dim MyXmlNamespaceManager As System.Xml.XmlNamespaceManager
        Dim XmlNode As System.Xml.XmlNode
        Dim XmlContentsNodeList As System.Xml.XmlNodeList
        Dim XmlCommonPrefixesNodeList As System.Xml.XmlNodeList
        Dim ResponseMessage As String = ""

        Dim RequestURL As String
        Dim RequestMethod As String = "GET"
        Dim ExtraRequestHeaders As Dictionary(Of String, String)
        Dim AuthorizationValue As String


        'put the following code in a loop as we may be listing many pages
        Do
            QueryString = "?delimiter=" & System.Uri.EscapeDataString(Delimiter) & "&prefix=" & System.Uri.EscapeDataString(Prefix) & "&marker=" & System.Uri.EscapeDataString(Marker) & "&max-keys=" & MaxKeys

            RequestURL = MyREST.BuildS3RequestURL(True, "s3.amazonaws.com", TextBoxBucketBucketName.Text, "", QueryString)

            ExtraRequestHeaders = New Dictionary(Of String, String)
            ExtraRequestHeaders.Add("x-amz-date", DateTime.UtcNow.ToString("r"))

            Dim SignedString As String

            AuthorizationValue = MyREST.GetS3AuthorizationValue(RequestURL, RequestMethod, ExtraRequestHeaders, TextBoxAWSAccessKeyId.Text, TextBoxAWSSecretAccessKey.Text, SignedString)
            ExtraRequestHeaders.Add("Authorization", AuthorizationValue)

            RetBool = MyREST.MakeRequest(RequestURL, RequestMethod, ExtraRequestHeaders, "")

            Debug.Print("")
            Debug.Print(MyREST.LogData)
            Debug.Print("")

            If RetBool = True Then

                XmlDoc = New System.Xml.XmlDocument
                XmlDoc.LoadXml(MyREST.ResponseString)

                MyXmlNamespaceManager = New System.Xml.XmlNamespaceManager(XmlDoc.NameTable)
                MyXmlNamespaceManager.AddNamespace("amz", "http://s3.amazonaws.com/doc/2006-03-01/")

                XmlNode = XmlDoc.SelectSingleNode("/amz:ListBucketResult", MyXmlNamespaceManager)
                If IsNothing(XmlNode) = True Then
                    MessageBox.Show("The ListBucketResult node does not exist in the response XML.", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
                    Exit Do
                Else
                    'the call was successful, list all values in the XML
                    XmlNode = XmlDoc.SelectSingleNode("/amz:ListBucketResult/amz:Name", MyXmlNamespaceManager)
                    ResponseMessage = ResponseMessage & "Name = " & XmlNode.InnerText & vbCrLf

                    XmlNode = XmlDoc.SelectSingleNode("/amz:ListBucketResult/amz:Prefix", MyXmlNamespaceManager)
                    ResponseMessage = ResponseMessage & "Prefix = " & XmlNode.InnerText & vbCrLf

                    XmlNode = XmlDoc.SelectSingleNode("/amz:ListBucketResult/amz:Marker", MyXmlNamespaceManager)
                    ResponseMessage = ResponseMessage & "Marker = " & XmlNode.InnerText & vbCrLf

                    XmlNode = XmlDoc.SelectSingleNode("/amz:ListBucketResult/amz:MaxKeys", MyXmlNamespaceManager)
                    ResponseMessage = ResponseMessage & "MaxKeys = " & XmlNode.InnerText & vbCrLf

                    XmlNode = XmlDoc.SelectSingleNode("/amz:ListBucketResult/amz:Delimiter", MyXmlNamespaceManager)
                    If IsNothing(XmlNode) = False Then
                        ResponseMessage = ResponseMessage & "Delimiter = " & XmlNode.InnerText & vbCrLf
                    End If

                    XmlNode = XmlDoc.SelectSingleNode("/amz:ListBucketResult/amz:IsTruncated", MyXmlNamespaceManager)
                    IsTruncated = XmlNode.InnerText
                    ResponseMessage = ResponseMessage & "IsTruncated = " & XmlNode.InnerText & vbCrLf

                    XmlNode = XmlDoc.SelectSingleNode("/amz:ListBucketResult/amz:NextMarker", MyXmlNamespaceManager)
                    If IsNothing(XmlNode) = False Then
                        'set the Marker to the NextMarker value
                        Marker = XmlNode.InnerText
                        ResponseMessage = ResponseMessage & "NextMarker = " & XmlNode.InnerText & vbCrLf
                    End If


                    XmlContentsNodeList = XmlDoc.SelectNodes("/amz:ListBucketResult/amz:Contents", MyXmlNamespaceManager)

                    For Each XmlContentsNode As System.Xml.XmlNode In XmlContentsNodeList
                        XmlNode = XmlContentsNode.SelectSingleNode("./amz:Key", MyXmlNamespaceManager)
                        ResponseMessage = ResponseMessage & "KeyName = " & XmlNode.InnerText

                        'if the delimiter is empty the NextMarker XML element will not appear.  You will need to keep track of the Marker yourself.
                        If Delimiter = "" Then
                            Marker = XmlNode.InnerText
                        End If

                        XmlNode = XmlContentsNode.SelectSingleNode("./amz:LastModified", MyXmlNamespaceManager)
                        ResponseMessage = ResponseMessage & "     LastModified = " & CDate(XmlNode.InnerText)

                        XmlNode = XmlContentsNode.SelectSingleNode("./amz:ETag", MyXmlNamespaceManager)
                        ResponseMessage = ResponseMessage & "     ETag = " & XmlNode.InnerText

                        XmlNode = XmlContentsNode.SelectSingleNode("./amz:Size", MyXmlNamespaceManager)
                        ResponseMessage = ResponseMessage & "     Size = " & XmlNode.InnerText

                        XmlNode = XmlContentsNode.SelectSingleNode("./amz:Owner/amz:ID", MyXmlNamespaceManager)
                        If IsNothing(XmlNode) = False Then
                            ResponseMessage = ResponseMessage & "     Owner ID = " & XmlNode.InnerText
                        End If

                        XmlNode = XmlContentsNode.SelectSingleNode("./amz:Owner/amz:DisplayName", MyXmlNamespaceManager)
                        If IsNothing(XmlNode) = False Then
                            ResponseMessage = ResponseMessage & "     Owner DisplayName = " & XmlNode.InnerText
                        End If

                        XmlNode = XmlContentsNode.SelectSingleNode("./amz:StorageClass", MyXmlNamespaceManager)
                        ResponseMessage = ResponseMessage & "     StorageClass = " & XmlNode.InnerText

                        ResponseMessage = ResponseMessage & vbCrLf
                    Next


                    XmlCommonPrefixesNodeList = XmlDoc.SelectNodes("/amz:ListBucketResult/amz:CommonPrefixes", MyXmlNamespaceManager)

                    For Each XmlPrefixesNode As System.Xml.XmlNode In XmlCommonPrefixesNodeList
                        XmlNode = XmlPrefixesNode.SelectSingleNode("./amz:Prefix", MyXmlNamespaceManager)
                        ResponseMessage = ResponseMessage & "Prefix = " & XmlNode.InnerText & vbCrLf
                    Next

                    ResponseMessage = ResponseMessage & vbCrLf

                End If

            Else
                ResponseMessage = FormatLogData(MyREST.RequestURL, MyREST.RequestMethod, MyREST.RequestHeaders, MyREST.ResponseStatusCode, MyREST.ResponseStatusDescription, MyREST.ResponseHeaders, MyREST.ResponseStringFormatted, MyREST.ErrorNumber, MyREST.ErrorDescription)

                DialogOutput.Text = "Error"
                DialogOutput.TextBoxOutput.Text = ResponseMessage
                DialogOutput.ShowDialog(Me)

                Exit Do
            End If


            If IsTruncated = False Then
                'if there are no more pages to get, show the output and exit
                DialogOutput.Text = "Success"
                DialogOutput.TextBoxOutput.Text = ResponseMessage
                DialogOutput.ShowDialog(Me)

                Exit Do
            End If

        Loop

        sender.Enabled = True
    End Sub


    Private Sub ButtonCreateBucket_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonCreateBucket.Click
        sender.Enabled = False

        'Working with Amazon S3 Buckets: http://docs.amazonwebservices.com/AmazonS3/latest/UsingBucket.html
        'PUT Bucket: http://docs.amazonwebservices.com/AmazonS3/latest/API/RESTBucketPUT.html

        Dim NewBucketName As String
        NewBucketName = TextBoxBucketBucketName.Text

        'This is a simple implementation of creating a bucket.  A more complete implementation would do the following:
        '  validate the bucket name
        '  check if a bucket with the same name already exists

        If NewBucketName <> "" Then

            Dim MyREST As New SprightlySoftAWS.REST

            Dim RequestMethod As String = "PUT"

            Dim RequestURL As String
            RequestURL = MyREST.BuildS3RequestURL(True, "s3.amazonaws.com", NewBucketName, "", "")

            Dim ExtraRequestHeaders As New Dictionary(Of String, String)
            ExtraRequestHeaders.Add("x-amz-date", DateTime.UtcNow.ToString("r"))

            Dim AuthorizationValue As String
            AuthorizationValue = MyREST.GetS3AuthorizationValue(RequestURL, RequestMethod, ExtraRequestHeaders, TextBoxAWSAccessKeyId.Text, TextBoxAWSSecretAccessKey.Text)
            ExtraRequestHeaders.Add("Authorization", AuthorizationValue)


            Dim PutXML As String
            PutXML = ""  'US region

            'uncomment the following line to create the bucket in Europe
            'PutXML = "<CreateBucketConfiguration><LocationConstraint>EU</LocationConstraint></CreateBucketConfiguration>"  'EU region

            'uncomment the following line to create the bucket in Northern California
            'PutXML = "<CreateBucketConfiguration><LocationConstraint>us-west-1</LocationConstraint></CreateBucketConfiguration>"  'US-West region 

            'uncomment the following line to create the bucket in Asia Pacific (Singapore)
            'PutXML = "<CreateBucketConfiguration><LocationConstraint>ap-southeast-1</LocationConstraint></CreateBucketConfiguration>"  'US-West region 

            Dim RetBool As Boolean
            RetBool = MyREST.MakeRequest(RequestURL, RequestMethod, ExtraRequestHeaders, PutXML)

            Debug.Print("")
            Debug.Print(MyREST.LogData)
            Debug.Print("")

            If RetBool = True Then
                MessageBox.Show("The bucket was created.", "Success", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Else
                Dim ResponseMessage As String
                ResponseMessage = FormatLogData(MyREST.RequestURL, MyREST.RequestMethod, MyREST.RequestHeaders, MyREST.ResponseStatusCode, MyREST.ResponseStatusDescription, MyREST.ResponseHeaders, MyREST.ResponseStringFormatted, MyREST.ErrorNumber, MyREST.ErrorDescription)

                DialogOutput.Text = "Error"
                DialogOutput.TextBoxOutput.Text = ResponseMessage
                DialogOutput.ShowDialog(Me)
            End If
        End If

        sender.Enabled = True
    End Sub

    Private Sub ButtonDeleteBucket_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonDeleteBucket.Click
        sender.Enabled = False

        'DELETE Bucket: http://docs.amazonwebservices.com/AmazonS3/latest/API/RESTBucketDELETE.html

        Dim MyREST As New SprightlySoftAWS.REST

        Dim RequestURL As String
        RequestURL = MyREST.BuildS3RequestURL(True, "s3.amazonaws.com", TextBoxBucketBucketName.Text, "", "")

        Dim RequestMethod As String = "DELETE"

        Dim ExtraRequestHeaders As New Dictionary(Of String, String)
        ExtraRequestHeaders.Add("x-amz-date", DateTime.UtcNow.ToString("r"))

        Dim AuthorizationValue As String
        AuthorizationValue = MyREST.GetS3AuthorizationValue(RequestURL, RequestMethod, ExtraRequestHeaders, TextBoxAWSAccessKeyId.Text, TextBoxAWSSecretAccessKey.Text)
        ExtraRequestHeaders.Add("Authorization", AuthorizationValue)

        Dim RetBool As Boolean
        RetBool = MyREST.MakeRequest(RequestURL, RequestMethod, ExtraRequestHeaders, "")

        Debug.Print("")
        Debug.Print(MyREST.LogData)
        Debug.Print("")

        If RetBool = True Then
            MessageBox.Show("The bucket was deleted.", "Success", MessageBoxButtons.OK, MessageBoxIcon.Information)
        Else

            Dim ResponseMessage As String
            ResponseMessage = FormatLogData(MyREST.RequestURL, MyREST.RequestMethod, MyREST.RequestHeaders, MyREST.ResponseStatusCode, MyREST.ResponseStatusDescription, MyREST.ResponseHeaders, MyREST.ResponseStringFormatted, MyREST.ErrorNumber, MyREST.ErrorDescription)

            DialogOutput.Text = "Error"
            DialogOutput.TextBoxOutput.Text = ResponseMessage
            DialogOutput.ShowDialog(Me)
        End If

        sender.Enabled = True
    End Sub

    Private Sub ButtonBucketExists_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonBucketExists.Click
        sender.Enabled = False

        'do a HEAD request on the bucket to see if it exists

        Dim MyREST As New SprightlySoftAWS.REST

        Dim RequestURL As String
        RequestURL = MyREST.BuildS3RequestURL(True, "s3.amazonaws.com", TextBoxBucketBucketName.Text, "", "")

        Dim RequestMethod As String = "HEAD"

        Dim ExtraRequestHeaders As New Dictionary(Of String, String)
        ExtraRequestHeaders.Add("x-amz-date", DateTime.UtcNow.ToString("r"))

        Dim AuthorizationValue As String
        AuthorizationValue = MyREST.GetS3AuthorizationValue(RequestURL, RequestMethod, ExtraRequestHeaders, TextBoxAWSAccessKeyId.Text, TextBoxAWSSecretAccessKey.Text)
        ExtraRequestHeaders.Add("Authorization", AuthorizationValue)

        Dim RetBool As Boolean
        RetBool = MyREST.MakeRequest(RequestURL, RequestMethod, ExtraRequestHeaders, "")

        Debug.Print("")
        Debug.Print(MyREST.LogData)
        Debug.Print("")

        If MyREST.ResponseStatusCode = 200 Then
            MessageBox.Show("The bucket exists, you have permission to it.", "Success", MessageBoxButtons.OK, MessageBoxIcon.Information)
        ElseIf MyREST.ResponseStatusCode = 404 Then
            MessageBox.Show("The bucket does not exists.", "Success", MessageBoxButtons.OK, MessageBoxIcon.Information)
        ElseIf MyREST.ResponseStatusCode = 403 Then
            MessageBox.Show("Permission error.  Someone else owns the bucket or your access keys are invalid.", "Error", MessageBoxButtons.OK, MessageBoxIcon.Information)
        Else
            Dim ResponseMessage As String
            ResponseMessage = FormatLogData(MyREST.RequestURL, MyREST.RequestMethod, MyREST.RequestHeaders, MyREST.ResponseStatusCode, MyREST.ResponseStatusDescription, MyREST.ResponseHeaders, MyREST.ResponseStringFormatted, MyREST.ErrorNumber, MyREST.ErrorDescription)

            DialogOutput.Text = "Error"
            DialogOutput.TextBoxOutput.Text = ResponseMessage
            DialogOutput.ShowDialog(Me)
        End If

        sender.Enabled = True
    End Sub

    Private Sub ButtonGetBucketLocation_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonGetBucketLocation.Click
        sender.Enabled = False

        'GET Bucket location: http://docs.amazonwebservices.com/AmazonS3/latest/API/RESTBucketLocationGET.html

        Dim MyREST As New SprightlySoftAWS.REST

        Dim RequestURL As String
        RequestURL = MyREST.BuildS3RequestURL(True, "s3.amazonaws.com", TextBoxBucketBucketName.Text, "", "?location")

        Dim RequestMethod As String = "GET"

        Dim ExtraRequestHeaders As New Dictionary(Of String, String)
        ExtraRequestHeaders.Add("x-amz-date", DateTime.UtcNow.ToString("r"))

        Dim AuthorizationValue As String
        AuthorizationValue = MyREST.GetS3AuthorizationValue(RequestURL, RequestMethod, ExtraRequestHeaders, TextBoxAWSAccessKeyId.Text, TextBoxAWSSecretAccessKey.Text)
        ExtraRequestHeaders.Add("Authorization", AuthorizationValue)

        Dim RetBool As Boolean
        RetBool = MyREST.MakeRequest(RequestURL, RequestMethod, ExtraRequestHeaders, "")

        Debug.Print("")
        Debug.Print(MyREST.LogData)
        Debug.Print("")

        Dim XmlDoc As System.Xml.XmlDocument
        Dim MyXmlNamespaceManager As System.Xml.XmlNamespaceManager
        Dim XmlNode As System.Xml.XmlNode

        If RetBool = True Then
            XmlDoc = New System.Xml.XmlDocument
            XmlDoc.LoadXml(MyREST.ResponseString)

            MyXmlNamespaceManager = New System.Xml.XmlNamespaceManager(XmlDoc.NameTable)
            MyXmlNamespaceManager.AddNamespace("amz", "http://s3.amazonaws.com/doc/2006-03-01/")

            XmlNode = XmlDoc.SelectSingleNode("/amz:LocationConstraint", MyXmlNamespaceManager)

            If IsNothing(XmlNode) = True Then
                MessageBox.Show("The LocationConstraint node does not exist in the response XML.", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Else
                If XmlNode.InnerText = "" Then
                    MessageBox.Show("Location is US.", "Success", MessageBoxButtons.OK, MessageBoxIcon.Information)
                Else
                    MessageBox.Show("Location is " & XmlNode.InnerText & ".", "Success", MessageBoxButtons.OK, MessageBoxIcon.Information)
                End If
            End If

        Else
            Dim ResponseMessage As String
            ResponseMessage = FormatLogData(MyREST.RequestURL, MyREST.RequestMethod, MyREST.RequestHeaders, MyREST.ResponseStatusCode, MyREST.ResponseStatusDescription, MyREST.ResponseHeaders, MyREST.ResponseStringFormatted, MyREST.ErrorNumber, MyREST.ErrorDescription)

            DialogOutput.Text = "Error"
            DialogOutput.TextBoxOutput.Text = ResponseMessage
            DialogOutput.ShowDialog(Me)
        End If

        sender.Enabled = True
    End Sub

    Private Sub ButtonGetBucketLogging_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonGetBucketLogging.Click
        sender.Enabled = False

        'Server Access Logging: http://docs.amazonwebservices.com/AmazonS3/latest/ServerLogs.html
        'GET Bucket logging: http://docs.amazonwebservices.com/AmazonS3/latest/API/RESTBucketGETlogging.html

        Dim MyREST As New SprightlySoftAWS.REST

        Dim RequestURL As String
        RequestURL = MyREST.BuildS3RequestURL(True, "s3.amazonaws.com", TextBoxBucketBucketName.Text, "", "?logging")

        Dim RequestMethod As String = "GET"

        Dim ExtraRequestHeaders As New Dictionary(Of String, String)
        ExtraRequestHeaders.Add("x-amz-date", DateTime.UtcNow.ToString("r"))

        Dim AuthorizationValue As String
        AuthorizationValue = MyREST.GetS3AuthorizationValue(RequestURL, RequestMethod, ExtraRequestHeaders, TextBoxAWSAccessKeyId.Text, TextBoxAWSSecretAccessKey.Text)
        ExtraRequestHeaders.Add("Authorization", AuthorizationValue)

        Dim RetBool As Boolean
        RetBool = MyREST.MakeRequest(RequestURL, RequestMethod, ExtraRequestHeaders, "")

        Debug.Print("")
        Debug.Print(MyREST.LogData)
        Debug.Print("")

        Dim XmlDoc As System.Xml.XmlDocument
        Dim MyXmlNamespaceManager As System.Xml.XmlNamespaceManager
        Dim XmlNodeTargetBucket As System.Xml.XmlNode
        Dim TargetPrefix As System.Xml.XmlNode

        If RetBool = True Then
            XmlDoc = New System.Xml.XmlDocument
            XmlDoc.LoadXml(MyREST.ResponseString)

            MyXmlNamespaceManager = New System.Xml.XmlNamespaceManager(XmlDoc.NameTable)
            MyXmlNamespaceManager.AddNamespace("amz", "http://s3.amazonaws.com/doc/2006-03-01/")

            XmlNodeTargetBucket = XmlDoc.SelectSingleNode("/amz:BucketLoggingStatus/amz:LoggingEnabled/amz:TargetBucket", MyXmlNamespaceManager)
            TargetPrefix = XmlDoc.SelectSingleNode("/amz:BucketLoggingStatus/amz:LoggingEnabled/amz:TargetPrefix", MyXmlNamespaceManager)

            If IsNothing(XmlNodeTargetBucket) = True Then
                MessageBox.Show("Logging is not enabled.", "Success", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Else
                MessageBox.Show("Logging is enabled.   TargetBucket=" & XmlNodeTargetBucket.InnerText & "   TargetPrefix=" & TargetPrefix.InnerText, "Success", MessageBoxButtons.OK, MessageBoxIcon.Information)
            End If

        Else
            Dim ResponseMessage As String
            ResponseMessage = FormatLogData(MyREST.RequestURL, MyREST.RequestMethod, MyREST.RequestHeaders, MyREST.ResponseStatusCode, MyREST.ResponseStatusDescription, MyREST.ResponseHeaders, MyREST.ResponseStringFormatted, MyREST.ErrorNumber, MyREST.ErrorDescription)

            DialogOutput.Text = "Error"
            DialogOutput.TextBoxOutput.Text = ResponseMessage
            DialogOutput.ShowDialog(Me)
        End If

        sender.Enabled = True
    End Sub

    Private Sub ButtonSetBucketLogging_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonSetBucketLogging.Click
        sender.Enabled = False

        'Server Access Logging Configuration API: http://docs.amazonwebservices.com/AmazonS3/latest/LoggingAPI.html
        'PUT Bucket logging: http://docs.amazonwebservices.com/AmazonS3/latest/API/RESTBucketPUTlogging.html

        'ask the user where the log files should be saved
        Dim TargetBucket As String
        TargetBucket = InputBox("To enable logging enter the bucket name where log files will be saved.  To disable logging leave the value below empty.", "Target Bucket")

        Dim PutXML As String = ""
        Dim RetBool As Boolean

        Dim MyREST As New SprightlySoftAWS.REST
        Dim RequestURL As String
        Dim RequestMethod As String = "PUT"
        Dim ExtraRequestHeaders As Dictionary(Of String, String)
        Dim AuthorizationValue As String

        RequestURL = MyREST.BuildS3RequestURL(True, "s3.amazonaws.com", TextBoxBucketBucketName.Text, "", "?logging")

        ExtraRequestHeaders = New Dictionary(Of String, String)
        ExtraRequestHeaders.Add("x-amz-date", DateTime.UtcNow.ToString("r"))
        AuthorizationValue = MyREST.GetS3AuthorizationValue(RequestURL, RequestMethod, ExtraRequestHeaders, TextBoxAWSAccessKeyId.Text, TextBoxAWSSecretAccessKey.Text)
        ExtraRequestHeaders.Add("Authorization", AuthorizationValue)

        If TargetBucket = "" Then
            'to diable logging send an XML with no LoggingEnabled element
            PutXML = PutXML & "<?xml version=""1.0"" encoding=""UTF-8""?>" & vbCrLf
            PutXML = PutXML & "<BucketLoggingStatus xmlns=""http://s3.amazonaws.com/doc/2006-03-01/""/>"

            RetBool = MyREST.MakeRequest(RequestURL, RequestMethod, ExtraRequestHeaders, PutXML)

            Debug.Print("")
            Debug.Print(MyREST.LogData)
            Debug.Print("")

            If RetBool = True Then
                MessageBox.Show("Logging has been disabled.", "Success", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Else
                Dim ResponseMessage As String
                ResponseMessage = FormatLogData(MyREST.RequestURL, MyREST.RequestMethod, MyREST.RequestHeaders, MyREST.ResponseStatusCode, MyREST.ResponseStatusDescription, MyREST.ResponseHeaders, MyREST.ResponseStringFormatted, MyREST.ErrorNumber, MyREST.ErrorDescription)

                DialogOutput.Text = "Error"
                DialogOutput.TextBoxOutput.Text = ResponseMessage
                DialogOutput.ShowDialog(Me)
            End If

        Else

            'This is a simple implementation of enabling logging.  A more complete implementation would do the following:
            '  validate the that TargetBucket exists
            '  get the ACLs of the target bucket.  The LogDelivery group requires WRITE and READ_ACP access to the target bucket
            '  add permission to the target bucket for the LogDelivery group if required

            PutXML = ""
            PutXML = PutXML & "<?xml version=""1.0"" encoding=""UTF-8""?>"
            PutXML = PutXML & "<BucketLoggingStatus xmlns=""http://s3.amazonaws.com/doc/2006-03-01/"">"
            PutXML = PutXML & "<LoggingEnabled>"
            PutXML = PutXML & "<TargetBucket>" & TargetBucket & "</TargetBucket>"
            PutXML = PutXML & "<TargetPrefix>" & TextBoxBucketBucketName.Text & "_log-</TargetPrefix>"
            'uncomment the following lines if you would like the AllUsers group to have read access to new log files
            'PutXML = PutXML & "<TargetGrants>"
            'PutXML = PutXML & "<Grant>"
            'PutXML = PutXML & "<Grantee xmlns:xsi=""http://www.w3.org/2001/XMLSchema-instance"" xsi:type=""Group"">"
            'PutXML = PutXML & "<URI>http://acs.amazonaws.com/groups/global/AllUsers</URI>"
            'PutXML = PutXML & "</Grantee>"
            'PutXML = PutXML & "<Permission>READ</Permission>"
            'PutXML = PutXML & "</Grant>"
            'PutXML = PutXML & "</TargetGrants>"
            PutXML = PutXML & "</LoggingEnabled>"
            PutXML = PutXML & "</BucketLoggingStatus>"

            RetBool = MyREST.MakeRequest(RequestURL, RequestMethod, ExtraRequestHeaders, PutXML)

            Debug.Print("")
            Debug.Print(MyREST.LogData)
            Debug.Print("")

            If RetBool = True Then
                MessageBox.Show("Logging has been enabled.", "Success", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Else
                Dim ResponseMessage As String
                ResponseMessage = FormatLogData(MyREST.RequestURL, MyREST.RequestMethod, MyREST.RequestHeaders, MyREST.ResponseStatusCode, MyREST.ResponseStatusDescription, MyREST.ResponseHeaders, MyREST.ResponseStringFormatted, MyREST.ErrorNumber, MyREST.ErrorDescription)

                DialogOutput.Text = "Error"
                DialogOutput.TextBoxOutput.Text = ResponseMessage
                DialogOutput.ShowDialog(Me)
            End If

        End If

        sender.Enabled = True
    End Sub

    Private Sub ButtonGetBucketACLs_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonGetBucketACLs.Click
        sender.Enabled = False

        'Buckets and Access Control: http://docs.amazonwebservices.com/AmazonS3/latest/BucketAccess.html
        'GET Bucket acl: http://docs.amazonwebservices.com/AmazonS3/latest/API/RESTBucketGETacl.html

        Dim MyREST As New SprightlySoftAWS.REST

        Dim RequestURL As String
        RequestURL = MyREST.BuildS3RequestURL(True, "s3.amazonaws.com", TextBoxBucketBucketName.Text, "", "?acl")

        Dim RequestMethod As String = "GET"

        Dim ExtraRequestHeaders As New Dictionary(Of String, String)
        ExtraRequestHeaders.Add("x-amz-date", DateTime.UtcNow.ToString("r"))

        Dim AuthorizationValue As String
        AuthorizationValue = MyREST.GetS3AuthorizationValue(RequestURL, RequestMethod, ExtraRequestHeaders, TextBoxAWSAccessKeyId.Text, TextBoxAWSSecretAccessKey.Text)
        ExtraRequestHeaders.Add("Authorization", AuthorizationValue)

        Dim RetBool As Boolean
        RetBool = MyREST.MakeRequest(RequestURL, RequestMethod, ExtraRequestHeaders, "")

        Debug.Print("")
        Debug.Print(MyREST.LogData)
        Debug.Print("")

        Dim XmlDoc As System.Xml.XmlDocument
        Dim MyXmlNamespaceManager As System.Xml.XmlNamespaceManager
        Dim XmlNode As System.Xml.XmlNode
        Dim XmlContentsNodeList As System.Xml.XmlNodeList
        Dim ResponseMessage As String = ""

        If RetBool = True Then
            XmlDoc = New System.Xml.XmlDocument
            XmlDoc.LoadXml(MyREST.ResponseString)

            MyXmlNamespaceManager = New System.Xml.XmlNamespaceManager(XmlDoc.NameTable)
            MyXmlNamespaceManager.AddNamespace("amz", "http://s3.amazonaws.com/doc/2006-03-01/")

            XmlContentsNodeList = XmlDoc.SelectNodes("/amz:AccessControlPolicy/amz:AccessControlList/amz:Grant", MyXmlNamespaceManager)

            For Each XmlContentsNode As System.Xml.XmlNode In XmlContentsNodeList

                XmlNode = XmlContentsNode.SelectSingleNode("./amz:Grantee", MyXmlNamespaceManager)

                If XmlNode.Attributes("xsi:type").Value = "CanonicalUser" Then
                    XmlNode = XmlContentsNode.SelectSingleNode("./amz:Grantee/amz:ID", MyXmlNamespaceManager)
                    ResponseMessage = ResponseMessage & "CanonicalUser.ID = " & XmlNode.InnerText & vbCrLf

                    XmlNode = XmlContentsNode.SelectSingleNode("./amz:Grantee/amz:DisplayName", MyXmlNamespaceManager)
                    ResponseMessage = ResponseMessage & "CanonicalUser.DisplayName = " & XmlNode.InnerText & vbCrLf

                    XmlNode = XmlContentsNode.SelectSingleNode("./amz:Permission", MyXmlNamespaceManager)
                    ResponseMessage = ResponseMessage & "Permission = " & XmlNode.InnerText & vbCrLf

                ElseIf XmlNode.Attributes("xsi:type").Value = "AmazonCustomerByEmail" Then
                    XmlNode = XmlContentsNode.SelectSingleNode("./amz:Grantee/amz:EmailAddress", MyXmlNamespaceManager)
                    ResponseMessage = ResponseMessage & "AmazonCustomerByEmail.EmailAddress = " & XmlNode.InnerText & vbCrLf

                    XmlNode = XmlContentsNode.SelectSingleNode("./amz:Permission", MyXmlNamespaceManager)
                    ResponseMessage = ResponseMessage & "Permission = " & XmlNode.InnerText & vbCrLf

                ElseIf XmlNode.Attributes("xsi:type").Value = "Group" Then
                    XmlNode = XmlContentsNode.SelectSingleNode("./amz:Grantee/amz:URI", MyXmlNamespaceManager)
                    ResponseMessage = ResponseMessage & "Group.URI = " & XmlNode.InnerText & vbCrLf

                    XmlNode = XmlContentsNode.SelectSingleNode("./amz:Permission", MyXmlNamespaceManager)
                    ResponseMessage = ResponseMessage & "Permission = " & XmlNode.InnerText & vbCrLf

                End If

                ResponseMessage = ResponseMessage & vbCrLf

            Next

            DialogOutput.Text = "Success"
            DialogOutput.TextBoxOutput.Text = ResponseMessage
            DialogOutput.ShowDialog(Me)

        Else
            ResponseMessage = FormatLogData(MyREST.RequestURL, MyREST.RequestMethod, MyREST.RequestHeaders, MyREST.ResponseStatusCode, MyREST.ResponseStatusDescription, MyREST.ResponseHeaders, MyREST.ResponseStringFormatted, MyREST.ErrorNumber, MyREST.ErrorDescription)

            DialogOutput.Text = "Error"
            DialogOutput.TextBoxOutput.Text = ResponseMessage
            DialogOutput.ShowDialog(Me)
        End If

        sender.Enabled = True
    End Sub

    Private Sub ButtonSetBucketACLs_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonSetBucketACLs.Click
        sender.Enabled = False

        Dim MyDialogResult As System.Windows.Forms.DialogResult
        MyDialogResult = MessageBox.Show("Would you like everyone to have the permission to list the objects in this bucket?", "Set ACLs", MessageBoxButtons.YesNo, MessageBoxIcon.Question, MessageBoxDefaultButton.Button1)

        'Get the owner ID.  It will be used when constructing the Access Control List
        Dim MyREST As New SprightlySoftAWS.REST

        Dim RequestURL As String
        RequestURL = MyREST.BuildS3RequestURL(True, "s3.amazonaws.com", TextBoxBucketBucketName.Text, "", "?acl")

        Dim RequestMethod As String
        RequestMethod = "GET"

        Dim ExtraRequestHeaders As New Dictionary(Of String, String)
        ExtraRequestHeaders.Add("x-amz-date", DateTime.UtcNow.ToString("r"))

        Dim AuthorizationValue As String
        AuthorizationValue = MyREST.GetS3AuthorizationValue(RequestURL, RequestMethod, ExtraRequestHeaders, TextBoxAWSAccessKeyId.Text, TextBoxAWSSecretAccessKey.Text)
        ExtraRequestHeaders.Add("Authorization", AuthorizationValue)

        Dim RetBool As Boolean
        RetBool = MyREST.MakeRequest(RequestURL, RequestMethod, ExtraRequestHeaders, "")

        Dim XmlDoc As System.Xml.XmlDocument
        Dim MyXmlNamespaceManager As System.Xml.XmlNamespaceManager
        Dim XmlNode As System.Xml.XmlNode
        Dim ResponseMessage As String

        If RetBool = True Then
            XmlDoc = New System.Xml.XmlDocument
            XmlDoc.LoadXml(MyREST.ResponseString)

            MyXmlNamespaceManager = New System.Xml.XmlNamespaceManager(XmlDoc.NameTable)
            MyXmlNamespaceManager.AddNamespace("amz", "http://s3.amazonaws.com/doc/2006-03-01/")

            XmlNode = XmlDoc.SelectSingleNode("/amz:AccessControlPolicy/amz:Owner/amz:ID", MyXmlNamespaceManager)

            'construct an Access Control List.  Grant the bucket owner FULL_CONTROL and the AllUsers group READ access.  Read access allows listing the bucket
            'Access Control Lists: http://docs.amazonwebservices.com/AmazonS3/latest/S3_ACLs.html

            Dim PutXML As String = ""
            PutXML = PutXML & "<?xml version=""1.0"" encoding=""UTF-8""?>"
            PutXML = PutXML & "<AccessControlPolicy xmlns=""http://s3.amazonaws.com/doc/2006-03-01/"">"
            PutXML = PutXML & "<Owner>"
            PutXML = PutXML & "<ID>" & XmlNode.InnerText & "</ID>"
            PutXML = PutXML & "</Owner>"
            PutXML = PutXML & "<AccessControlList>"
            PutXML = PutXML & "<Grant>"
            PutXML = PutXML & "<Grantee xmlns:xsi=""http://www.w3.org/2001/XMLSchema-instance"" xsi:type=""CanonicalUser"">"
            PutXML = PutXML & "<ID>" & XmlNode.InnerText & "</ID>"
            PutXML = PutXML & "</Grantee>"
            PutXML = PutXML & "<Permission>FULL_CONTROL</Permission>"
            PutXML = PutXML & "</Grant>"
            'if the user selected yes, add read permission for the AllUsers group
            If MyDialogResult = System.Windows.Forms.DialogResult.Yes Then
                PutXML = PutXML & "<Grant>"
                PutXML = PutXML & "<Grantee xmlns:xsi=""http://www.w3.org/2001/XMLSchema-instance"" xsi:type=""Group"">"
                PutXML = PutXML & "<URI>http://acs.amazonaws.com/groups/global/AllUsers</URI>"
                PutXML = PutXML & "</Grantee>"
                PutXML = PutXML & "<Permission>READ</Permission>"
                PutXML = PutXML & "</Grant>"
            End If
            PutXML = PutXML & "</AccessControlList>"
            PutXML = PutXML & "</AccessControlPolicy>"


            RequestURL = MyREST.BuildS3RequestURL(True, "s3.amazonaws.com", TextBoxBucketBucketName.Text, "", "?acl")

            RequestMethod = "PUT"

            ExtraRequestHeaders = New Dictionary(Of String, String)
            ExtraRequestHeaders.Add("x-amz-date", DateTime.UtcNow.ToString("r"))

            AuthorizationValue = MyREST.GetS3AuthorizationValue(RequestURL, RequestMethod, ExtraRequestHeaders, TextBoxAWSAccessKeyId.Text, TextBoxAWSSecretAccessKey.Text)
            ExtraRequestHeaders.Add("Authorization", AuthorizationValue)

            RetBool = MyREST.MakeRequest(RequestURL, RequestMethod, ExtraRequestHeaders, PutXML)

            Debug.Print("")
            Debug.Print(MyREST.LogData)
            Debug.Print("")

            If RetBool = True Then
                MessageBox.Show("ACLs were set on the bucket.", "Success", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Else
                ResponseMessage = FormatLogData(MyREST.RequestURL, MyREST.RequestMethod, MyREST.RequestHeaders, MyREST.ResponseStatusCode, MyREST.ResponseStatusDescription, MyREST.ResponseHeaders, MyREST.ResponseStringFormatted, MyREST.ErrorNumber, MyREST.ErrorDescription)

                DialogOutput.Text = "Error"
                DialogOutput.TextBoxOutput.Text = ResponseMessage
                DialogOutput.ShowDialog(Me)
            End If

        Else
            ResponseMessage = FormatLogData(MyREST.RequestURL, MyREST.RequestMethod, MyREST.RequestHeaders, MyREST.ResponseStatusCode, MyREST.ResponseStatusDescription, MyREST.ResponseHeaders, MyREST.ResponseStringFormatted, MyREST.ErrorNumber, MyREST.ErrorDescription)

            DialogOutput.Text = "Error"
            DialogOutput.TextBoxOutput.Text = ResponseMessage
            DialogOutput.ShowDialog(Me)
        End If

        sender.Enabled = True
    End Sub

    Private Sub ButtonGetBucketRequestPayment_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonGetBucketRequestPayment.Click
        sender.Enabled = False

        'GET Bucket requestPayment: http://docs.amazonwebservices.com/AmazonS3/latest/API/RESTrequestPaymentGET.html

        Dim MyREST As New SprightlySoftAWS.REST

        Dim RequestURL As String
        RequestURL = MyREST.BuildS3RequestURL(True, "s3.amazonaws.com", TextBoxBucketBucketName.Text, "", "?requestPayment")

        Dim RequestMethod As String = "GET"

        Dim ExtraRequestHeaders As New Dictionary(Of String, String)
        ExtraRequestHeaders.Add("x-amz-date", DateTime.UtcNow.ToString("r"))

        Dim AuthorizationValue As String
        AuthorizationValue = MyREST.GetS3AuthorizationValue(RequestURL, RequestMethod, ExtraRequestHeaders, TextBoxAWSAccessKeyId.Text, TextBoxAWSSecretAccessKey.Text)
        ExtraRequestHeaders.Add("Authorization", AuthorizationValue)

        Dim RetBool As Boolean
        RetBool = MyREST.MakeRequest(RequestURL, RequestMethod, ExtraRequestHeaders, "")

        Debug.Print("")
        Debug.Print(MyREST.LogData)
        Debug.Print("")

        Dim XmlDoc As System.Xml.XmlDocument
        Dim MyXmlNamespaceManager As System.Xml.XmlNamespaceManager
        Dim XmlNode As System.Xml.XmlNode

        If RetBool = True Then

            XmlDoc = New System.Xml.XmlDocument
            XmlDoc.LoadXml(MyREST.ResponseString)

            MyXmlNamespaceManager = New System.Xml.XmlNamespaceManager(XmlDoc.NameTable)
            MyXmlNamespaceManager.AddNamespace("amz", "http://s3.amazonaws.com/doc/2006-03-01/")

            XmlNode = XmlDoc.SelectSingleNode("/amz:RequestPaymentConfiguration/amz:Payer", MyXmlNamespaceManager)

            If XmlNode.InnerText = "BucketOwner" Then
                MessageBox.Show("BucketOwner pays.", "Success", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Else
                MessageBox.Show("Requester pays.", "Success", MessageBoxButtons.OK, MessageBoxIcon.Information)
            End If

        Else
            Dim ResponseMessage As String
            ResponseMessage = FormatLogData(MyREST.RequestURL, MyREST.RequestMethod, MyREST.RequestHeaders, MyREST.ResponseStatusCode, MyREST.ResponseStatusDescription, MyREST.ResponseHeaders, MyREST.ResponseStringFormatted, MyREST.ErrorNumber, MyREST.ErrorDescription)

            DialogOutput.Text = "Error"
            DialogOutput.TextBoxOutput.Text = ResponseMessage
            DialogOutput.ShowDialog(Me)
        End If

        sender.Enabled = True
    End Sub

    Private Sub ButtonSetBucketRequestPayment_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonSetBucketRequestPayment.Click
        sender.Enabled = False

        'Requester Pays Buckets: http://docs.amazonwebservices.com/AmazonS3/latest/dev/RequesterPaysBuckets.html
        'PUT Bucket requestPayment: http://docs.amazonwebservices.com/AmazonS3/latest/API/RESTrequestPaymentPUT.html

        'get who the payer should be
        Dim MyDialogResult As System.Windows.Forms.DialogResult
        MyDialogResult = MessageBox.Show("Would you like the requester pay for requests?  Click Yes for Requester pays.  Click No for BucketOwner pays.", "Request Payer", MessageBoxButtons.YesNo, MessageBoxIcon.Question, MessageBoxDefaultButton.Button1)

        Dim Payer As String
        If MyDialogResult = System.Windows.Forms.DialogResult.Yes Then
            Payer = "Requester"
        Else
            Payer = "BucketOwner"
        End If

        'Construct the XML to send
        Dim PutXML As String = ""
        PutXML = PutXML & "<?xml version=""1.0"" encoding=""UTF-8""?>" & vbCrLf
        PutXML = PutXML & "<RequestPaymentConfiguration xmlns=""http://s3.amazonaws.com/doc/2006-03-01/"">"
        PutXML = PutXML & "<Payer>" & Payer & "</Payer>"
        PutXML = PutXML & "</RequestPaymentConfiguration>"

        Dim MyREST As New SprightlySoftAWS.REST

        Dim RequestURL As String
        RequestURL = MyREST.BuildS3RequestURL(True, "s3.amazonaws.com", TextBoxBucketBucketName.Text, "", "?requestPayment")

        Dim RequestMethod As String = "PUT"

        Dim ExtraRequestHeaders As New Dictionary(Of String, String)
        ExtraRequestHeaders.Add("x-amz-date", DateTime.UtcNow.ToString("r"))

        Dim AuthorizationValue As String
        AuthorizationValue = MyREST.GetS3AuthorizationValue(RequestURL, RequestMethod, ExtraRequestHeaders, TextBoxAWSAccessKeyId.Text, TextBoxAWSSecretAccessKey.Text)
        ExtraRequestHeaders.Add("Authorization", AuthorizationValue)

        Dim RetBool As Boolean
        RetBool = MyREST.MakeRequest(RequestURL, RequestMethod, ExtraRequestHeaders, PutXML)

        Debug.Print("")
        Debug.Print(MyREST.LogData)
        Debug.Print("")

        If RetBool = True Then
            MessageBox.Show("RequestPayment has been set to " & Payer & ".", "Success", MessageBoxButtons.OK, MessageBoxIcon.Information)
        Else
            Dim ResponseMessage As String
            ResponseMessage = FormatLogData(MyREST.RequestURL, MyREST.RequestMethod, MyREST.RequestHeaders, MyREST.ResponseStatusCode, MyREST.ResponseStatusDescription, MyREST.ResponseHeaders, MyREST.ResponseStringFormatted, MyREST.ErrorNumber, MyREST.ErrorDescription)

            DialogOutput.Text = "Error"
            DialogOutput.TextBoxOutput.Text = ResponseMessage
            DialogOutput.ShowDialog(Me)
        End If

        sender.Enabled = True
    End Sub

    Private Sub ButtonGetBucketVersioning_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonGetBucketVersioning.Click
        sender.Enabled = False

        'GET Bucket versioning: http://docs.amazonwebservices.com/AmazonS3/latest/API/RESTBucketGETversioningStatus.html

        Dim MyREST As New SprightlySoftAWS.REST

        Dim RequestURL As String
        RequestURL = MyREST.BuildS3RequestURL(True, "s3.amazonaws.com", TextBoxBucketBucketName.Text, "", "?versioning")

        Dim RequestMethod As String = "GET"

        Dim ExtraRequestHeaders As New Dictionary(Of String, String)
        ExtraRequestHeaders.Add("x-amz-date", DateTime.UtcNow.ToString("r"))

        Dim AuthorizationValue As String
        AuthorizationValue = MyREST.GetS3AuthorizationValue(RequestURL, RequestMethod, ExtraRequestHeaders, TextBoxAWSAccessKeyId.Text, TextBoxAWSSecretAccessKey.Text)
        ExtraRequestHeaders.Add("Authorization", AuthorizationValue)

        Dim RetBool As Boolean
        RetBool = MyREST.MakeRequest(RequestURL, RequestMethod, ExtraRequestHeaders, "")

        Debug.Print("")
        Debug.Print(MyREST.LogData)
        Debug.Print("")

        Dim XmlDoc As System.Xml.XmlDocument
        Dim MyXmlNamespaceManager As System.Xml.XmlNamespaceManager
        Dim XmlNode As System.Xml.XmlNode

        If RetBool = True Then

            XmlDoc = New System.Xml.XmlDocument
            XmlDoc.LoadXml(MyREST.ResponseString)

            MyXmlNamespaceManager = New System.Xml.XmlNamespaceManager(XmlDoc.NameTable)
            MyXmlNamespaceManager.AddNamespace("amz", "http://s3.amazonaws.com/doc/2006-03-01/")

            XmlNode = XmlDoc.SelectSingleNode("/amz:VersioningConfiguration/amz:Status", MyXmlNamespaceManager)

            If IsNothing(XmlNode) = True Then
                MessageBox.Show("Versioning is not enabled.", "Success", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Else
                If XmlNode.InnerText = "Enabled" Then
                    MessageBox.Show("Versioning is enabled.", "Success", MessageBoxButtons.OK, MessageBoxIcon.Information)
                Else
                    MessageBox.Show("Versioning is suspended.", "Success", MessageBoxButtons.OK, MessageBoxIcon.Information)
                End If
            End If

        Else
            Dim ResponseMessage As String
            ResponseMessage = FormatLogData(MyREST.RequestURL, MyREST.RequestMethod, MyREST.RequestHeaders, MyREST.ResponseStatusCode, MyREST.ResponseStatusDescription, MyREST.ResponseHeaders, MyREST.ResponseStringFormatted, MyREST.ErrorNumber, MyREST.ErrorDescription)

            DialogOutput.Text = "Error"
            DialogOutput.TextBoxOutput.Text = ResponseMessage
            DialogOutput.ShowDialog(Me)
        End If

        sender.Enabled = True
    End Sub

    Private Sub ButtonSetBucketVersioning_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonSetBucketVersioning.Click
        sender.Enabled = False

        'Enabling a Bucket's Versioning State: http://docs.amazonwebservices.com/AmazonS3/latest/dev/EnablingSuspendingandReturningtheVersioningState.html
        'PUT Bucket versioning: http://docs.amazonwebservices.com/AmazonS3/latest/API/RESTBucketPUTVersioningStatus.html

        Dim MyDialogResult As System.Windows.Forms.DialogResult
        MyDialogResult = MessageBox.Show("Are you sure you would like to set versioning.  Once versioning is enabled on the bucket, it can never be set back to unversioned.", "Set Versioning", MessageBoxButtons.YesNo, MessageBoxIcon.Question, MessageBoxDefaultButton.Button1)

        If MyDialogResult = System.Windows.Forms.DialogResult.Yes Then

            MyDialogResult = MessageBox.Show("Would you like the enable versioning?  Click Yes to enable versioning.  Click No to suspend versioning.", "Set Versioning", MessageBoxButtons.YesNo, MessageBoxIcon.Question, MessageBoxDefaultButton.Button1)

            Dim VerStatus As String
            If MyDialogResult = System.Windows.Forms.DialogResult.Yes Then
                VerStatus = "Enabled"
            Else
                VerStatus = "Suspended"
            End If

            'Construct the XML to send
            Dim PutXML As String = ""
            PutXML = PutXML & "<?xml version=""1.0"" encoding=""UTF-8""?>" & vbCrLf
            PutXML = PutXML & "<VersioningConfiguration xmlns=""http://s3.amazonaws.com/doc/2006-03-01/"">"
            PutXML = PutXML & "<Status>" & VerStatus & "</Status>"
            PutXML = PutXML & "</VersioningConfiguration>"

            Dim MyREST As New SprightlySoftAWS.REST

            Dim RequestURL As String
            RequestURL = MyREST.BuildS3RequestURL(True, "s3.amazonaws.com", TextBoxBucketBucketName.Text, "", "?versioning")

            Dim RequestMethod As String = "PUT"

            Dim ExtraRequestHeaders As New Dictionary(Of String, String)
            ExtraRequestHeaders.Add("x-amz-date", DateTime.UtcNow.ToString("r"))

            Dim AuthorizationValue As String
            AuthorizationValue = MyREST.GetS3AuthorizationValue(RequestURL, RequestMethod, ExtraRequestHeaders, TextBoxAWSAccessKeyId.Text, TextBoxAWSSecretAccessKey.Text)
            ExtraRequestHeaders.Add("Authorization", AuthorizationValue)

            Dim RetBool As Boolean
            RetBool = MyREST.MakeRequest(RequestURL, RequestMethod, ExtraRequestHeaders, PutXML)

            Debug.Print("")
            Debug.Print(MyREST.LogData)
            Debug.Print("")

            If RetBool = True Then
                MessageBox.Show("Versioning has been set to " & VerStatus & ".", "Success", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Else
                Dim ResponseMessage As String
                ResponseMessage = FormatLogData(MyREST.RequestURL, MyREST.RequestMethod, MyREST.RequestHeaders, MyREST.ResponseStatusCode, MyREST.ResponseStatusDescription, MyREST.ResponseHeaders, MyREST.ResponseStringFormatted, MyREST.ErrorNumber, MyREST.ErrorDescription)

                DialogOutput.Text = "Error"
                DialogOutput.TextBoxOutput.Text = ResponseMessage
                DialogOutput.ShowDialog(Me)
            End If

        End If

        sender.Enabled = True
    End Sub

    Private Sub ButtonListBucketVersions_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonListBucketVersions.Click
        sender.Enabled = False

        'Listing the Objects in a Versioning-Enabled Bucket: http://docs.amazonwebservices.com/AmazonS3/latest/dev/ListingtheObjectsinaVersioningEnabledBucket.html
        'GET Bucket Object versions: http://docs.amazonwebservices.com/AmazonS3/latest/API/RESTBucketGETVersion.html

        Dim MyREST As New SprightlySoftAWS.REST

        Dim Delimiter As String = "/"  'use a forward slash as the delimiter if your bucket uses folders and you want to list a single folder.
        Dim KeyMarker As String = ""
        Dim VersionIDMarker As String = ""
        Dim MaxKeys As Integer = 1000  '1000 is the maximum number of objects that can be returned in a page
        Dim IsTruncated As Boolean = False

        Dim QueryString As String
        Dim RetBool As Boolean
        Dim XmlDoc As System.Xml.XmlDocument
        Dim MyXmlNamespaceManager As System.Xml.XmlNamespaceManager
        Dim XmlNode As System.Xml.XmlNode
        Dim XmlListVersionsResultNode As System.Xml.XmlNode
        Dim XmlCommonPrefixesNodeList As System.Xml.XmlNodeList
        Dim ResponseMessage As String = ""

        Dim RequestURL As String
        Dim RequestMethod As String = "GET"
        Dim ExtraRequestHeaders As Dictionary(Of String, String)
        Dim AuthorizationValue As String

        'put the following code in a loop as we may be listing many pages
        Do
            QueryString = "?versions&delimiter=" & System.Uri.EscapeDataString(Delimiter) & "&key-marker=" & System.Uri.EscapeDataString(KeyMarker) & "&max-keys=" & MaxKeys
            If VersionIDMarker <> "" Then
                QueryString = QueryString & "&version-id-marker=" & System.Uri.EscapeDataString(VersionIDMarker)
            End If

            RequestURL = MyREST.BuildS3RequestURL(True, "s3.amazonaws.com", TextBoxBucketBucketName.Text, "", QueryString)

            ExtraRequestHeaders = New Dictionary(Of String, String)
            ExtraRequestHeaders.Add("x-amz-date", DateTime.UtcNow.ToString("r"))
            AuthorizationValue = MyREST.GetS3AuthorizationValue(RequestURL, RequestMethod, ExtraRequestHeaders, TextBoxAWSAccessKeyId.Text, TextBoxAWSSecretAccessKey.Text)
            ExtraRequestHeaders.Add("Authorization", AuthorizationValue)

            RetBool = MyREST.MakeRequest(RequestURL, RequestMethod, ExtraRequestHeaders, "")

            Debug.Print("")
            Debug.Print(MyREST.LogData)
            Debug.Print("")

            If RetBool = True Then

                XmlDoc = New System.Xml.XmlDocument
                XmlDoc.LoadXml(MyREST.ResponseString)

                MyXmlNamespaceManager = New System.Xml.XmlNamespaceManager(XmlDoc.NameTable)
                MyXmlNamespaceManager.AddNamespace("amz", "http://s3.amazonaws.com/doc/2006-03-01/")

                XmlNode = XmlDoc.SelectSingleNode("/amz:ListVersionsResult", MyXmlNamespaceManager)
                If IsNothing(XmlNode) = True Then
                    MessageBox.Show("The ListVersionsResult node does not exist in the response XML.", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
                    Exit Do
                Else

                    XmlNode = XmlDoc.SelectSingleNode("/amz:ListVersionsResult/amz:Name", MyXmlNamespaceManager)
                    ResponseMessage = ResponseMessage & "Name = " & XmlNode.InnerText & vbCrLf

                    XmlNode = XmlDoc.SelectSingleNode("/amz:ListVersionsResult/amz:Prefix", MyXmlNamespaceManager)
                    ResponseMessage = ResponseMessage & "Prefix = " & XmlNode.InnerText & vbCrLf

                    XmlNode = XmlDoc.SelectSingleNode("/amz:ListVersionsResult/amz:KeyMarker", MyXmlNamespaceManager)
                    ResponseMessage = ResponseMessage & "KeyMarker = " & XmlNode.InnerText & vbCrLf

                    XmlNode = XmlDoc.SelectSingleNode("/amz:ListVersionsResult/amz:VersionIdMarker", MyXmlNamespaceManager)
                    ResponseMessage = ResponseMessage & "VersionIdMarker = " & XmlNode.InnerText & vbCrLf

                    XmlNode = XmlDoc.SelectSingleNode("/amz:ListVersionsResult/amz:NextKeyMarker", MyXmlNamespaceManager)
                    If IsNothing(XmlNode) = True Then
                        KeyMarker = ""
                    Else
                        'set the KeyMarker to the NextKeyMarker value.  This will be used in the query string in the next call.
                        KeyMarker = XmlNode.InnerText
                        ResponseMessage = ResponseMessage & "NextKeyMarker = " & XmlNode.InnerText & vbCrLf
                    End If

                    XmlNode = XmlDoc.SelectSingleNode("/amz:ListVersionsResult/amz:NextVersionIdMarker", MyXmlNamespaceManager)
                    If IsNothing(XmlNode) = True Then
                        VersionIDMarker = ""
                    Else
                        'set the VersionIDMarker to the NextVersionIdMarker value.  This will be used in the query string in the next call.
                        VersionIDMarker = XmlNode.InnerText
                        ResponseMessage = ResponseMessage & "NextVersionIdMarker = " & XmlNode.InnerText & vbCrLf
                    End If

                    XmlNode = XmlDoc.SelectSingleNode("/amz:ListVersionsResult/amz:MaxKeys", MyXmlNamespaceManager)
                    ResponseMessage = ResponseMessage & "MaxKeys = " & XmlNode.InnerText & vbCrLf

                    XmlNode = XmlDoc.SelectSingleNode("/amz:ListVersionsResult/amz:Delimiter", MyXmlNamespaceManager)
                    If IsNothing(XmlNode) = False Then
                        ResponseMessage = ResponseMessage & "Delimiter = " & XmlNode.InnerText & vbCrLf
                    End If

                    XmlNode = XmlDoc.SelectSingleNode("/amz:ListVersionsResult/amz:IsTruncated", MyXmlNamespaceManager)
                    IsTruncated = XmlNode.InnerText
                    ResponseMessage = ResponseMessage & "IsTruncated = " & XmlNode.InnerText & vbCrLf


                    XmlListVersionsResultNode = XmlDoc.SelectSingleNode("/amz:ListVersionsResult", MyXmlNamespaceManager)

                    For Each ChildNodeList As System.Xml.XmlElement In XmlListVersionsResultNode.ChildNodes

                        If ChildNodeList.Name = "DeleteMarker" Then
                            ResponseMessage = ResponseMessage & "DeleteMarker"

                            XmlNode = ChildNodeList.SelectSingleNode("./amz:Key", MyXmlNamespaceManager)
                            ResponseMessage = ResponseMessage & "     Key = " & XmlNode.InnerText

                            XmlNode = ChildNodeList.SelectSingleNode("./amz:VersionId", MyXmlNamespaceManager)
                            ResponseMessage = ResponseMessage & "     VersionId = " & XmlNode.InnerText

                            XmlNode = ChildNodeList.SelectSingleNode("./amz:IsLatest", MyXmlNamespaceManager)
                            ResponseMessage = ResponseMessage & "     IsLatest = " & XmlNode.InnerText

                            XmlNode = ChildNodeList.SelectSingleNode("./amz:LastModified", MyXmlNamespaceManager)
                            ResponseMessage = ResponseMessage & "     LastModified = " & XmlNode.InnerText

                            XmlNode = ChildNodeList.SelectSingleNode("./amz:Owner/amz:ID", MyXmlNamespaceManager)
                            If IsNothing(XmlNode) = False Then
                                ResponseMessage = ResponseMessage & "     Owner ID = " & XmlNode.InnerText
                            End If

                            ResponseMessage = ResponseMessage & vbCrLf

                        ElseIf ChildNodeList.Name = "Version" Then
                            ResponseMessage = ResponseMessage & "Version"

                            XmlNode = ChildNodeList.SelectSingleNode("./amz:Key", MyXmlNamespaceManager)
                            ResponseMessage = ResponseMessage & "     Key = " & XmlNode.InnerText

                            XmlNode = ChildNodeList.SelectSingleNode("./amz:VersionId", MyXmlNamespaceManager)
                            ResponseMessage = ResponseMessage & "     VersionId = " & XmlNode.InnerText

                            XmlNode = ChildNodeList.SelectSingleNode("./amz:IsLatest", MyXmlNamespaceManager)
                            ResponseMessage = ResponseMessage & "     IsLatest = " & XmlNode.InnerText

                            XmlNode = ChildNodeList.SelectSingleNode("./amz:LastModified", MyXmlNamespaceManager)
                            ResponseMessage = ResponseMessage & "     LastModified = " & XmlNode.InnerText

                            XmlNode = ChildNodeList.SelectSingleNode("./amz:ETag", MyXmlNamespaceManager)
                            ResponseMessage = ResponseMessage & "     ETag = " & XmlNode.InnerText

                            XmlNode = ChildNodeList.SelectSingleNode("./amz:Size", MyXmlNamespaceManager)
                            ResponseMessage = ResponseMessage & "     Size = " & XmlNode.InnerText

                            XmlNode = ChildNodeList.SelectSingleNode("./amz:Owner/amz:ID", MyXmlNamespaceManager)
                            If IsNothing(XmlNode) = False Then
                                ResponseMessage = ResponseMessage & "     Owner ID = " & XmlNode.InnerText
                            End If

                            XmlNode = ChildNodeList.SelectSingleNode("./amz:StorageClass", MyXmlNamespaceManager)
                            ResponseMessage = ResponseMessage & "     StorageClass = " & XmlNode.InnerText

                            ResponseMessage = ResponseMessage & vbCrLf

                        End If

                    Next


                    XmlCommonPrefixesNodeList = XmlDoc.SelectNodes("/amz:ListVersionsResult/amz:CommonPrefixes", MyXmlNamespaceManager)
                    For Each XmlPrefixesNode As System.Xml.XmlNode In XmlCommonPrefixesNodeList
                        XmlNode = XmlPrefixesNode.SelectSingleNode("./amz:Prefix", MyXmlNamespaceManager)
                        ResponseMessage = ResponseMessage & "Prefix = " & XmlNode.InnerText & vbCrLf
                    Next

                    ResponseMessage = ResponseMessage & vbCrLf

                End If

            Else
                ResponseMessage = FormatLogData(MyREST.RequestURL, MyREST.RequestMethod, MyREST.RequestHeaders, MyREST.ResponseStatusCode, MyREST.ResponseStatusDescription, MyREST.ResponseHeaders, MyREST.ResponseStringFormatted, MyREST.ErrorNumber, MyREST.ErrorDescription)

                DialogOutput.Text = "Error"
                DialogOutput.TextBoxOutput.Text = ResponseMessage
                DialogOutput.ShowDialog(Me)
                Exit Do
            End If


            If IsTruncated = False Then
                'if there are no more pages to get, show the output and exit
                DialogOutput.Text = "Success"
                DialogOutput.TextBoxOutput.Text = ResponseMessage
                DialogOutput.ShowDialog(Me)
                Exit Do
            End If

        Loop

        sender.Enabled = True
    End Sub

    Private Sub ButtonGetBucketPolicies_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonGetBucketPolicies.Click
        sender.Enabled = False

        'Using Bucket Policies: http://docs.amazonwebservices.com/AmazonS3/latest/dev/UsingBucketPolicies.html
        'Returning the Bucket Policies on a Bucket: http://docs.amazonwebservices.com/AmazonS3/latest/dev/returnbucketpolicyonbucket.html

        Dim MyREST As New SprightlySoftAWS.REST

        Dim RequestURL As String
        RequestURL = MyREST.BuildS3RequestURL(True, "s3.amazonaws.com", TextBoxBucketBucketName.Text, "", "?policy")

        Dim RequestMethod As String = "GET"

        Dim ExtraRequestHeaders As New Dictionary(Of String, String)
        ExtraRequestHeaders.Add("x-amz-date", DateTime.UtcNow.ToString("r"))

        Dim AuthorizationValue As String
        AuthorizationValue = MyREST.GetS3AuthorizationValue(RequestURL, RequestMethod, ExtraRequestHeaders, TextBoxAWSAccessKeyId.Text, TextBoxAWSSecretAccessKey.Text)
        ExtraRequestHeaders.Add("Authorization", AuthorizationValue)

        Dim RetBool As Boolean
        RetBool = MyREST.MakeRequest(RequestURL, RequestMethod, ExtraRequestHeaders, "")

        Debug.Print("")
        Debug.Print(MyREST.LogData)
        Debug.Print("")

        If RetBool = True Then
            DialogOutput.Text = "Success"
            DialogOutput.TextBoxOutput.Text = MyREST.ResponseStringFormatted
            DialogOutput.ShowDialog(Me)
        Else
            Dim ResponseMessage As String
            ResponseMessage = FormatLogData(MyREST.RequestURL, MyREST.RequestMethod, MyREST.RequestHeaders, MyREST.ResponseStatusCode, MyREST.ResponseStatusDescription, MyREST.ResponseHeaders, MyREST.ResponseStringFormatted, MyREST.ErrorNumber, MyREST.ErrorDescription)

            DialogOutput.Text = "Error"
            DialogOutput.TextBoxOutput.Text = ResponseMessage
            DialogOutput.ShowDialog(Me)
        End If

        sender.Enabled = True
    End Sub

    Private Sub ButtonSetBucketPolicies_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonSetBucketPolicies.Click
        sender.Enabled = False

        'Setting Bucket Policies on a Bucket: http://docs.amazonwebservices.com/AmazonS3/latest/dev/setpolicyonbucket.html

        Dim PutString As String = ""
        Dim RetBool As Boolean
        Dim MyREST As New SprightlySoftAWS.REST

        'The following example policy grants access to read files from the IP address of 168.144.123.123.
        PutString = PutString & "{" & vbCrLf
        PutString = PutString & "  ""Version"":""2008-10-17""," & vbCrLf
        PutString = PutString & "  ""Statement"":[{" & vbCrLf
        PutString = PutString & "	""Sid"":""IPAllow""," & vbCrLf
        PutString = PutString & "        ""Effect"":""Allow""," & vbCrLf
        PutString = PutString & "	  ""Principal"": {" & vbCrLf
        PutString = PutString & "            ""AWS"": ""*""" & vbCrLf
        PutString = PutString & "      }," & vbCrLf
        PutString = PutString & "      ""Action"":""s3:GetObject""," & vbCrLf
        PutString = PutString & "      ""Resource"":""arn:aws:s3:::" & TextBoxBucketBucketName.Text & "/*""," & vbCrLf
        PutString = PutString & "      ""Condition"":{" & vbCrLf
        PutString = PutString & "        ""IpAddress"":{" & vbCrLf
        PutString = PutString & "        ""aws:SourceIp"":""168.144.123.123""" & vbCrLf
        PutString = PutString & "        }" & vbCrLf
        PutString = PutString & "      }" & vbCrLf
        PutString = PutString & "    }" & vbCrLf
        PutString = PutString & "  ]" & vbCrLf
        PutString = PutString & "}" & vbCrLf

        Dim RequestURL As String
        RequestURL = MyREST.BuildS3RequestURL(True, "s3.amazonaws.com", TextBoxBucketBucketName.Text, "", "?policy")

        Dim RequestMethod As String = "PUT"

        Dim ExtraRequestHeaders As New Dictionary(Of String, String)
        ExtraRequestHeaders.Add("x-amz-date", DateTime.UtcNow.ToString("r"))

        Dim AuthorizationValue As String
        AuthorizationValue = MyREST.GetS3AuthorizationValue(RequestURL, RequestMethod, ExtraRequestHeaders, TextBoxAWSAccessKeyId.Text, TextBoxAWSSecretAccessKey.Text)
        ExtraRequestHeaders.Add("Authorization", AuthorizationValue)

        RetBool = MyREST.MakeRequest(RequestURL, RequestMethod, ExtraRequestHeaders, PutString)

        Debug.Print("")
        Debug.Print(MyREST.LogData)
        Debug.Print("")

        If RetBool = True Then
            MessageBox.Show("The buckey policy has been set.", "Success", MessageBoxButtons.OK, MessageBoxIcon.Information)
        Else
            Dim ResponseMessage As String
            ResponseMessage = FormatLogData(MyREST.RequestURL, MyREST.RequestMethod, MyREST.RequestHeaders, MyREST.ResponseStatusCode, MyREST.ResponseStatusDescription, MyREST.ResponseHeaders, MyREST.ResponseStringFormatted, MyREST.ErrorNumber, MyREST.ErrorDescription)

            DialogOutput.Text = "Error"
            DialogOutput.TextBoxOutput.Text = ResponseMessage
            DialogOutput.ShowDialog(Me)
        End If


        sender.Enabled = True
    End Sub

    Private Sub ButtonDeleteBucketPolicies_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonDeleteBucketPolicies.Click
        sender.Enabled = False

        'Deleting Bucket Policies on a Bucket: http://docs.amazonwebservices.com/AmazonS3/latest/dev/deletebucketpolicy.html

        Dim MyREST As New SprightlySoftAWS.REST

        Dim RequestURL As String
        RequestURL = MyREST.BuildS3RequestURL(True, "s3.amazonaws.com", TextBoxBucketBucketName.Text, "", "?policy")

        Dim RequestMethod As String = "DELETE"

        Dim ExtraRequestHeaders As New Dictionary(Of String, String)
        ExtraRequestHeaders.Add("x-amz-date", DateTime.UtcNow.ToString("r"))

        Dim AuthorizationValue As String
        AuthorizationValue = MyREST.GetS3AuthorizationValue(RequestURL, RequestMethod, ExtraRequestHeaders, TextBoxAWSAccessKeyId.Text, TextBoxAWSSecretAccessKey.Text)
        ExtraRequestHeaders.Add("Authorization", AuthorizationValue)

        Dim RetBool As Boolean
        RetBool = MyREST.MakeRequest(RequestURL, RequestMethod, ExtraRequestHeaders, "")

        Debug.Print("")
        Debug.Print(MyREST.LogData)
        Debug.Print("")

        If RetBool = True Then
            MessageBox.Show("The policy was deleted.", "Success", MessageBoxButtons.OK, MessageBoxIcon.Information)
        Else

            Dim ResponseMessage As String
            ResponseMessage = FormatLogData(MyREST.RequestURL, MyREST.RequestMethod, MyREST.RequestHeaders, MyREST.ResponseStatusCode, MyREST.ResponseStatusDescription, MyREST.ResponseHeaders, MyREST.ResponseStringFormatted, MyREST.ErrorNumber, MyREST.ErrorDescription)

            DialogOutput.Text = "Error"
            DialogOutput.TextBoxOutput.Text = ResponseMessage
            DialogOutput.ShowDialog(Me)
        End If

        sender.Enabled = True
    End Sub

    Private Sub ButtonGetBucketNotification_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonGetBucketNotification.Click
        sender.Enabled = False

        'GET Bucket notification: http://docs.amazonwebservices.com/AmazonS3/latest/API/RESTBucketGETnotification.html

        Dim MyREST As New SprightlySoftAWS.REST

        Dim RequestURL As String
        RequestURL = MyREST.BuildS3RequestURL(True, "s3.amazonaws.com", TextBoxBucketBucketName.Text, "", "?notification")

        Dim RequestMethod As String = "GET"

        Dim ExtraRequestHeaders As New Dictionary(Of String, String)
        ExtraRequestHeaders.Add("x-amz-date", DateTime.UtcNow.ToString("r"))

        Dim AuthorizationValue As String
        AuthorizationValue = MyREST.GetS3AuthorizationValue(RequestURL, RequestMethod, ExtraRequestHeaders, TextBoxAWSAccessKeyId.Text, TextBoxAWSSecretAccessKey.Text)
        ExtraRequestHeaders.Add("Authorization", AuthorizationValue)

        Dim RetBool As Boolean
        RetBool = MyREST.MakeRequest(RequestURL, RequestMethod, ExtraRequestHeaders, "")

        Debug.Print("")
        Debug.Print(MyREST.LogData)
        Debug.Print("")

        Dim XmlDoc As System.Xml.XmlDocument
        Dim MyXmlNamespaceManager As System.Xml.XmlNamespaceManager
        Dim XmlNodeTopic As System.Xml.XmlNode
        Dim XmlNodeEvent As System.Xml.XmlNode

        If RetBool = True Then
            XmlDoc = New System.Xml.XmlDocument
            XmlDoc.LoadXml(MyREST.ResponseString)

            MyXmlNamespaceManager = New System.Xml.XmlNamespaceManager(XmlDoc.NameTable)
            MyXmlNamespaceManager.AddNamespace("amz", "http://s3.amazonaws.com/doc/2006-03-01/")

            XmlNodeTopic = XmlDoc.SelectSingleNode("/amz:NotificationConfiguration/amz:TopicConfiguration/amz:Topic", MyXmlNamespaceManager)
            XmlNodeEvent = XmlDoc.SelectSingleNode("/amz:NotificationConfiguration/amz:TopicConfiguration/amz:Event", MyXmlNamespaceManager)

            If IsNothing(XmlNodeTopic) = True Then
                MessageBox.Show("Notification is not enabled.", "Success", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Else
                MessageBox.Show("Notification is enabled.   Topic=" & XmlNodeTopic.InnerText & "   Event=" & XmlNodeEvent.InnerText, "Success", MessageBoxButtons.OK, MessageBoxIcon.Information)
            End If

        Else
            Dim ResponseMessage As String
            ResponseMessage = FormatLogData(MyREST.RequestURL, MyREST.RequestMethod, MyREST.RequestHeaders, MyREST.ResponseStatusCode, MyREST.ResponseStatusDescription, MyREST.ResponseHeaders, MyREST.ResponseStringFormatted, MyREST.ErrorNumber, MyREST.ErrorDescription)

            DialogOutput.Text = "Error"
            DialogOutput.TextBoxOutput.Text = ResponseMessage
            DialogOutput.ShowDialog(Me)
        End If

        sender.Enabled = True
    End Sub

    Private Sub ButtonSetBucketNotification_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonSetBucketNotification.Click
        sender.Enabled = False

        'Setting Up Notification of Bucket Events: http://docs.amazonwebservices.com/AmazonS3/latest/dev/NotificationHowTo.html
        'PUT Bucket notification: http://docs.amazonwebservices.com/AmazonS3/latest/API/RESTBucketPUTnotification.html

        Dim NotificationTopic As String
        NotificationTopic = InputBox("Enter the Amazon Simple Notification Service (SNS) topic the notification will be sent to if Amazon S3 looses all copies of a Reduced Redundancy Storage (RRS) object.  To disable notification leave the value below empty.", "Amazon Simple Notification Service Topic")

        Dim PutXML As String = ""
        Dim RetBool As Boolean

        Dim MyREST As New SprightlySoftAWS.REST
        Dim RequestURL As String
        Dim RequestMethod As String
        Dim ExtraRequestHeaders As Dictionary(Of String, String)
        Dim AuthorizationValue As String

        If NotificationTopic = "" Then
            'to diable notification send an XML with an empty NotificationConfiguration element
            PutXML = PutXML & "<?xml version=""1.0"" encoding=""UTF-8""?>" & vbCrLf
            PutXML = PutXML & "<NotificationConfiguration xmlns=""http://s3.amazonaws.com/doc/2006-03-01/""/>"

            RequestMethod = "PUT"

            RequestURL = MyREST.BuildS3RequestURL(True, "s3.amazonaws.com", TextBoxBucketBucketName.Text, "", "?notification")

            ExtraRequestHeaders = New Dictionary(Of String, String)
            ExtraRequestHeaders.Add("x-amz-date", DateTime.UtcNow.ToString("r"))
            AuthorizationValue = MyREST.GetS3AuthorizationValue(RequestURL, RequestMethod, ExtraRequestHeaders, TextBoxAWSAccessKeyId.Text, TextBoxAWSSecretAccessKey.Text)
            ExtraRequestHeaders.Add("Authorization", AuthorizationValue)

            RetBool = MyREST.MakeRequest(RequestURL, RequestMethod, ExtraRequestHeaders, PutXML)

            Debug.Print("")
            Debug.Print(MyREST.LogData)
            Debug.Print("")

            If RetBool = True Then
                MessageBox.Show("Notification has been disabled.", "Success", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Else
                Dim ResponseMessage As String
                ResponseMessage = FormatLogData(MyREST.RequestURL, MyREST.RequestMethod, MyREST.RequestHeaders, MyREST.ResponseStatusCode, MyREST.ResponseStatusDescription, MyREST.ResponseHeaders, MyREST.ResponseStringFormatted, MyREST.ErrorNumber, MyREST.ErrorDescription)

                DialogOutput.Text = "Error"
                DialogOutput.TextBoxOutput.Text = ResponseMessage
                DialogOutput.ShowDialog(Me)
            End If

        Else

            PutXML = ""
            PutXML = PutXML & "<NotificationConfiguration>"
            PutXML = PutXML & "<TopicConfiguration>"
            PutXML = PutXML & "<Topic>" & NotificationTopic & "</Topic>"
            PutXML = PutXML & "<Event>s3:ReducedRedundancyLostObject</Event>"
            PutXML = PutXML & "</TopicConfiguration>"
            PutXML = PutXML & "</NotificationConfiguration>"

            RequestMethod = "PUT"

            RequestURL = MyREST.BuildS3RequestURL(True, "s3.amazonaws.com", TextBoxBucketBucketName.Text, "", "?notification")

            ExtraRequestHeaders = New Dictionary(Of String, String)
            ExtraRequestHeaders.Add("x-amz-date", DateTime.UtcNow.ToString("r"))
            AuthorizationValue = MyREST.GetS3AuthorizationValue(RequestURL, RequestMethod, ExtraRequestHeaders, TextBoxAWSAccessKeyId.Text, TextBoxAWSSecretAccessKey.Text)
            ExtraRequestHeaders.Add("Authorization", AuthorizationValue)

            RetBool = MyREST.MakeRequest(RequestURL, RequestMethod, ExtraRequestHeaders, PutXML)

            Debug.Print("")
            Debug.Print(MyREST.LogData)
            Debug.Print("")

            If RetBool = True Then
                MessageBox.Show("Notification has been enabled.", "Success", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Else
                Dim ResponseMessage As String
                ResponseMessage = FormatLogData(MyREST.RequestURL, MyREST.RequestMethod, MyREST.RequestHeaders, MyREST.ResponseStatusCode, MyREST.ResponseStatusDescription, MyREST.ResponseHeaders, MyREST.ResponseStringFormatted, MyREST.ErrorNumber, MyREST.ErrorDescription)

                DialogOutput.Text = "Error"
                DialogOutput.TextBoxOutput.Text = ResponseMessage
                DialogOutput.ShowDialog(Me)
            End If

        End If

        sender.Enabled = True
    End Sub

    Private Sub ButtonListMultipartUploads_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonListMultipartUploads.Click
        sender.Enabled = False

        'List Multipart Uploads: http://docs.amazonwebservices.com/AmazonS3/latest/API/mpUploadListMPUpload.html

        Dim MyREST As New SprightlySoftAWS.REST

        Dim QueryString As String
        QueryString = "?uploads"

        Dim RequestURL As String
        RequestURL = MyREST.BuildS3RequestURL(True, "s3.amazonaws.com", TextBoxBucketBucketName.Text, "", QueryString)

        Dim RequestMethod As String = "GET"

        Dim ExtraRequestHeaders As New Dictionary(Of String, String)
        ExtraRequestHeaders.Add("x-amz-date", DateTime.UtcNow.ToString("r"))

        Dim AuthorizationValue As String
        AuthorizationValue = MyREST.GetS3AuthorizationValue(RequestURL, RequestMethod, ExtraRequestHeaders, TextBoxAWSAccessKeyId.Text, TextBoxAWSSecretAccessKey.Text)
        ExtraRequestHeaders.Add("Authorization", AuthorizationValue)

        Dim RetBool As Boolean
        RetBool = MyREST.MakeRequest(RequestURL, RequestMethod, ExtraRequestHeaders, "")

        Debug.Print("")
        Debug.Print(MyREST.LogData)
        Debug.Print("")

        Dim ResponseMessage As String = ""

        If RetBool = True Then
            Dim MyXmlDocument As System.Xml.XmlDocument
            Dim MyXmlNamespaceManager As System.Xml.XmlNamespaceManager
            Dim MyXmlNode As System.Xml.XmlNode
            Dim MyXmlNodeList As System.Xml.XmlNodeList

            MyXmlDocument = New System.Xml.XmlDocument
            MyXmlDocument.LoadXml(MyREST.ResponseString)

            MyXmlNamespaceManager = New System.Xml.XmlNamespaceManager(MyXmlDocument.NameTable)
            MyXmlNamespaceManager.AddNamespace("amz", "http://s3.amazonaws.com/doc/2006-03-01/")

            MyXmlNodeList = MyXmlDocument.SelectNodes("amz:ListMultipartUploadsResult/amz:Upload", MyXmlNamespaceManager)

            If IsNothing(MyXmlNodeList) = True Then
                MessageBox.Show("No multipart uploads exist.", "Success", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Else
                For Each ItemXmlNode As System.Xml.XmlNode In MyXmlNodeList
                    MyXmlNode = ItemXmlNode.SelectSingleNode("amz:Key", MyXmlNamespaceManager)
                    ResponseMessage += "Key = " & MyXmlNode.InnerText & vbCrLf

                    MyXmlNode = ItemXmlNode.SelectSingleNode("amz:UploadId", MyXmlNamespaceManager)
                    ResponseMessage += "UploadId = " & MyXmlNode.InnerText & vbCrLf

                    ResponseMessage += vbCrLf
                Next

                DialogOutput.Text = "Success"
                DialogOutput.TextBoxOutput.Text = ResponseMessage
                DialogOutput.ShowDialog(Me)
            End If

        Else
            ResponseMessage = FormatLogData(MyREST.RequestURL, MyREST.RequestMethod, MyREST.RequestHeaders, MyREST.ResponseStatusCode, MyREST.ResponseStatusDescription, MyREST.ResponseHeaders, MyREST.ResponseStringFormatted, MyREST.ErrorNumber, MyREST.ErrorDescription)

            DialogOutput.Text = "Error"
            DialogOutput.TextBoxOutput.Text = ResponseMessage
            DialogOutput.ShowDialog(Me)
        End If

        sender.Enabled = True
    End Sub

    Private Sub ButtonGetObjectProperties_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonGetObjectProperties.Click
        sender.Enabled = False

        'HEAD Object: http://docs.amazonwebservices.com/AmazonS3/latest/API/RESTObjectHEAD.html

        Dim MyREST As New SprightlySoftAWS.REST

        Dim RequestURL As String
        RequestURL = MyREST.BuildS3RequestURL(True, "s3.amazonaws.com", TextBoxObjectBucketName.Text, TextBoxObjectKeyName.Text, "")

        Dim RequestMethod As String = "HEAD"

        Dim ExtraRequestHeaders As New Dictionary(Of String, String)
        ExtraRequestHeaders.Add("x-amz-date", DateTime.UtcNow.ToString("r"))

        Dim AuthorizationValue As String
        AuthorizationValue = MyREST.GetS3AuthorizationValue(RequestURL, RequestMethod, ExtraRequestHeaders, TextBoxAWSAccessKeyId.Text, TextBoxAWSSecretAccessKey.Text)
        ExtraRequestHeaders.Add("Authorization", AuthorizationValue)

        Dim RetBool As Boolean
        RetBool = MyREST.MakeRequest(RequestURL, RequestMethod, ExtraRequestHeaders, "")

        Debug.Print("")
        Debug.Print(MyREST.LogData)
        Debug.Print("")

        Dim ResponseMessage As String = ""

        If RetBool = True Then

            For Each MyKeyValuePair As KeyValuePair(Of String, String) In MyREST.ResponseHeaders
                If InStr(MyKeyValuePair.Key, "x-amz-") = 1 Then
                    If MyKeyValuePair.Key <> "x-amz-id-2" And MyKeyValuePair.Key <> "x-amz-request-id" Then  'Ignore the Amazon ID response headers.  They are included in every response and they could be used to troubleshoot issues on Amazon's end.
                        ResponseMessage = ResponseMessage & "Amazon header = " & MyKeyValuePair.Key & ":" & MyKeyValuePair.Value & vbCrLf
                    End If
                End If
            Next

            If MyREST.ResponseHeaders.ContainsKey("Cache-Control") = True Then
                ResponseMessage = ResponseMessage & "Cache-Control = " & MyREST.ResponseHeaders("Cache-Control") & vbCrLf
            End If

            If MyREST.ResponseHeaders.ContainsKey("Content-Disposition") = True Then
                ResponseMessage = ResponseMessage & "Content-Disposition = " & MyREST.ResponseHeaders("Content-Disposition") & vbCrLf
            End If

            If MyREST.ResponseHeaders.ContainsKey("Content-Encoding") = True Then
                ResponseMessage = ResponseMessage & "Content-Encoding = " & MyREST.ResponseHeaders("Content-Encoding") & vbCrLf
            End If

            If MyREST.ResponseHeaders.ContainsKey("Content-Language") = True Then
                ResponseMessage = ResponseMessage & "Content-Language = " & MyREST.ResponseHeaders("Content-Language") & vbCrLf
            End If

            If MyREST.ResponseHeaders.ContainsKey("Content-Type") = True Then
                ResponseMessage = ResponseMessage & "Content-Type = " & MyREST.ResponseHeaders("Content-Type") & vbCrLf
            End If

            If MyREST.ResponseHeaders.ContainsKey("Expires") = True Then
                ResponseMessage = ResponseMessage & "Expires = " & MyREST.ResponseHeaders("Expires") & vbCrLf
            End If

            If MyREST.ResponseHeaders.ContainsKey("Content-Length") = True Then
                ResponseMessage = ResponseMessage & "Content-Length = " & MyREST.ResponseHeaders("Content-Length") & vbCrLf
            End If

            If MyREST.ResponseHeaders.ContainsKey("Last-Modified") = True Then
                ResponseMessage = ResponseMessage & "Last-Modified = " & CDate(MyREST.ResponseHeaders("Last-Modified")) & vbCrLf
            End If

            If MyREST.ResponseHeaders.ContainsKey("ETag") = True Then
                ResponseMessage = ResponseMessage & "ETag = " & MyREST.ResponseHeaders("ETag") & vbCrLf
            End If

            DialogOutput.Text = "Success"
            DialogOutput.TextBoxOutput.Text = ResponseMessage
            DialogOutput.ShowDialog(Me)

        Else
            ResponseMessage = FormatLogData(MyREST.RequestURL, MyREST.RequestMethod, MyREST.RequestHeaders, MyREST.ResponseStatusCode, MyREST.ResponseStatusDescription, MyREST.ResponseHeaders, MyREST.ResponseStringFormatted, MyREST.ErrorNumber, MyREST.ErrorDescription)

            DialogOutput.Text = "Error"
            DialogOutput.TextBoxOutput.Text = ResponseMessage
            DialogOutput.ShowDialog(Me)
        End If

        sender.Enabled = True
    End Sub

    Private Sub ButtonDeleteObject_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonDeleteObject.Click
        sender.Enabled = False

        'The following code deletes an object in a bucket.  If versioning on the bucket is enabled,
        'the call will replace the object with a Delete Marker.

        'DELETE Object: http://docs.amazonwebservices.com/AmazonS3/latest/API/RESTObjectDELETE.html

        Dim MyDialogResult As System.Windows.Forms.DialogResult
        MyDialogResult = MessageBox.Show("Are you sure you would like to delete the object " & TextBoxObjectKeyName.Text & "?", "Delete Object", MessageBoxButtons.YesNo, MessageBoxIcon.Question, MessageBoxDefaultButton.Button1)

        If MyDialogResult = System.Windows.Forms.DialogResult.Yes Then

            Dim MyREST As New SprightlySoftAWS.REST

            Dim RequestURL As String
            RequestURL = MyREST.BuildS3RequestURL(True, "s3.amazonaws.com", TextBoxObjectBucketName.Text, TextBoxObjectKeyName.Text, "")

            Dim RequestMethod As String = "DELETE"

            Dim ExtraRequestHeaders As New Dictionary(Of String, String)
            ExtraRequestHeaders.Add("x-amz-date", DateTime.UtcNow.ToString("r"))

            Dim AuthorizationValue As String
            AuthorizationValue = MyREST.GetS3AuthorizationValue(RequestURL, RequestMethod, ExtraRequestHeaders, TextBoxAWSAccessKeyId.Text, TextBoxAWSSecretAccessKey.Text)
            ExtraRequestHeaders.Add("Authorization", AuthorizationValue)

            Dim RetBool As Boolean
            RetBool = MyREST.MakeRequest(RequestURL, RequestMethod, ExtraRequestHeaders, "")

            Debug.Print("")
            Debug.Print(MyREST.LogData)
            Debug.Print("")

            If RetBool = True Then
                MessageBox.Show("The object was deleted.", "Success", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Else
                Dim ResponseMessage As String
                ResponseMessage = FormatLogData(MyREST.RequestURL, MyREST.RequestMethod, MyREST.RequestHeaders, MyREST.ResponseStatusCode, MyREST.ResponseStatusDescription, MyREST.ResponseHeaders, MyREST.ResponseStringFormatted, MyREST.ErrorNumber, MyREST.ErrorDescription)

                DialogOutput.Text = "Error"
                DialogOutput.TextBoxOutput.Text = ResponseMessage
                DialogOutput.ShowDialog(Me)
            End If

        End If

        sender.Enabled = True
    End Sub

    Private Sub ButtonObjectExists_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonObjectExists.Click
        sender.Enabled = False

        'do a HEAD request on the object to see if it exists

        'HEAD Object: http://docs.amazonwebservices.com/AmazonS3/latest/API/RESTObjectHEAD.html

        Dim MyREST As New SprightlySoftAWS.REST

        Dim RequestURL As String
        RequestURL = MyREST.BuildS3RequestURL(True, "s3.amazonaws.com", TextBoxObjectBucketName.Text, TextBoxObjectKeyName.Text, "")

        Dim RequestMethod As String = "HEAD"

        Dim ExtraRequestHeaders As New Dictionary(Of String, String)
        ExtraRequestHeaders.Add("x-amz-date", DateTime.UtcNow.ToString("r"))

        Dim AuthorizationValue As String
        AuthorizationValue = MyREST.GetS3AuthorizationValue(RequestURL, RequestMethod, ExtraRequestHeaders, TextBoxAWSAccessKeyId.Text, TextBoxAWSSecretAccessKey.Text)
        ExtraRequestHeaders.Add("Authorization", AuthorizationValue)

        Dim RetBool As Boolean
        RetBool = MyREST.MakeRequest(RequestURL, RequestMethod, ExtraRequestHeaders, "")

        Debug.Print("")
        Debug.Print(MyREST.LogData)
        Debug.Print("")

        If MyREST.ResponseStatusCode = 200 Then
            MessageBox.Show("The object exists, you have permission to it.", "Success", MessageBoxButtons.OK, MessageBoxIcon.Information)
        ElseIf MyREST.ResponseStatusCode = 404 Then
            MessageBox.Show("The object does not exists.", "Success", MessageBoxButtons.OK, MessageBoxIcon.Information)
        ElseIf MyREST.ResponseStatusCode = 403 Then
            MessageBox.Show("Permission error.  Someone else owns the object or your access keys are invalid.", "Error", MessageBoxButtons.OK, MessageBoxIcon.Information)
        Else
            Dim ResponseMessage As String
            ResponseMessage = FormatLogData(MyREST.RequestURL, MyREST.RequestMethod, MyREST.RequestHeaders, MyREST.ResponseStatusCode, MyREST.ResponseStatusDescription, MyREST.ResponseHeaders, MyREST.ResponseStringFormatted, MyREST.ErrorNumber, MyREST.ErrorDescription)

            DialogOutput.Text = "Error"
            DialogOutput.TextBoxOutput.Text = ResponseMessage
            DialogOutput.ShowDialog(Me)
        End If

        sender.Enabled = True
    End Sub

    Private Sub ButtonGetObjectACLs_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonGetObjectACLs.Click
        sender.Enabled = False

        'GET Object acl: http://docs.amazonwebservices.com/AmazonS3/latest/API/RESTObjectGETacl.html

        Dim XmlDoc As System.Xml.XmlDocument
        Dim MyXmlNamespaceManager As System.Xml.XmlNamespaceManager
        Dim XmlNode As System.Xml.XmlNode
        Dim XmlContentsNodeList As System.Xml.XmlNodeList
        Dim ResponseMessage As String = ""

        Dim MyREST As New SprightlySoftAWS.REST

        Dim RequestURL As String
        RequestURL = MyREST.BuildS3RequestURL(True, "s3.amazonaws.com", TextBoxObjectBucketName.Text, TextBoxObjectKeyName.Text, "?acl")

        Dim RequestMethod As String = "GET"

        Dim ExtraRequestHeaders As New Dictionary(Of String, String)
        ExtraRequestHeaders.Add("x-amz-date", DateTime.UtcNow.ToString("r"))

        Dim AuthorizationValue As String
        AuthorizationValue = MyREST.GetS3AuthorizationValue(RequestURL, RequestMethod, ExtraRequestHeaders, TextBoxAWSAccessKeyId.Text, TextBoxAWSSecretAccessKey.Text)
        ExtraRequestHeaders.Add("Authorization", AuthorizationValue)

        Dim RetBool As Boolean
        RetBool = MyREST.MakeRequest(RequestURL, RequestMethod, ExtraRequestHeaders, "")

        Debug.Print("")
        Debug.Print(MyREST.LogData)
        Debug.Print("")

        If RetBool = True Then

            XmlDoc = New System.Xml.XmlDocument
            XmlDoc.LoadXml(MyREST.ResponseString)

            MyXmlNamespaceManager = New System.Xml.XmlNamespaceManager(XmlDoc.NameTable)
            MyXmlNamespaceManager.AddNamespace("amz", "http://s3.amazonaws.com/doc/2006-03-01/")

            XmlContentsNodeList = XmlDoc.SelectNodes("/amz:AccessControlPolicy/amz:AccessControlList/amz:Grant", MyXmlNamespaceManager)

            For Each XmlContentsNode As System.Xml.XmlNode In XmlContentsNodeList

                XmlNode = XmlContentsNode.SelectSingleNode("./amz:Grantee", MyXmlNamespaceManager)

                If XmlNode.Attributes("xsi:type").Value = "CanonicalUser" Then
                    XmlNode = XmlContentsNode.SelectSingleNode("./amz:Grantee/amz:ID", MyXmlNamespaceManager)
                    ResponseMessage = ResponseMessage & "CanonicalUser.ID = " & XmlNode.InnerText & vbCrLf
                    XmlNode = XmlContentsNode.SelectSingleNode("./amz:Grantee/amz:DisplayName", MyXmlNamespaceManager)
                    ResponseMessage = ResponseMessage & "CanonicalUser.DisplayName = " & XmlNode.InnerText & vbCrLf
                    XmlNode = XmlContentsNode.SelectSingleNode("./amz:Permission", MyXmlNamespaceManager)
                    ResponseMessage = ResponseMessage & "Permission = " & XmlNode.InnerText & vbCrLf
                    ResponseMessage = ResponseMessage & vbCrLf

                ElseIf XmlNode.Attributes("xsi:type").Value = "AmazonCustomerByEmail" Then
                    XmlNode = XmlContentsNode.SelectSingleNode("./amz:Grantee/amz:EmailAddress", MyXmlNamespaceManager)
                    ResponseMessage = ResponseMessage & "AmazonCustomerByEmail.EmailAddress = " & XmlNode.InnerText & vbCrLf
                    XmlNode = XmlContentsNode.SelectSingleNode("./amz:Permission", MyXmlNamespaceManager)
                    ResponseMessage = ResponseMessage & "Permission = " & XmlNode.InnerText & vbCrLf
                    ResponseMessage = ResponseMessage & vbCrLf

                ElseIf XmlNode.Attributes("xsi:type").Value = "Group" Then
                    XmlNode = XmlContentsNode.SelectSingleNode("./amz:Grantee/amz:URI", MyXmlNamespaceManager)
                    ResponseMessage = ResponseMessage & "Group.URI = " & XmlNode.InnerText & vbCrLf
                    XmlNode = XmlContentsNode.SelectSingleNode("./amz:Permission", MyXmlNamespaceManager)
                    ResponseMessage = ResponseMessage & "Permission = " & XmlNode.InnerText & vbCrLf
                    ResponseMessage = ResponseMessage & vbCrLf

                End If

            Next

            DialogOutput.Text = "Success"
            DialogOutput.TextBoxOutput.Text = ResponseMessage
            DialogOutput.ShowDialog(Me)

        Else
            ResponseMessage = FormatLogData(MyREST.RequestURL, MyREST.RequestMethod, MyREST.RequestHeaders, MyREST.ResponseStatusCode, MyREST.ResponseStatusDescription, MyREST.ResponseHeaders, MyREST.ResponseStringFormatted, MyREST.ErrorNumber, MyREST.ErrorDescription)

            DialogOutput.Text = "Error"
            DialogOutput.TextBoxOutput.Text = ResponseMessage
            DialogOutput.ShowDialog(Me)
        End If

        sender.Enabled = True
    End Sub

    Private Sub ButtonSetObjectACLs_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonSetObjectACLs.Click
        sender.Enabled = False

        'PUT Object acl: http://docs.amazonwebservices.com/AmazonS3/latest/API/RESTObjectPUTacl.html

        Dim MyDialogResult As System.Windows.Forms.DialogResult
        MyDialogResult = MessageBox.Show("Would you like everyone to have the permission to download this object?", "Set ACLs", MessageBoxButtons.YesNo, MessageBoxIcon.Question, MessageBoxDefaultButton.Button1)

        Dim MyREST As New SprightlySoftAWS.REST

        Dim RequestURL As String
        RequestURL = MyREST.BuildS3RequestURL(True, "s3.amazonaws.com", TextBoxObjectBucketName.Text, TextBoxObjectKeyName.Text, "?acl")

        Dim RequestMethod As String = "GET"

        Dim ExtraRequestHeaders As New Dictionary(Of String, String)
        ExtraRequestHeaders.Add("x-amz-date", DateTime.UtcNow.ToString("r"))

        Dim AuthorizationValue As String
        AuthorizationValue = MyREST.GetS3AuthorizationValue(RequestURL, RequestMethod, ExtraRequestHeaders, TextBoxAWSAccessKeyId.Text, TextBoxAWSSecretAccessKey.Text)
        ExtraRequestHeaders.Add("Authorization", AuthorizationValue)

        'get the owner of the object.  It will be used when constructing the Access Control List.
        Dim RetBool As Boolean
        RetBool = MyREST.MakeRequest(RequestURL, RequestMethod, ExtraRequestHeaders, "")

        Dim XmlDoc As System.Xml.XmlDocument
        Dim MyXmlNamespaceManager As System.Xml.XmlNamespaceManager
        Dim XmlNode As System.Xml.XmlNode

        If RetBool = True Then
            XmlDoc = New System.Xml.XmlDocument
            XmlDoc.LoadXml(MyREST.ResponseString)

            MyXmlNamespaceManager = New System.Xml.XmlNamespaceManager(XmlDoc.NameTable)
            MyXmlNamespaceManager.AddNamespace("amz", "http://s3.amazonaws.com/doc/2006-03-01/")

            XmlNode = XmlDoc.SelectSingleNode("/amz:AccessControlPolicy/amz:Owner/amz:ID", MyXmlNamespaceManager)

            'construct an Access Control List.  Grant the AllUsers group READ permission.
            'Access Control Lists: http://docs.amazonwebservices.com/AmazonS3/latest/S3_ACLs.html

            Dim PutXML As String = ""
            PutXML = PutXML & "<?xml version=""1.0"" encoding=""UTF-8""?>"
            PutXML = PutXML & "<AccessControlPolicy xmlns=""http://s3.amazonaws.com/doc/2006-03-01/"">"
            PutXML = PutXML & "<Owner>"
            PutXML = PutXML & "<ID>" & XmlNode.InnerText & "</ID>"
            PutXML = PutXML & "</Owner>"
            PutXML = PutXML & "<AccessControlList>"
            PutXML = PutXML & "<Grant>"
            PutXML = PutXML & "<Grantee xmlns:xsi=""http://www.w3.org/2001/XMLSchema-instance"" xsi:type=""CanonicalUser"">"
            PutXML = PutXML & "<ID>" & XmlNode.InnerText & "</ID>"
            PutXML = PutXML & "</Grantee>"
            PutXML = PutXML & "<Permission>FULL_CONTROL</Permission>"
            PutXML = PutXML & "</Grant>"
            If MyDialogResult = System.Windows.Forms.DialogResult.Yes Then
                PutXML = PutXML & "<Grant>"
                PutXML = PutXML & "<Grantee xmlns:xsi=""http://www.w3.org/2001/XMLSchema-instance"" xsi:type=""Group"">"
                PutXML = PutXML & "<URI>http://acs.amazonaws.com/groups/global/AllUsers</URI>"
                PutXML = PutXML & "</Grantee>"
                PutXML = PutXML & "<Permission>READ</Permission>"
                PutXML = PutXML & "</Grant>"
            End If
            PutXML = PutXML & "</AccessControlList>"
            PutXML = PutXML & "</AccessControlPolicy>"

            RequestMethod = "PUT"

            RequestURL = MyREST.BuildS3RequestURL(True, "s3.amazonaws.com", TextBoxObjectBucketName.Text, TextBoxObjectKeyName.Text, "?acl")

            ExtraRequestHeaders = New Dictionary(Of String, String)
            ExtraRequestHeaders.Add("x-amz-date", DateTime.UtcNow.ToString("r"))
            AuthorizationValue = MyREST.GetS3AuthorizationValue(RequestURL, RequestMethod, ExtraRequestHeaders, TextBoxAWSAccessKeyId.Text, TextBoxAWSSecretAccessKey.Text)
            ExtraRequestHeaders.Add("Authorization", AuthorizationValue)

            RetBool = MyREST.MakeRequest(RequestURL, RequestMethod, ExtraRequestHeaders, PutXML)

            Debug.Print("")
            Debug.Print(MyREST.LogData)
            Debug.Print("")

            If RetBool = True Then
                MessageBox.Show("ACLs were set on the object.", "Success", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Else
                Dim ResponseMessage As String
                ResponseMessage = FormatLogData(MyREST.RequestURL, MyREST.RequestMethod, MyREST.RequestHeaders, MyREST.ResponseStatusCode, MyREST.ResponseStatusDescription, MyREST.ResponseHeaders, MyREST.ResponseStringFormatted, MyREST.ErrorNumber, MyREST.ErrorDescription)

                DialogOutput.Text = "Error"
                DialogOutput.TextBoxOutput.Text = ResponseMessage
                DialogOutput.ShowDialog(Me)
            End If

        Else
            Dim ResponseMessage As String
            ResponseMessage = FormatLogData(MyREST.RequestURL, MyREST.RequestMethod, MyREST.RequestHeaders, MyREST.ResponseStatusCode, MyREST.ResponseStatusDescription, MyREST.ResponseHeaders, MyREST.ResponseStringFormatted, MyREST.ErrorNumber, MyREST.ErrorDescription)

            DialogOutput.Text = "Error"
            DialogOutput.TextBoxOutput.Text = ResponseMessage
            DialogOutput.ShowDialog(Me)
        End If

        sender.Enabled = True
    End Sub

    Private Sub ButtonCopyObject_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonCopyObject.Click
        sender.Enabled = False

        'Copying Amazon S3 Objects: http://docs.amazonwebservices.com/AmazonS3/latest/UsingCopyingObjects.html
        'PUT Object (Copy): http://docs.amazonwebservices.com/AmazonS3/latest/API/RESTObjectCOPY.html

        'This is a simple implementation of copying an object.  A more complete implementation would do the following:
        '  check if the destination file exists and prompt the user if they would like to overwrite it
        '  get the ACLs from the source file and apply them to the new file

        Dim NewKeyName As String
        NewKeyName = TextBoxObjectKeyName.Text & "(1)"
        NewKeyName = InputBox("Enter the new key name.", "Copy Object", NewKeyName)

        If NewKeyName <> "" Then
            Dim ExtraRequestHeaders As New Dictionary(Of String, String)
            ExtraRequestHeaders.Add("x-amz-copy-source", "/" & TextBoxObjectBucketName.Text & "/" & TextBoxObjectKeyName.Text)
            ExtraRequestHeaders.Add("x-amz-metadata-directive", "COPY")  'use this request header to copy the metadata and extra headers

            Dim MyREST As New SprightlySoftAWS.REST

            Dim RequestURL As String
            RequestURL = MyREST.BuildS3RequestURL(True, "s3.amazonaws.com", TextBoxObjectBucketName.Text, NewKeyName, "")

            Dim RequestMethod As String = "PUT"

            ExtraRequestHeaders.Add("x-amz-date", DateTime.UtcNow.ToString("r"))

            Dim AuthorizationValue As String
            AuthorizationValue = MyREST.GetS3AuthorizationValue(RequestURL, RequestMethod, ExtraRequestHeaders, TextBoxAWSAccessKeyId.Text, TextBoxAWSSecretAccessKey.Text)
            ExtraRequestHeaders.Add("Authorization", AuthorizationValue)

            Dim RetBool As Boolean
            RetBool = MyREST.MakeRequest(RequestURL, RequestMethod, ExtraRequestHeaders, "")

            Debug.Print("")
            Debug.Print(MyREST.LogData)
            Debug.Print("")

            Dim XmlDoc As System.Xml.XmlDocument
            Dim MyXmlNamespaceManager As System.Xml.XmlNamespaceManager
            Dim XmlNode As System.Xml.XmlNode
            Dim ResponseMessage As String = ""

            If RetBool = True Then

                XmlDoc = New System.Xml.XmlDocument
                XmlDoc.LoadXml(MyREST.ResponseString)

                MyXmlNamespaceManager = New System.Xml.XmlNamespaceManager(XmlDoc.NameTable)
                MyXmlNamespaceManager.AddNamespace("amz", "http://s3.amazonaws.com/doc/2006-03-01/")

                XmlNode = XmlDoc.SelectSingleNode("/amz:CopyObjectResult/amz:LastModified", MyXmlNamespaceManager)
                ResponseMessage = ResponseMessage & "LastModified = " & XmlNode.InnerText & vbCrLf

                XmlNode = XmlDoc.SelectSingleNode("/amz:CopyObjectResult/amz:ETag", MyXmlNamespaceManager)
                ResponseMessage = ResponseMessage & "ETag = " & XmlNode.InnerText & vbCrLf

                DialogOutput.Text = "Success"
                DialogOutput.TextBoxOutput.Text = ResponseMessage
                DialogOutput.ShowDialog(Me)

            Else
                ResponseMessage = FormatLogData(MyREST.RequestURL, MyREST.RequestMethod, MyREST.RequestHeaders, MyREST.ResponseStatusCode, MyREST.ResponseStatusDescription, MyREST.ResponseHeaders, MyREST.ResponseStringFormatted, MyREST.ErrorNumber, MyREST.ErrorDescription)

                DialogOutput.Text = "Error"
                DialogOutput.TextBoxOutput.Text = ResponseMessage
                DialogOutput.ShowDialog(Me)
            End If

        End If

        sender.Enabled = True
    End Sub

    Private Sub ButtonSetObjectMetadata_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonSetObjectMetadata.Click
        sender.Enabled = False

        Dim MetadataValue As String
        MetadataValue = InputBox("Enter the value for a metadata key named x-amz-meta-mymetadata.", "Set Metadata")

        If MetadataValue <> "" Then

            'Metadata: http://docs.amazonwebservices.com/AmazonS3/latest/UsingMetadata.html
            'PUT Object (Copy): http://docs.amazonwebservices.com/AmazonS3/latest/API/RESTObjectCOPY.html
            'To update the metadata you basically copy the object and supply new metadata.  The source key name and destination key name will be the same.
            'A more complete implementation would get the ACLs before copying the object and set the ACLs after copying the object.

            Dim ExtraRequestHeaders As New Dictionary(Of String, String)
            ExtraRequestHeaders.Add("x-amz-copy-source", "/" & TextBoxObjectBucketName.Text & "/" & Uri.EscapeDataString(TextBoxObjectKeyName.Text))
            ExtraRequestHeaders.Add("x-amz-metadata-directive", "REPLACE")  'use this directive to replace the metadata and custom HTTP headers

            'add your metadata headers here.
            ExtraRequestHeaders.Add("x-amz-meta-mymetadata", MetadataValue)
            'ExtraRequestHeaders.Add("Content-Type", "text/plain")  'you can add custom HTTP headers such as Content-Type here.

            Dim MyREST As New SprightlySoftAWS.REST

            Dim RequestURL As String
            RequestURL = MyREST.BuildS3RequestURL(True, "s3.amazonaws.com", TextBoxObjectBucketName.Text, TextBoxObjectKeyName.Text, "")

            Dim RequestMethod As String = "PUT"

            ExtraRequestHeaders.Add("x-amz-date", DateTime.UtcNow.ToString("r"))

            Dim AuthorizationValue As String
            AuthorizationValue = MyREST.GetS3AuthorizationValue(RequestURL, RequestMethod, ExtraRequestHeaders, TextBoxAWSAccessKeyId.Text, TextBoxAWSSecretAccessKey.Text)
            ExtraRequestHeaders.Add("Authorization", AuthorizationValue)

            Dim RetBool As Boolean
            RetBool = MyREST.MakeRequest(RequestURL, RequestMethod, ExtraRequestHeaders, "")

            Debug.Print("")
            Debug.Print(MyREST.LogData)
            Debug.Print("")

            Dim XmlDoc As System.Xml.XmlDocument
            Dim MyXmlNamespaceManager As System.Xml.XmlNamespaceManager
            Dim XmlNode As System.Xml.XmlNode
            Dim ResponseMessage As String

            If RetBool = True Then
                XmlDoc = New System.Xml.XmlDocument
                XmlDoc.LoadXml(MyREST.ResponseString)

                MyXmlNamespaceManager = New System.Xml.XmlNamespaceManager(XmlDoc.NameTable)
                MyXmlNamespaceManager.AddNamespace("amz", "http://s3.amazonaws.com/doc/2006-03-01/")

                ResponseMessage = "The metadata has been updated."

                XmlNode = XmlDoc.SelectSingleNode("/amz:CopyObjectResult/amz:LastModified", MyXmlNamespaceManager)
                Debug.Print("LastModified=" & XmlNode.InnerText)

                XmlNode = XmlDoc.SelectSingleNode("/amz:CopyObjectResult/amz:ETag", MyXmlNamespaceManager)
                Debug.Print("ETag=" & XmlNode.InnerText)

                MessageBox.Show(ResponseMessage, "Success", MessageBoxButtons.OK, MessageBoxIcon.Information)

            Else
                ResponseMessage = FormatLogData(MyREST.RequestURL, MyREST.RequestMethod, MyREST.RequestHeaders, MyREST.ResponseStatusCode, MyREST.ResponseStatusDescription, MyREST.ResponseHeaders, MyREST.ResponseStringFormatted, MyREST.ErrorNumber, MyREST.ErrorDescription)

                DialogOutput.Text = "Error"
                DialogOutput.TextBoxOutput.Text = ResponseMessage
                DialogOutput.ShowDialog(Me)
            End If

        End If

        sender.Enabled = True
    End Sub

    Private Sub ButtonGenerateURL_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonGenerateURL.Click
        sender.Enabled = False

        'You would generate a URL if you want to share a file but the AllUsers group does not have read permission to the object.
        'The following exampe creates a URL that is valid for 1 day.

        'Query String Authentication: http://docs.amazonwebservices.com/AmazonS3/latest/S3_QSAuth.html
        'Query String Request Authentication Alternative: http://docs.amazonwebservices.com/AmazonS3/latest/dev/RESTAuthentication.html#RESTAuthenticationQueryStringAuth

        Dim MyS3Helper As New SprightlySoftAWS.S3.Helper

        Dim ExpiresURL As String
        ExpiresURL = MyS3Helper.BuildExpiresURL(False, "s3.amazonaws.com", TextBoxObjectBucketName.Text, TextBoxObjectKeyName.Text, "", DateAdd(DateInterval.Day, 1, Now), TextBoxAWSAccessKeyId.Text, TextBoxAWSSecretAccessKey.Text)

        DialogOutput.Text = "Success"
        DialogOutput.TextBoxOutput.Text = ExpiresURL
        DialogOutput.ShowDialog(Me)

        sender.Enabled = True
    End Sub

    Private Sub ButtonUploadBrowse_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonUploadBrowse.Click
        Dim OpenFileDialog As New System.Windows.Forms.OpenFileDialog
        OpenFileDialog.Multiselect = False
        OpenFileDialog.FileName = ""
        OpenFileDialog.ShowDialog()

        If OpenFileDialog.FileName <> "" Then
            If System.IO.File.Exists(OpenFileDialog.FileName) = True Then

                TextBoxUploadFileName.Text = OpenFileDialog.FileName
                TextBoxUploadKeyName.Text = System.IO.Path.GetFileName(OpenFileDialog.FileName)

                'set the content type from the file's extension
                'the SprightlySoftS3 Helper class contains a function that returns a dictionary of extensions and associated content types
                Dim MyS3Helper As New SprightlySoftAWS.S3.Helper
                Dim ContentTypesDictionary As Dictionary(Of String, String)
                ContentTypesDictionary = MyS3Helper.GetContentTypesDictionary

                Dim MyExtension As String
                MyExtension = LCase(System.IO.Path.GetExtension(OpenFileDialog.FileName))

                If ContentTypesDictionary.ContainsKey(MyExtension) = True Then
                    TextBoxUploadContentType.Text = ContentTypesDictionary(MyExtension)
                Else
                    TextBoxUploadContentType.Text = ""
                End If

            End If
        End If
    End Sub

    Private Sub ButtonUploadFile_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonUploadFile.Click
        sender.Enabled = False

        If System.IO.File.Exists(TextBoxUploadFileName.Text) = True Then

            'PUT Object: http://docs.amazonwebservices.com/AmazonS3/latest/API/RESTObjectPUT.html

            Dim ExtraRequestHeaders As New Dictionary(Of String, String)

            If TextBoxUploadContentType.Text <> "" Then
                ExtraRequestHeaders.Add("Content-Type", TextBoxUploadContentType.Text)
            End If

            If CheckBoxUploadMakePublic.Checked = True Then
                'add a x-amz-acl header with the value of public-read to make the uploaded file public
                'PUT Object acl: http://docs.amazonwebservices.com/AmazonS3/latest/API/RESTObjectPUTacl.html
                ExtraRequestHeaders.Add("x-amz-acl", "public-read")
            End If

            If CheckBoxUploadUseSSE.Checked = True Then
                'Specifying Server-Side Encryption Using REST API: http://docs.amazonwebservices.com/AmazonS3/latest/dev/SSEUsingRESTAPI.html
                ExtraRequestHeaders.Add("x-amz-server-side-encryption", "AES256")
            End If

            If ComboBoxUploadStorageClass.Text = "REDUCED_REDUNDANCY" Then
                'add a x-amz-storage-class header with the value of REDUCED_REDUNDANCY to make the uploaded file reduced redundancy
                ExtraRequestHeaders.Add("x-amz-storage-class", "REDUCED_REDUNDANCY")
            End If


            'add a Content-MD5 header to ensure data is not corrupted over the network
            'Amazon will return an error if the MD5 they calulate does not match the MD5 you send
            Dim MyCalculateHash As New SprightlySoftAWS.S3.CalculateHash

            Dim MyMD5 As String
            MyMD5 = MyCalculateHash.CalculateMD5FromFile(TextBoxUploadFileName.Text)
            ExtraRequestHeaders.Add("Content-MD5", MyMD5)

            Dim MyUpload As New SprightlySoftAWS.S3.Upload

            Dim RequestURL As String
            RequestURL = MyUpload.BuildS3RequestURL(True, "s3.amazonaws.com", TextBoxUploadBucketName.Text, TextBoxUploadKeyName.Text, "")

            Dim RequestMethod As String = "PUT"

            ExtraRequestHeaders.Add("x-amz-date", DateTime.UtcNow.ToString("r"))

            Dim AuthorizationValue As String
            AuthorizationValue = MyUpload.GetS3AuthorizationValue(RequestURL, RequestMethod, ExtraRequestHeaders, TextBoxAWSAccessKeyId.Text, TextBoxAWSSecretAccessKey.Text)
            ExtraRequestHeaders.Add("Authorization", AuthorizationValue)

            Dim RetBool As Boolean
            RetBool = MyUpload.UploadFile(RequestURL, RequestMethod, ExtraRequestHeaders, TextBoxUploadFileName.Text)

            Debug.Print("")
            Debug.Print(MyUpload.LogData)
            Debug.Print("")

            If RetBool = True Then
                MessageBox.Show("Upload complete.", "Success", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Else
                Dim ResponseMessage As String
                ResponseMessage = FormatLogData(MyUpload.RequestURL, MyUpload.RequestMethod, MyUpload.RequestHeaders, MyUpload.ResponseStatusCode, MyUpload.ResponseStatusDescription, MyUpload.ResponseHeaders, MyUpload.ResponseStringFormatted, MyUpload.ErrorNumber, MyUpload.ErrorDescription)

                DialogOutput.Text = "Error"
                DialogOutput.TextBoxOutput.Text = ResponseMessage
                DialogOutput.ShowDialog(Me)
            End If

        Else
            MessageBox.Show("The local file does not exist.", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End If


        sender.Enabled = True
    End Sub

    Private Sub ButtonDownloadFile_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonDownloadFile.Click
        sender.Enabled = False

        If System.IO.Directory.Exists(System.IO.Path.GetDirectoryName(TextBoxDownloadFileName.Text)) = True Then

            'GET Object: http://docs.amazonwebservices.com/AmazonS3/latest/API/RESTObjectGET.html

            Dim MyDownload As New SprightlySoftAWS.S3.Download

            Dim RequestURL As String
            RequestURL = MyDownload.BuildS3RequestURL(True, "s3.amazonaws.com", TextBoxDownloadBucketName.Text, TextBoxDownloadKeyName.Text, "")

            Dim RequestMethod As String = "GET"

            Dim ExtraRequestHeaders As New Dictionary(Of String, String)
            ExtraRequestHeaders.Add("x-amz-date", DateTime.UtcNow.ToString("r"))

            Dim AuthorizationValue As String
            AuthorizationValue = MyDownload.GetS3AuthorizationValue(RequestURL, RequestMethod, ExtraRequestHeaders, TextBoxAWSAccessKeyId.Text, TextBoxAWSSecretAccessKey.Text)
            ExtraRequestHeaders.Add("Authorization", AuthorizationValue)

            Dim RetBool As Boolean
            RetBool = MyDownload.DownloadFile(RequestURL, RequestMethod, ExtraRequestHeaders, TextBoxDownloadFileName.Text, False)

            Debug.Print("")
            Debug.Print(MyDownload.LogData)
            Debug.Print("")

            If RetBool = True Then
                MessageBox.Show("Download complete.", "Success", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Else
                Dim ResponseMessage As String
                ResponseMessage = FormatLogData(MyDownload.RequestURL, MyDownload.RequestMethod, MyDownload.RequestHeaders, MyDownload.ResponseStatusCode, MyDownload.ResponseStatusDescription, MyDownload.ResponseHeaders, MyDownload.ResponseStringFormatted, MyDownload.ErrorNumber, MyDownload.ErrorDescription)

                DialogOutput.Text = "Error"
                DialogOutput.TextBoxOutput.Text = ResponseMessage
                DialogOutput.ShowDialog(Me)
            End If

        Else
            MessageBox.Show("The local file path does not exist.", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End If

        sender.Enabled = True
    End Sub

    Private Sub ButtonHashBrowse_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonHashBrowse.Click
        Dim OpenFileDialog As New System.Windows.Forms.OpenFileDialog
        OpenFileDialog.Multiselect = False
        OpenFileDialog.FileName = ""
        OpenFileDialog.ShowDialog()
        If OpenFileDialog.FileName <> "" Then
            If System.IO.File.Exists(OpenFileDialog.FileName) = True Then
                TextBoxHashFileName.Text = OpenFileDialog.FileName
            End If
        End If
    End Sub

    Private Sub ButtonCalculateETag_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonCalculateETag.Click
        sender.Enabled = False

        Dim MyCalculateHash As New SprightlySoftAWS.S3.CalculateHash

        Dim ResponseValue As String
        ResponseValue = MyCalculateHash.CalculateETagFromFile(TextBoxHashFileName.Text)

        Debug.Print("")
        Debug.Print(MyCalculateHash.LogData)
        Debug.Print("")

        If MyCalculateHash.ErrorNumber = 0 Then
            MessageBox.Show("ETag = " & ResponseValue, "Success", MessageBoxButtons.OK, MessageBoxIcon.Information)
        Else
            MessageBox.Show(MyCalculateHash.ErrorDescription, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End If

        sender.Enabled = True
    End Sub

    Private Sub ButtonCalculateMD5_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonCalculateMD5.Click
        sender.Enabled = False

        Dim MyCalculateHash As New SprightlySoftAWS.S3.CalculateHash

        Dim ResponseValue As String
        ResponseValue = MyCalculateHash.CalculateMD5FromFile(TextBoxHashFileName.Text)

        Debug.Print("")
        Debug.Print(MyCalculateHash.LogData)
        Debug.Print("")

        If MyCalculateHash.ErrorNumber = 0 Then
            MessageBox.Show("MD5 = " & ResponseValue, "Success", MessageBoxButtons.OK, MessageBoxIcon.Information)
        Else
            MessageBox.Show(MyCalculateHash.ErrorDescription, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End If

        sender.Enabled = True
    End Sub

    Private Sub ButtonVerGetProperties_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonVerGetProperties.Click
        sender.Enabled = False

        'You can get the properties for any version of an object.  Do a HEAD call on the object
        'and pass the versionID in the query string.

        'HEAD Object: http://docs.amazonwebservices.com/AmazonS3/latest/API/RESTObjectHEAD.html

        Dim MyREST As New SprightlySoftAWS.REST

        Dim QueryString As String
        QueryString = "?versionId=" & TextBoxVerVersionID.Text

        Dim RequestURL As String
        RequestURL = MyREST.BuildS3RequestURL(True, "s3.amazonaws.com", TextBoxVerBucketName.Text, TextBoxVerKeyName.Text, QueryString)

        Dim RequestMethod As String = "HEAD"

        Dim ExtraRequestHeaders As New Dictionary(Of String, String)
        ExtraRequestHeaders.Add("x-amz-date", DateTime.UtcNow.ToString("r"))

        Dim AuthorizationValue As String
        AuthorizationValue = MyREST.GetS3AuthorizationValue(RequestURL, RequestMethod, ExtraRequestHeaders, TextBoxAWSAccessKeyId.Text, TextBoxAWSSecretAccessKey.Text)
        ExtraRequestHeaders.Add("Authorization", AuthorizationValue)

        Dim RetBool As Boolean
        RetBool = MyREST.MakeRequest(RequestURL, RequestMethod, ExtraRequestHeaders, "")

        Debug.Print("")
        Debug.Print(MyREST.LogData)
        Debug.Print("")

        Dim ResponseMessage As String = ""

        If RetBool = True Then

            For Each MyKeyValuePair As KeyValuePair(Of String, String) In MyREST.ResponseHeaders
                If InStr(MyKeyValuePair.Key, "x-amz-") = 1 Then
                    If MyKeyValuePair.Key <> "x-amz-id-2" And MyKeyValuePair.Key <> "x-amz-request-id" Then  'Ignore the Amazon ID response headers.  They are included in every response and they could be used to troubleshoot issues on Amazon's end.
                        ResponseMessage = ResponseMessage & "Amazon header = " & MyKeyValuePair.Key & ":" & MyKeyValuePair.Value & vbCrLf
                    End If
                End If
            Next

            If MyREST.ResponseHeaders.ContainsKey("Cache-Control") = True Then
                ResponseMessage = ResponseMessage & "Cache-Control = " & MyREST.ResponseHeaders("Cache-Control") & vbCrLf
            End If

            If MyREST.ResponseHeaders.ContainsKey("Content-Disposition") = True Then
                ResponseMessage = ResponseMessage & "Content-Disposition = " & MyREST.ResponseHeaders("Content-Disposition") & vbCrLf
            End If

            If MyREST.ResponseHeaders.ContainsKey("Content-Encoding") = True Then
                ResponseMessage = ResponseMessage & "Content-Encoding = " & MyREST.ResponseHeaders("Content-Encoding") & vbCrLf
            End If

            If MyREST.ResponseHeaders.ContainsKey("Content-Language") = True Then
                ResponseMessage = ResponseMessage & "Content-Language = " & MyREST.ResponseHeaders("Content-Language") & vbCrLf
            End If

            If MyREST.ResponseHeaders.ContainsKey("Content-Type") = True Then
                ResponseMessage = ResponseMessage & "Content-Type = " & MyREST.ResponseHeaders("Content-Type") & vbCrLf
            End If

            If MyREST.ResponseHeaders.ContainsKey("Expires") = True Then
                ResponseMessage = ResponseMessage & "Expires = " & MyREST.ResponseHeaders("Expires") & vbCrLf
            End If

            If MyREST.ResponseHeaders.ContainsKey("Content-Length") = True Then
                ResponseMessage = ResponseMessage & "Content-Length = " & MyREST.ResponseHeaders("Content-Length") & vbCrLf
            End If

            If MyREST.ResponseHeaders.ContainsKey("Last-Modified") = True Then
                ResponseMessage = ResponseMessage & "Last-Modified = " & CDate(MyREST.ResponseHeaders("Last-Modified")) & vbCrLf
            End If

            If MyREST.ResponseHeaders.ContainsKey("ETag") = True Then
                ResponseMessage = ResponseMessage & "ETag = " & MyREST.ResponseHeaders("ETag") & vbCrLf
            End If

            DialogOutput.Text = "Success"
            DialogOutput.TextBoxOutput.Text = ResponseMessage
            DialogOutput.ShowDialog(Me)

        Else
            ResponseMessage = FormatLogData(MyREST.RequestURL, MyREST.RequestMethod, MyREST.RequestHeaders, MyREST.ResponseStatusCode, MyREST.ResponseStatusDescription, MyREST.ResponseHeaders, MyREST.ResponseStringFormatted, MyREST.ErrorNumber, MyREST.ErrorDescription)

            DialogOutput.Text = "Error"
            DialogOutput.TextBoxOutput.Text = ResponseMessage
            DialogOutput.ShowDialog(Me)
        End If

        sender.Enabled = True
    End Sub

    Private Sub ButtonVerDeleteVersion_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonVerDeleteVersion.Click
        sender.Enabled = False

        'You can delete any version of an object by specifying the versionId in the query string.
        'When you specify a versionId the version is permanently deleted.  You can also delete a 
        'Delete Marker with this call.

        'DELETE Object: http://docs.amazonwebservices.com/AmazonS3/latest/API/RESTObjectDELETE.html

        Dim MyDialogResult As System.Windows.Forms.DialogResult
        MyDialogResult = MessageBox.Show("Are you sure you would like to delete the version " & TextBoxVerKeyName.Text & "?", "Delete Object", MessageBoxButtons.YesNo, MessageBoxIcon.Question, MessageBoxDefaultButton.Button1)

        If MyDialogResult = System.Windows.Forms.DialogResult.Yes Then

            Dim MyREST As New SprightlySoftAWS.REST

            Dim QueryString As String
            QueryString = "?versionId=" & TextBoxVerVersionID.Text

            Dim RequestURL As String
            RequestURL = MyREST.BuildS3RequestURL(True, "s3.amazonaws.com", TextBoxVerBucketName.Text, TextBoxVerKeyName.Text, QueryString)

            Dim RequestMethod As String = "DELETE"

            Dim ExtraRequestHeaders As New Dictionary(Of String, String)
            ExtraRequestHeaders.Add("x-amz-date", DateTime.UtcNow.ToString("r"))

            Dim AuthorizationValue As String
            AuthorizationValue = MyREST.GetS3AuthorizationValue(RequestURL, RequestMethod, ExtraRequestHeaders, TextBoxAWSAccessKeyId.Text, TextBoxAWSSecretAccessKey.Text)
            ExtraRequestHeaders.Add("Authorization", AuthorizationValue)

            Dim RetBool As Boolean
            RetBool = MyREST.MakeRequest(RequestURL, RequestMethod, ExtraRequestHeaders, "")

            Debug.Print("")
            Debug.Print(MyREST.LogData)
            Debug.Print("")

            If RetBool = True Then
                MessageBox.Show("The version was deleted.", "Success", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Else
                Dim ResponseMessage As String
                ResponseMessage = FormatLogData(MyREST.RequestURL, MyREST.RequestMethod, MyREST.RequestHeaders, MyREST.ResponseStatusCode, MyREST.ResponseStatusDescription, MyREST.ResponseHeaders, MyREST.ResponseStringFormatted, MyREST.ErrorNumber, MyREST.ErrorDescription)

                DialogOutput.Text = "Error"
                DialogOutput.TextBoxOutput.Text = ResponseMessage
                DialogOutput.ShowDialog(Me)
            End If

        End If

        sender.Enabled = True
    End Sub


    Private Sub ButtonVerGetACLs_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonVerGetACLs.Click
        sender.Enabled = False

        'You can get the ACL of any version of an object by specifying the versionId in the query string.

        'GET Object acl: http://docs.amazonwebservices.com/AmazonS3/latest/API/RESTObjectGETacl.html

        Dim XmlDoc As System.Xml.XmlDocument
        Dim MyXmlNamespaceManager As System.Xml.XmlNamespaceManager
        Dim XmlNode As System.Xml.XmlNode
        Dim XmlContentsNodeList As System.Xml.XmlNodeList

        Dim MyREST As New SprightlySoftAWS.REST

        Dim QueryString As String
        QueryString = "?acl&versionId=" & TextBoxVerVersionID.Text

        Dim RequestURL As String
        RequestURL = MyREST.BuildS3RequestURL(True, "s3.amazonaws.com", TextBoxVerBucketName.Text, TextBoxVerKeyName.Text, QueryString)

        Dim RequestMethod As String = "GET"

        Dim ExtraRequestHeaders As New Dictionary(Of String, String)
        ExtraRequestHeaders.Add("x-amz-date", DateTime.UtcNow.ToString("r"))

        Dim AuthorizationValue As String
        AuthorizationValue = MyREST.GetS3AuthorizationValue(RequestURL, RequestMethod, ExtraRequestHeaders, TextBoxAWSAccessKeyId.Text, TextBoxAWSSecretAccessKey.Text)
        ExtraRequestHeaders.Add("Authorization", AuthorizationValue)

        Dim RetBool As Boolean
        RetBool = MyREST.MakeRequest(RequestURL, RequestMethod, ExtraRequestHeaders, "")

        Debug.Print("")
        Debug.Print(MyREST.LogData)
        Debug.Print("")

        If RetBool = True Then
            Dim ResponseMessage As String = ""

            XmlDoc = New System.Xml.XmlDocument
            XmlDoc.LoadXml(MyREST.ResponseString)

            MyXmlNamespaceManager = New System.Xml.XmlNamespaceManager(XmlDoc.NameTable)
            MyXmlNamespaceManager.AddNamespace("amz", "http://s3.amazonaws.com/doc/2006-03-01/")

            XmlContentsNodeList = XmlDoc.SelectNodes("/amz:AccessControlPolicy/amz:AccessControlList/amz:Grant", MyXmlNamespaceManager)

            For Each XmlContentsNode As System.Xml.XmlNode In XmlContentsNodeList

                XmlNode = XmlContentsNode.SelectSingleNode("./amz:Grantee", MyXmlNamespaceManager)

                If XmlNode.Attributes("xsi:type").Value = "CanonicalUser" Then
                    XmlNode = XmlContentsNode.SelectSingleNode("./amz:Grantee/amz:ID", MyXmlNamespaceManager)
                    ResponseMessage = ResponseMessage & "CanonicalUser.ID = " & XmlNode.InnerText & vbCrLf
                    XmlNode = XmlContentsNode.SelectSingleNode("./amz:Grantee/amz:DisplayName", MyXmlNamespaceManager)
                    ResponseMessage = ResponseMessage & "CanonicalUser.DisplayName = " & XmlNode.InnerText & vbCrLf
                    XmlNode = XmlContentsNode.SelectSingleNode("./amz:Permission", MyXmlNamespaceManager)
                    ResponseMessage = ResponseMessage & "Permission = " & XmlNode.InnerText & vbCrLf
                    ResponseMessage = ResponseMessage & vbCrLf

                ElseIf XmlNode.Attributes("xsi:type").Value = "AmazonCustomerByEmail" Then
                    XmlNode = XmlContentsNode.SelectSingleNode("./amz:Grantee/amz:EmailAddress", MyXmlNamespaceManager)
                    ResponseMessage = ResponseMessage & "AmazonCustomerByEmail.EmailAddress = " & XmlNode.InnerText & vbCrLf
                    XmlNode = XmlContentsNode.SelectSingleNode("./amz:Permission", MyXmlNamespaceManager)
                    ResponseMessage = ResponseMessage & "Permission = " & XmlNode.InnerText & vbCrLf
                    ResponseMessage = ResponseMessage & vbCrLf

                ElseIf XmlNode.Attributes("xsi:type").Value = "Group" Then
                    XmlNode = XmlContentsNode.SelectSingleNode("./amz:Grantee/amz:URI", MyXmlNamespaceManager)
                    ResponseMessage = ResponseMessage & "Group.URI = " & XmlNode.InnerText & vbCrLf
                    XmlNode = XmlContentsNode.SelectSingleNode("./amz:Permission", MyXmlNamespaceManager)
                    ResponseMessage = ResponseMessage & "Permission = " & XmlNode.InnerText & vbCrLf
                    ResponseMessage = ResponseMessage & vbCrLf

                End If

            Next

            DialogOutput.Text = "Success"
            DialogOutput.TextBoxOutput.Text = ResponseMessage
            DialogOutput.ShowDialog(Me)

        Else
            Dim ResponseMessage As String
            ResponseMessage = FormatLogData(MyREST.RequestURL, MyREST.RequestMethod, MyREST.RequestHeaders, MyREST.ResponseStatusCode, MyREST.ResponseStatusDescription, MyREST.ResponseHeaders, MyREST.ResponseStringFormatted, MyREST.ErrorNumber, MyREST.ErrorDescription)

            DialogOutput.Text = "Error"
            DialogOutput.TextBoxOutput.Text = ResponseMessage
            DialogOutput.ShowDialog(Me)
        End If

        sender.Enabled = True
    End Sub

    Private Sub ButtonVerGenerateURL_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonVerGenerateURL.Click
        sender.Enabled = False

        Dim MyS3Helper As New SprightlySoftAWS.S3.Helper

        Dim QueryString As String
        QueryString = "?versionId=" & TextBoxVerVersionID.Text

        Dim ExpiresURL As String
        ExpiresURL = MyS3Helper.BuildExpiresURL(False, "s3.amazonaws.com", TextBoxVerBucketName.Text, TextBoxVerKeyName.Text, QueryString, DateAdd(DateInterval.Day, 1, Now), TextBoxAWSAccessKeyId.Text, TextBoxAWSSecretAccessKey.Text)

        DialogOutput.Text = "Success"
        DialogOutput.TextBoxOutput.Text = ExpiresURL
        DialogOutput.ShowDialog(Me)

        sender.Enabled = True
    End Sub

    Private Sub ButtonVerCopyVersion_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonVerCopyVersion.Click
        sender.Enabled = False

        'PUT Object (Copy): http://docs.amazonwebservices.com/AmazonS3/latest/API/RESTObjectCOPY.html

        Dim NewKeyName As String
        NewKeyName = TextBoxVerKeyName.Text
        NewKeyName = InputBox("Enter the new key name.", "Copy Version", NewKeyName)

        If NewKeyName <> "" Then

            Dim QueryString As String
            QueryString = "?versionId=" & TextBoxVerVersionID.Text

            Dim ExtraRequestHeaders As New Dictionary(Of String, String)
            ExtraRequestHeaders.Add("x-amz-copy-source", "/" & TextBoxVerBucketName.Text & "/" & TextBoxVerKeyName.Text & QueryString)
            ExtraRequestHeaders.Add("x-amz-metadata-directive", "COPY")  'use this request header to copy the metadata and extra headers

            'uncomment the following line if you would like to set the copied file as reduced redundancy
            'ExtraRequestHeaders.Add("x-amz-storage-class", "REDUCED_REDUNDANCY")

            Dim MyREST As New SprightlySoftAWS.REST

            Dim RequestURL As String
            RequestURL = MyREST.BuildS3RequestURL(True, "s3.amazonaws.com", TextBoxVerBucketName.Text, NewKeyName, "")

            Dim RequestMethod As String = "PUT"

            ExtraRequestHeaders.Add("x-amz-date", DateTime.UtcNow.ToString("r"))

            Dim AuthorizationValue As String
            AuthorizationValue = MyREST.GetS3AuthorizationValue(RequestURL, RequestMethod, ExtraRequestHeaders, TextBoxAWSAccessKeyId.Text, TextBoxAWSSecretAccessKey.Text)
            ExtraRequestHeaders.Add("Authorization", AuthorizationValue)

            Dim RetBool As Boolean
            RetBool = MyREST.MakeRequest(RequestURL, RequestMethod, ExtraRequestHeaders, "")

            Debug.Print("")
            Debug.Print(MyREST.LogData)
            Debug.Print("")

            Dim XmlDoc As System.Xml.XmlDocument
            Dim MyXmlNamespaceManager As System.Xml.XmlNamespaceManager
            Dim XmlNode As System.Xml.XmlNode
            Dim ResponseMessage As String = ""

            If RetBool = True Then
                XmlDoc = New System.Xml.XmlDocument
                XmlDoc.LoadXml(MyREST.ResponseString)

                MyXmlNamespaceManager = New System.Xml.XmlNamespaceManager(XmlDoc.NameTable)
                MyXmlNamespaceManager.AddNamespace("amz", "http://s3.amazonaws.com/doc/2006-03-01/")

                XmlNode = XmlDoc.SelectSingleNode("/amz:CopyObjectResult/amz:LastModified", MyXmlNamespaceManager)
                ResponseMessage = ResponseMessage & "LastModified = " & XmlNode.InnerText & vbCrLf

                XmlNode = XmlDoc.SelectSingleNode("/amz:CopyObjectResult/amz:ETag", MyXmlNamespaceManager)
                ResponseMessage = ResponseMessage & "ETag = " & XmlNode.InnerText & vbCrLf

                DialogOutput.Text = "Success"
                DialogOutput.TextBoxOutput.Text = ResponseMessage
                DialogOutput.ShowDialog(Me)

            Else
                ResponseMessage = FormatLogData(MyREST.RequestURL, MyREST.RequestMethod, MyREST.RequestHeaders, MyREST.ResponseStatusCode, MyREST.ResponseStatusDescription, MyREST.ResponseHeaders, MyREST.ResponseStringFormatted, MyREST.ErrorNumber, MyREST.ErrorDescription)

                DialogOutput.Text = "Error"
                DialogOutput.TextBoxOutput.Text = ResponseMessage
                DialogOutput.ShowDialog(Me)
            End If

        End If

        sender.Enabled = True
    End Sub

    Private Sub ButtonMultiBrowse_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonMultiBrowse.Click
        Dim OpenFileDialog As New System.Windows.Forms.OpenFileDialog
        OpenFileDialog.Multiselect = False
        OpenFileDialog.FileName = ""
        OpenFileDialog.ShowDialog()

        If OpenFileDialog.FileName <> "" Then
            If System.IO.File.Exists(OpenFileDialog.FileName) = True Then

                TextBoxMultiFileName.Text = OpenFileDialog.FileName
                TextBoxMultiKeyName.Text = System.IO.Path.GetFileName(OpenFileDialog.FileName)

                'set the content type from the file's extension
                'the SprightlySoftS3 Helper class contains a function that returns a dictionary of extensions and associated content types
                Dim MyS3Helper As New SprightlySoftAWS.S3.Helper
                Dim ContentTypesDictionary As Dictionary(Of String, String)
                ContentTypesDictionary = MyS3Helper.GetContentTypesDictionary

                Dim MyExtension As String
                MyExtension = LCase(System.IO.Path.GetExtension(OpenFileDialog.FileName))

                If ContentTypesDictionary.ContainsKey(MyExtension) = True Then
                    TextBoxMultiContentType.Text = ContentTypesDictionary(MyExtension)
                Else
                    TextBoxMultiContentType.Text = ""
                End If

            End If
        End If
    End Sub

    Private Sub ButtonMultiInitiateUpload_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonMultiInitiateUpload.Click
        sender.Enabled = False

        'Initiate Multipart Upload: http://docs.amazonwebservices.com/AmazonS3/latest/API/mpUploadInitiate.html

        Dim MyREST As New SprightlySoftAWS.REST

        Dim QueryString As String
        QueryString = "?uploads"

        Dim RequestURL As String
        RequestURL = MyREST.BuildS3RequestURL(True, "s3.amazonaws.com", TextBoxMultiBucketName.Text, TextBoxMultiKeyName.Text, QueryString)

        Dim RequestMethod As String = "POST"

        Dim ExtraRequestHeaders As New Dictionary(Of String, String)

        If TextBoxMultiContentType.Text <> "" Then
            ExtraRequestHeaders.Add("Content-Type", TextBoxMultiContentType.Text)
        End If

        If CheckBoxMultiMakePublic.Checked = True Then
            'add a x-amz-acl header with the value of public-read to make the uploaded file public
            'REST Access Control Policy: http://docs.amazonwebservices.com/AmazonS3/2006-03-01/dev/RESTAccessPolicy.html
            ExtraRequestHeaders.Add("x-amz-acl", "public-read")
        End If

        If ComboBoxMultiStorageClass.Text = "REDUCED_REDUNDANCY" Then
            'add a x-amz-storage-class header with the value of REDUCED_REDUNDANCY to make the uploaded file reduced redundancy
            ExtraRequestHeaders.Add("x-amz-storage-class", "REDUCED_REDUNDANCY")
        End If

        ExtraRequestHeaders.Add("x-amz-date", DateTime.UtcNow.ToString("r"))

        Dim AuthorizationValue As String
        AuthorizationValue = MyREST.GetS3AuthorizationValue(RequestURL, RequestMethod, ExtraRequestHeaders, TextBoxAWSAccessKeyId.Text, TextBoxAWSSecretAccessKey.Text)
        ExtraRequestHeaders.Add("Authorization", AuthorizationValue)

        Dim RetBool As Boolean
        RetBool = MyREST.MakeRequest(RequestURL, RequestMethod, ExtraRequestHeaders, "")

        Debug.Print("")
        Debug.Print(MyREST.LogData)
        Debug.Print("")

        If RetBool = True Then
            Dim MyXmlDocument As System.Xml.XmlDocument
            Dim MyXmlNamespaceManager As System.Xml.XmlNamespaceManager
            Dim MyXmlNode As System.Xml.XmlNode

            MyXmlDocument = New System.Xml.XmlDocument
            MyXmlDocument.LoadXml(MyREST.ResponseString)

            MyXmlNamespaceManager = New System.Xml.XmlNamespaceManager(MyXmlDocument.NameTable)
            MyXmlNamespaceManager.AddNamespace("amz", "http://s3.amazonaws.com/doc/2006-03-01/")

            MyXmlNode = MyXmlDocument.SelectSingleNode("amz:InitiateMultipartUploadResult/amz:UploadId", MyXmlNamespaceManager)

            TextBoxMultiUploadId.Text = MyXmlNode.InnerText

            MessageBox.Show("The multipart upload has been initiated.  uploadId=" & TextBoxMultiUploadId.Text, "Success", MessageBoxButtons.OK, MessageBoxIcon.Information)
        Else
            Dim ResponseMessage As String
            ResponseMessage = FormatLogData(MyREST.RequestURL, MyREST.RequestMethod, MyREST.RequestHeaders, MyREST.ResponseStatusCode, MyREST.ResponseStatusDescription, MyREST.ResponseHeaders, MyREST.ResponseStringFormatted, MyREST.ErrorNumber, MyREST.ErrorDescription)

            DialogOutput.Text = "Error"
            DialogOutput.TextBoxOutput.Text = ResponseMessage
            DialogOutput.ShowDialog(Me)
        End If

        sender.Enabled = True
    End Sub

    Private Sub ButtonMultiGetUploadId_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonMultiGetUploadId.Click
        sender.Enabled = False

        'Get the uploadId based on the key name and bucket name.

        'List Multipart Uploads: http://docs.amazonwebservices.com/AmazonS3/latest/API/mpUploadListMPUpload.html

        Dim MyREST As New SprightlySoftAWS.REST

        Dim QueryString As String
        QueryString = "?uploads"

        Dim RequestURL As String
        RequestURL = MyREST.BuildS3RequestURL(True, "s3.amazonaws.com", TextBoxMultiBucketName.Text, "", QueryString)

        Dim RequestMethod As String = "GET"

        Dim ExtraRequestHeaders As New Dictionary(Of String, String)
        ExtraRequestHeaders.Add("x-amz-date", DateTime.UtcNow.ToString("r"))

        Dim AuthorizationValue As String
        AuthorizationValue = MyREST.GetS3AuthorizationValue(RequestURL, RequestMethod, ExtraRequestHeaders, TextBoxAWSAccessKeyId.Text, TextBoxAWSSecretAccessKey.Text)
        ExtraRequestHeaders.Add("Authorization", AuthorizationValue)

        Dim RetBool As Boolean
        RetBool = MyREST.MakeRequest(RequestURL, RequestMethod, ExtraRequestHeaders, "")

        Debug.Print("")
        Debug.Print(MyREST.LogData)
        Debug.Print("")

        If RetBool = True Then
            Dim MyXmlDocument As System.Xml.XmlDocument
            Dim MyXmlNamespaceManager As System.Xml.XmlNamespaceManager
            Dim MyXmlNode As System.Xml.XmlNode
            Dim MyXmlNodeList As System.Xml.XmlNodeList

            MyXmlDocument = New System.Xml.XmlDocument
            MyXmlDocument.LoadXml(MyREST.ResponseString)

            MyXmlNamespaceManager = New System.Xml.XmlNamespaceManager(MyXmlDocument.NameTable)
            MyXmlNamespaceManager.AddNamespace("amz", "http://s3.amazonaws.com/doc/2006-03-01/")

            MyXmlNodeList = MyXmlDocument.SelectNodes("amz:ListMultipartUploadsResult/amz:Upload", MyXmlNamespaceManager)

            Dim UploadId As String = ""

            For Each ItemXmlNode As System.Xml.XmlNode In MyXmlNodeList
                MyXmlNode = ItemXmlNode.SelectSingleNode("amz:Key", MyXmlNamespaceManager)

                If MyXmlNode.InnerText = TextBoxMultiKeyName.Text Then
                    MyXmlNode = ItemXmlNode.SelectSingleNode("amz:UploadId", MyXmlNamespaceManager)
                    UploadId = MyXmlNode.InnerText
                    TextBoxMultiUploadId.Text = UploadId
                    Exit For
                End If

            Next

            If UploadId = "" Then
                MessageBox.Show("A multipart upload does not exist for " & TextBoxMultiKeyName.Text & ".", "Success", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Else
                MessageBox.Show("A multipart upload exist for " & TextBoxMultiKeyName.Text & ".  uploadId=" & UploadId, "Success", MessageBoxButtons.OK, MessageBoxIcon.Information)
            End If


        Else
            Dim ResponseMessage As String
            ResponseMessage = FormatLogData(MyREST.RequestURL, MyREST.RequestMethod, MyREST.RequestHeaders, MyREST.ResponseStatusCode, MyREST.ResponseStatusDescription, MyREST.ResponseHeaders, MyREST.ResponseStringFormatted, MyREST.ErrorNumber, MyREST.ErrorDescription)

            DialogOutput.Text = "Error"
            DialogOutput.TextBoxOutput.Text = ResponseMessage
            DialogOutput.ShowDialog(Me)
        End If

        sender.Enabled = True
    End Sub

    Private Sub ButtonMultiUploadParts_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonMultiUploadParts.Click
        sender.Enabled = False

        If System.IO.File.Exists(TextBoxMultiFileName.Text) = True Then

            'List the parts of the upload.  This information will be used to skip any parts that have already been uploaded.

            Dim MyREST As New SprightlySoftAWS.REST

            Dim QueryString As String
            QueryString = "?uploadId=" & System.Uri.EscapeDataString(TextBoxMultiUploadId.Text)

            Dim RequestURL As String
            RequestURL = MyREST.BuildS3RequestURL(True, "s3.amazonaws.com", TextBoxMultiBucketName.Text, TextBoxMultiKeyName.Text, QueryString)

            Dim RequestMethod As String = "GET"

            Dim ExtraRequestHeaders As New Dictionary(Of String, String)
            ExtraRequestHeaders.Add("x-amz-date", DateTime.UtcNow.ToString("r"))

            Dim AuthorizationValue As String
            AuthorizationValue = MyREST.GetS3AuthorizationValue(RequestURL, RequestMethod, ExtraRequestHeaders, TextBoxAWSAccessKeyId.Text, TextBoxAWSSecretAccessKey.Text)
            ExtraRequestHeaders.Add("Authorization", AuthorizationValue)

            Dim RetBool As Boolean
            RetBool = MyREST.MakeRequest(RequestURL, RequestMethod, ExtraRequestHeaders)

            Debug.Print("")
            Debug.Print(MyREST.LogData)
            Debug.Print("")

            If RetBool = True Then

                Dim MyXmlDocument As System.Xml.XmlDocument
                Dim MyXmlNamespaceManager As System.Xml.XmlNamespaceManager
                Dim MyXmlNode As System.Xml.XmlNode

                MyXmlDocument = New System.Xml.XmlDocument
                MyXmlDocument.LoadXml(MyREST.ResponseString)

                MyXmlNamespaceManager = New System.Xml.XmlNamespaceManager(MyXmlDocument.NameTable)
                MyXmlNamespaceManager.AddNamespace("amz", "http://s3.amazonaws.com/doc/2006-03-01/")


                Dim PartSize As Long
                PartSize = 5242880  '5 MB is the minimum size of a part

                Dim MyFileInfo As System.IO.FileInfo
                MyFileInfo = New System.IO.FileInfo(TextBoxMultiFileName.Text)

                Dim PartCounter As Integer = 0
                Dim OffsetStart As Long
                Dim OffsetEnd As Long

                Dim MyUpload As New SprightlySoftAWS.S3.Upload
                Dim MyCalculateHash As New SprightlySoftAWS.S3.CalculateHash
                Dim MyMD5 As String


                Do
                    PartCounter += 1

                    'Get the byte range of the part to upload.
                    OffsetStart = (PartSize * PartCounter) - PartSize
                    OffsetEnd = (PartSize * PartCounter) - 1

                    If OffsetEnd >= MyFileInfo.Length Then
                        OffsetEnd = MyFileInfo.Length - 1
                    End If

                    'Exit if all of the file has been uploaded.
                    If OffsetStart > OffsetEnd Then
                        Exit Do
                    End If

                    'Check if the part has already been uploaded.
                    MyXmlNode = MyXmlDocument.SelectSingleNode("amz:ListPartsResult/amz:Part[amz:PartNumber='" & PartCounter & "']", MyXmlNamespaceManager)

                    If IsNothing(MyXmlNode) = True Then

                        'Upload Part: http://docs.amazonwebservices.com/AmazonS3/latest/API/mpUploadUploadPart.html

                        RequestMethod = "PUT"

                        ExtraRequestHeaders = New Dictionary(Of String, String)

                        QueryString = "?uploadId=" & System.Uri.EscapeDataString(TextBoxMultiUploadId.Text) & "&partNumber=" & PartCounter

                        RequestURL = MyUpload.BuildS3RequestURL(True, "s3.amazonaws.com", TextBoxMultiBucketName.Text, TextBoxMultiKeyName.Text, QueryString)

                        'Calculate the MD5 hash of the part that will be uploaded.
                        MyMD5 = MyCalculateHash.CalculateMD5FromFile(TextBoxMultiFileName.Text, OffsetStart, OffsetEnd)
                        ExtraRequestHeaders.Add("Content-MD5", MyMD5)

                        ExtraRequestHeaders.Add("x-amz-date", DateTime.UtcNow.ToString("r"))

                        AuthorizationValue = MyUpload.GetS3AuthorizationValue(RequestURL, RequestMethod, ExtraRequestHeaders, TextBoxAWSAccessKeyId.Text, TextBoxAWSSecretAccessKey.Text)
                        ExtraRequestHeaders.Add("Authorization", AuthorizationValue)

                        RetBool = MyUpload.UploadFile(RequestURL, RequestMethod, ExtraRequestHeaders, TextBoxMultiFileName.Text, OffsetStart, OffsetEnd)

                        Debug.Print("")
                        Debug.Print(MyUpload.LogData)
                        Debug.Print("")

                        If RetBool = False Then
                            Exit Do
                        End If

                    Else
                        'The part exists on S3, do not upload it.
                    End If

                Loop


                If RetBool = True Then
                    MessageBox.Show("Upload parts complete.", "Success", MessageBoxButtons.OK, MessageBoxIcon.Information)
                Else
                    Dim ResponseMessage As String
                    ResponseMessage = FormatLogData(MyUpload.RequestURL, MyUpload.RequestMethod, MyUpload.RequestHeaders, MyUpload.ResponseStatusCode, MyUpload.ResponseStatusDescription, MyUpload.ResponseHeaders, MyUpload.ResponseStringFormatted, MyUpload.ErrorNumber, MyUpload.ErrorDescription)

                    DialogOutput.Text = "Error"
                    DialogOutput.TextBoxOutput.Text = ResponseMessage
                    DialogOutput.ShowDialog(Me)

                End If

            Else
                Dim ResponseMessage As String
                ResponseMessage = FormatLogData(MyREST.RequestURL, MyREST.RequestMethod, MyREST.RequestHeaders, MyREST.ResponseStatusCode, MyREST.ResponseStatusDescription, MyREST.ResponseHeaders, MyREST.ResponseStringFormatted, MyREST.ErrorNumber, MyREST.ErrorDescription)

                DialogOutput.Text = "Error"
                DialogOutput.TextBoxOutput.Text = ResponseMessage
                DialogOutput.ShowDialog(Me)
            End If


        Else
            MessageBox.Show("Error, the local file does not exist.", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End If

        sender.Enabled = True
    End Sub

    Private Sub ButtonMultiListParts_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonMultiListParts.Click
        sender.Enabled = False

        'List Parts: http://docs.amazonwebservices.com/AmazonS3/latest/API/mpUploadListParts.html

        Dim MyREST As New SprightlySoftAWS.REST

        Dim QueryString As String
        QueryString = "?uploadId=" & System.Uri.EscapeDataString(TextBoxMultiUploadId.Text)

        Dim RequestURL As String
        RequestURL = MyREST.BuildS3RequestURL(True, "s3.amazonaws.com", TextBoxMultiBucketName.Text, TextBoxMultiKeyName.Text, QueryString)

        Dim RequestMethod As String = "GET"

        Dim ExtraRequestHeaders As New Dictionary(Of String, String)
        ExtraRequestHeaders.Add("x-amz-date", DateTime.UtcNow.ToString("r"))

        Dim AuthorizationValue As String
        AuthorizationValue = MyREST.GetS3AuthorizationValue(RequestURL, RequestMethod, ExtraRequestHeaders, TextBoxAWSAccessKeyId.Text, TextBoxAWSSecretAccessKey.Text)
        ExtraRequestHeaders.Add("Authorization", AuthorizationValue)

        Dim RetBool As Boolean
        RetBool = MyREST.MakeRequest(RequestURL, RequestMethod, ExtraRequestHeaders)

        Debug.Print("")
        Debug.Print(MyREST.LogData)
        Debug.Print("")

        If RetBool = True Then

            DialogOutput.Text = "Success"
            DialogOutput.TextBoxOutput.Text = MyREST.ResponseStringFormatted
            DialogOutput.ShowDialog(Me)

        Else
            Dim ResponseMessage As String
            ResponseMessage = FormatLogData(MyREST.RequestURL, MyREST.RequestMethod, MyREST.RequestHeaders, MyREST.ResponseStatusCode, MyREST.ResponseStatusDescription, MyREST.ResponseHeaders, MyREST.ResponseStringFormatted, MyREST.ErrorNumber, MyREST.ErrorDescription)

            DialogOutput.Text = "Error"
            DialogOutput.TextBoxOutput.Text = ResponseMessage
            DialogOutput.ShowDialog(Me)
        End If


        sender.Enabled = True
    End Sub

    Private Sub ButtonMultiCompleteUpload_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonMultiCompleteUpload.Click
        sender.Enabled = False

        'Start by listing the parts of the upload.  This information will be used to generate an XML document in the Complete Multipart Upload request.
        Dim MyREST As New SprightlySoftAWS.REST

        Dim QueryString As String
        QueryString = "?uploadId=" & System.Uri.EscapeDataString(TextBoxMultiUploadId.Text)

        Dim RequestURL As String
        RequestURL = MyREST.BuildS3RequestURL(True, "s3.amazonaws.com", TextBoxMultiBucketName.Text, TextBoxMultiKeyName.Text, QueryString)

        Dim RequestMethod As String = "GET"

        Dim ExtraRequestHeaders As New Dictionary(Of String, String)
        ExtraRequestHeaders.Add("x-amz-date", DateTime.UtcNow.ToString("r"))

        Dim AuthorizationValue As String
        AuthorizationValue = MyREST.GetS3AuthorizationValue(RequestURL, RequestMethod, ExtraRequestHeaders, TextBoxAWSAccessKeyId.Text, TextBoxAWSSecretAccessKey.Text)
        ExtraRequestHeaders.Add("Authorization", AuthorizationValue)

        Dim RetBool As Boolean
        RetBool = MyREST.MakeRequest(RequestURL, RequestMethod, ExtraRequestHeaders)

        Debug.Print("")
        Debug.Print(MyREST.LogData)
        Debug.Print("")

        If RetBool = True Then
            Dim MyXmlDocument As System.Xml.XmlDocument
            Dim MyXmlNamespaceManager As System.Xml.XmlNamespaceManager
            Dim MyXmlNode As System.Xml.XmlNode
            Dim MyXmlNodeList As System.Xml.XmlNodeList

            MyXmlDocument = New System.Xml.XmlDocument
            MyXmlDocument.LoadXml(MyREST.ResponseString)

            MyXmlNamespaceManager = New System.Xml.XmlNamespaceManager(MyXmlDocument.NameTable)
            MyXmlNamespaceManager.AddNamespace("amz", "http://s3.amazonaws.com/doc/2006-03-01/")

            MyXmlNodeList = MyXmlDocument.SelectNodes("amz:ListPartsResult/amz:Part", MyXmlNamespaceManager)


            'Complete Multipart Upload: http://docs.amazonwebservices.com/AmazonS3/latest/API/mpUploadComplete.html

            'Generate the XML document to send in the request.

            Dim PostXML As String = ""
            PostXML += "<CompleteMultipartUpload>" & vbCrLf

            For Each ItemXmlNode As System.Xml.XmlNode In MyXmlNodeList
                PostXML += "  <Part>" & vbCrLf

                MyXmlNode = ItemXmlNode.SelectSingleNode("amz:PartNumber", MyXmlNamespaceManager)
                PostXML += "    <PartNumber>" & MyXmlNode.InnerText & "</PartNumber>" & vbCrLf

                MyXmlNode = ItemXmlNode.SelectSingleNode("amz:ETag", MyXmlNamespaceManager)
                PostXML += "    <ETag>" & MyXmlNode.InnerText & "</ETag>" & vbCrLf

                PostXML += "  </Part>" & vbCrLf
            Next

            PostXML += "</CompleteMultipartUpload>" & vbCrLf


            QueryString = "?uploadId=" & System.Uri.EscapeDataString(TextBoxMultiUploadId.Text)

            RequestURL = MyREST.BuildS3RequestURL(True, "s3.amazonaws.com", TextBoxMultiBucketName.Text, TextBoxMultiKeyName.Text, QueryString)

            RequestMethod = "POST"

            ExtraRequestHeaders = New Dictionary(Of String, String)
            ExtraRequestHeaders.Add("x-amz-date", DateTime.UtcNow.ToString("r"))

            AuthorizationValue = MyREST.GetS3AuthorizationValue(RequestURL, RequestMethod, ExtraRequestHeaders, TextBoxAWSAccessKeyId.Text, TextBoxAWSSecretAccessKey.Text)
            ExtraRequestHeaders.Add("Authorization", AuthorizationValue)

            RetBool = MyREST.MakeRequest(RequestURL, RequestMethod, ExtraRequestHeaders, PostXML)

            Debug.Print("")
            Debug.Print(MyREST.LogData)
            Debug.Print("")

            If RetBool = True Then

                MyXmlDocument = New System.Xml.XmlDocument
                MyXmlDocument.LoadXml(MyREST.ResponseString)

                MyXmlNamespaceManager = New System.Xml.XmlNamespaceManager(MyXmlDocument.NameTable)
                MyXmlNamespaceManager.AddNamespace("amz", "http://s3.amazonaws.com/doc/2006-03-01/")

                If IsNothing(MyXmlDocument.SelectSingleNode("amz:Error", MyXmlNamespaceManager)) = True Then
                    MessageBox.Show("The multipart upload is complete.", "Success", MessageBoxButtons.OK, MessageBoxIcon.Information)
                Else
                    DialogOutput.Text = "Error"
                    DialogOutput.TextBoxOutput.Text = MyREST.ResponseStringFormatted
                    DialogOutput.ShowDialog(Me)
                End If

            Else
                Dim ResponseMessage As String
                ResponseMessage = FormatLogData(MyREST.RequestURL, MyREST.RequestMethod, MyREST.RequestHeaders, MyREST.ResponseStatusCode, MyREST.ResponseStatusDescription, MyREST.ResponseHeaders, MyREST.ResponseStringFormatted, MyREST.ErrorNumber, MyREST.ErrorDescription)

                DialogOutput.Text = "Error"
                DialogOutput.TextBoxOutput.Text = ResponseMessage
                DialogOutput.ShowDialog(Me)
            End If

        Else
            Dim ResponseMessage As String
            ResponseMessage = FormatLogData(MyREST.RequestURL, MyREST.RequestMethod, MyREST.RequestHeaders, MyREST.ResponseStatusCode, MyREST.ResponseStatusDescription, MyREST.ResponseHeaders, MyREST.ResponseStringFormatted, MyREST.ErrorNumber, MyREST.ErrorDescription)

            DialogOutput.Text = "Error"
            DialogOutput.TextBoxOutput.Text = ResponseMessage
            DialogOutput.ShowDialog(Me)
        End If

        sender.Enabled = True
    End Sub

    Private Sub ButtonMultiAbortUpload_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonMultiAbortUpload.Click
        sender.Enabled = False

        'Abort Multipart Upload: http://docs.amazonwebservices.com/AmazonS3/latest/API/mpUploadAbort.html

        Dim MyREST As New SprightlySoftAWS.REST

        Dim QueryString As String
        QueryString = "?uploadId=" & System.Uri.EscapeDataString(TextBoxMultiUploadId.Text)

        Dim RequestURL As String
        RequestURL = MyREST.BuildS3RequestURL(True, "s3.amazonaws.com", TextBoxMultiBucketName.Text, TextBoxMultiKeyName.Text, QueryString)

        Dim RequestMethod As String = "DELETE"

        Dim ExtraRequestHeaders As New Dictionary(Of String, String)
        ExtraRequestHeaders.Add("x-amz-date", DateTime.UtcNow.ToString("r"))

        Dim AuthorizationValue As String
        AuthorizationValue = MyREST.GetS3AuthorizationValue(RequestURL, RequestMethod, ExtraRequestHeaders, TextBoxAWSAccessKeyId.Text, TextBoxAWSSecretAccessKey.Text)
        ExtraRequestHeaders.Add("Authorization", AuthorizationValue)

        Dim RetBool As Boolean
        RetBool = MyREST.MakeRequest(RequestURL, RequestMethod, ExtraRequestHeaders, "")

        Debug.Print("")
        Debug.Print(MyREST.LogData)
        Debug.Print("")

        If RetBool = True Then
            MessageBox.Show("The multipart upload has been aborted.", "Success", MessageBoxButtons.OK, MessageBoxIcon.Information)
        Else
            Dim ResponseMessage As String
            ResponseMessage = FormatLogData(MyREST.RequestURL, MyREST.RequestMethod, MyREST.RequestHeaders, MyREST.ResponseStatusCode, MyREST.ResponseStatusDescription, MyREST.ResponseHeaders, MyREST.ResponseStringFormatted, MyREST.ErrorNumber, MyREST.ErrorDescription)

            DialogOutput.Text = "Error"
            DialogOutput.TextBoxOutput.Text = ResponseMessage
            DialogOutput.ShowDialog(Me)
        End If

        sender.Enabled = True
    End Sub

    Private Sub ButtonGetBucketWebsite_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonGetBucketWebsite.Click
        sender.Enabled = False

        'GET Bucket website: http://docs.amazonwebservices.com/AmazonS3/latest/API/RESTBucketGETwebsite.html

        Dim MyREST As New SprightlySoftAWS.REST

        Dim RequestURL As String
        RequestURL = MyREST.BuildS3RequestURL(True, "s3.amazonaws.com", TextBoxBucketBucketName.Text, "", "?website")

        Dim RequestMethod As String = "GET"

        Dim ExtraRequestHeaders As New Dictionary(Of String, String)
        ExtraRequestHeaders.Add("x-amz-date", DateTime.UtcNow.ToString("r"))

        Dim AuthorizationValue As String
        AuthorizationValue = MyREST.GetS3AuthorizationValue(RequestURL, RequestMethod, ExtraRequestHeaders, TextBoxAWSAccessKeyId.Text, TextBoxAWSSecretAccessKey.Text)
        ExtraRequestHeaders.Add("Authorization", AuthorizationValue)

        Dim RetBool As Boolean
        RetBool = MyREST.MakeRequest(RequestURL, RequestMethod, ExtraRequestHeaders, "")

        Debug.Print("")
        Debug.Print(MyREST.LogData)
        Debug.Print("")

        If RetBool = True Then
            DialogOutput.Text = "Success"
            DialogOutput.TextBoxOutput.Text = MyREST.ResponseStringFormatted
            DialogOutput.ShowDialog(Me)
        Else
            Dim ResponseMessage As String
            ResponseMessage = FormatLogData(MyREST.RequestURL, MyREST.RequestMethod, MyREST.RequestHeaders, MyREST.ResponseStatusCode, MyREST.ResponseStatusDescription, MyREST.ResponseHeaders, MyREST.ResponseStringFormatted, MyREST.ErrorNumber, MyREST.ErrorDescription)

            DialogOutput.Text = "Error"
            DialogOutput.TextBoxOutput.Text = ResponseMessage
            DialogOutput.ShowDialog(Me)
        End If

        sender.Enabled = True
    End Sub

    Private Sub ButtonSetBucketWebsite_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonSetBucketWebsite.Click
        sender.Enabled = False

        'PUT Bucket website: http://docs.amazonwebservices.com/AmazonS3/latest/API/RESTBucketPUTwebsite.html

        Dim Suffix As String
        Suffix = InputBox("Enter the index document for your directories.", "Index Document", "index.html")

        Dim PutXML As String = ""
        Dim RetBool As Boolean

        Dim MyREST As New SprightlySoftAWS.REST
        Dim RequestURL As String
        Dim RequestMethod As String = "PUT"
        Dim ExtraRequestHeaders As Dictionary(Of String, String)
        Dim AuthorizationValue As String

        RequestURL = MyREST.BuildS3RequestURL(True, "s3.amazonaws.com", TextBoxBucketBucketName.Text, "", "?website")

        ExtraRequestHeaders = New Dictionary(Of String, String)
        ExtraRequestHeaders.Add("x-amz-date", DateTime.UtcNow.ToString("r"))
        AuthorizationValue = MyREST.GetS3AuthorizationValue(RequestURL, RequestMethod, ExtraRequestHeaders, TextBoxAWSAccessKeyId.Text, TextBoxAWSSecretAccessKey.Text)
        ExtraRequestHeaders.Add("Authorization", AuthorizationValue)

        PutXML = ""
        PutXML = PutXML & "<?xml version=""1.0"" encoding=""UTF-8""?>"
        PutXML = PutXML & "<WebsiteConfiguration xmlns=""http://s3.amazonaws.com/doc/2006-03-01/"">"
        PutXML = PutXML & "<IndexDocument>"
        PutXML = PutXML & "<Suffix>" & Suffix & "</Suffix>"
        PutXML = PutXML & "</IndexDocument>"
        'Uncomment the following lines to set an error document.
        'PutXML = PutXML & "<ErrorDocument>"
        'PutXML = PutXML & "<Key>404.html</Key>"
        'PutXML = PutXML & "</ErrorDocument>"
        PutXML = PutXML & "</WebsiteConfiguration>"

        RetBool = MyREST.MakeRequest(RequestURL, RequestMethod, ExtraRequestHeaders, PutXML)

        Debug.Print("")
        Debug.Print(MyREST.LogData)
        Debug.Print("")

        If RetBool = True Then
            'Get the bucket location to generate a URL.
            Dim BucketEndpoint As String = ""

            RequestURL = MyREST.BuildS3RequestURL(True, "s3.amazonaws.com", TextBoxBucketBucketName.Text, "", "?location")
            RequestMethod = "GET"

            ExtraRequestHeaders = New Dictionary(Of String, String)
            ExtraRequestHeaders.Add("x-amz-date", DateTime.UtcNow.ToString("r"))

            AuthorizationValue = MyREST.GetS3AuthorizationValue(RequestURL, RequestMethod, ExtraRequestHeaders, TextBoxAWSAccessKeyId.Text, TextBoxAWSSecretAccessKey.Text)
            ExtraRequestHeaders.Add("Authorization", AuthorizationValue)

            RetBool = MyREST.MakeRequest(RequestURL, RequestMethod, ExtraRequestHeaders, "")

            If RetBool = True Then
                Dim XmlDoc As System.Xml.XmlDocument
                Dim MyXmlNamespaceManager As System.Xml.XmlNamespaceManager
                Dim XmlNode As System.Xml.XmlNode

                XmlDoc = New System.Xml.XmlDocument
                XmlDoc.LoadXml(MyREST.ResponseString)

                MyXmlNamespaceManager = New System.Xml.XmlNamespaceManager(XmlDoc.NameTable)
                MyXmlNamespaceManager.AddNamespace("amz", "http://s3.amazonaws.com/doc/2006-03-01/")

                XmlNode = XmlDoc.SelectSingleNode("/amz:LocationConstraint", MyXmlNamespaceManager)

                If XmlNode.InnerText = "EU" Then
                    BucketEndpoint = "s3-website-eu-west-1.amazonaws.com"
                ElseIf XmlNode.InnerText = "us-west-1" Then
                    BucketEndpoint = "s3-website-us-west-1.amazonaws.com"
                ElseIf XmlNode.InnerText = "ap-southeast-1" Then
                    BucketEndpoint = "s3-website-ap-southeast-1.amazonaws.com"
                ElseIf XmlNode.InnerText = "ap-northeast-1" Then
                    BucketEndpoint = "s3-website-ap-northeast-1.amazonaws.com"
                Else
                    BucketEndpoint = "s3-website-us-east-1.amazonaws.com"
                End If

            End If

            Debug.Print("http://" & TextBoxBucketBucketName.Text & "." & BucketEndpoint)
            MessageBox.Show("The index document has been set.  Test by going to http://" & TextBoxBucketBucketName.Text & "." & BucketEndpoint & ".  Make sure " & Suffix & " exists and is public.", "Success", MessageBoxButtons.OK, MessageBoxIcon.Information)
        Else
            Dim ResponseMessage As String
            ResponseMessage = FormatLogData(MyREST.RequestURL, MyREST.RequestMethod, MyREST.RequestHeaders, MyREST.ResponseStatusCode, MyREST.ResponseStatusDescription, MyREST.ResponseHeaders, MyREST.ResponseStringFormatted, MyREST.ErrorNumber, MyREST.ErrorDescription)

            DialogOutput.Text = "Error"
            DialogOutput.TextBoxOutput.Text = ResponseMessage
            DialogOutput.ShowDialog(Me)
        End If

        sender.Enabled = True
    End Sub

    Private Sub ButtonDeleteBucketWebsite_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonDeleteBucketWebsite.Click
        sender.Enabled = False

        'DELETE Bucket website: http://docs.amazonwebservices.com/AmazonS3/latest/API/RESTBucketDELETEwebsite.html

        Dim MyREST As New SprightlySoftAWS.REST

        Dim RequestURL As String
        RequestURL = MyREST.BuildS3RequestURL(True, "s3.amazonaws.com", TextBoxBucketBucketName.Text, "", "?website")

        Dim RequestMethod As String = "DELETE"

        Dim ExtraRequestHeaders As New Dictionary(Of String, String)
        ExtraRequestHeaders.Add("x-amz-date", DateTime.UtcNow.ToString("r"))

        Dim AuthorizationValue As String
        AuthorizationValue = MyREST.GetS3AuthorizationValue(RequestURL, RequestMethod, ExtraRequestHeaders, TextBoxAWSAccessKeyId.Text, TextBoxAWSSecretAccessKey.Text)
        ExtraRequestHeaders.Add("Authorization", AuthorizationValue)

        Dim RetBool As Boolean
        RetBool = MyREST.MakeRequest(RequestURL, RequestMethod, ExtraRequestHeaders, "")

        Debug.Print("")
        Debug.Print(MyREST.LogData)
        Debug.Print("")

        If RetBool = True Then
            MessageBox.Show("The website configuration was deleted.", "Success", MessageBoxButtons.OK, MessageBoxIcon.Information)
        Else

            Dim ResponseMessage As String
            ResponseMessage = FormatLogData(MyREST.RequestURL, MyREST.RequestMethod, MyREST.RequestHeaders, MyREST.ResponseStatusCode, MyREST.ResponseStatusDescription, MyREST.ResponseHeaders, MyREST.ResponseStringFormatted, MyREST.ErrorNumber, MyREST.ErrorDescription)

            DialogOutput.Text = "Error"
            DialogOutput.TextBoxOutput.Text = ResponseMessage
            DialogOutput.ShowDialog(Me)
        End If

        sender.Enabled = True
    End Sub

End Class
